# think of logic for single line rail
# need to remove mainline patches from station and create it from the loops only 
# and also for loops add another condition for checking if ml is common or up/down such that the corresponding loops 
# can be constructed from the center where common ml is

#import numpy as ny
#import pandas as pd
#import travconges as tv
import matplotlib.pyplot as plt
import csv
from matplotlib.collections import PatchCollection
import matplotlib
from Tkinter import *
import tkFileDialog
import os.path as op
import travconges as tv


plt.axes()
#stn=pd.read_csv('station.txt')
#loop=pd.read_csv('loop.txt')
#block=pd.read_csv('block.txt')
#root=Tk()
directory=tkFileDialog.askdirectory()
s=open(directory+"/station.txt") #reading from three files and store their values in lists

if op.exists(directory+"/TraversalDetails.txt"):
    lpdtls=tv.loopDetails(directory+"/TraversalDetails.txt")
    print lpdtls

def color(num):
  if op.exists(directory+"/TraversalDetails.txt"):
    if lpdtls.get(num)==None:
      return [0,0,0]
    else:
      a=lpdtls[num]
      return [a,0,1-a]
  else:
    return [0,0,0]

stn=csv.reader(s, delimiter = ' ')
stn.next()
stn.next()
stations=[r for r in stn]

b=open(directory+"/block.txt")
blk=csv.reader(b, delimiter = ' ')
blk.next()
blk.next()
blocks=[r for r in blk]

l=open(directory+"/loop.txt")
lp=csv.reader(l, delimiter = ' ')
lp.next()
lp.next()
loops=[r for r in lp]

#patches = []
plt.plot([0,0,0,0],[-5,-2,2,5])
uplpcnt=[]
dnlpcnt=[]
cmlpcnt=[]
#------------------------------------------------------------------------------------------------------------------------

class Station:    #class for all three components used to create patch of that element and store it in the patches[]
  def __init__(self,name,start,end):
    self.name=name
    self.start=start
    self.end=end
    self.ml="updn"
    uplpcnt.append(0)
    dnlpcnt.append(0)
    cmlpcnt.append(0)
    
class Block:    #needs to define functions which will generate patch wrt direction
  def __init__(self,num,direction,start,end,uplink,downlink):
    self.num=int(num)
    self.direction=direction
    self.start=start
    self.end=end
    self.uplink=uplink
    self.downlink=downlink
    self.index=int(num)/10000
    #self.count=(int(num)%1000)/10
    #self.speed=speed
    if self.direction=="up":
      plt.plot([self.start,self.end],[0.5,0.5], color= color(self.num))
      plt.plot([self.start,self.end],[0.5,0.5],'r|')
      plt.text((self.start+self.end)/2.0,0.6,self.num,fontsize='8')
    elif self.direction== "down":
      plt.plot([self.start,self.end],[-0.5,-0.5],'r|')
      plt.plot([self.start,self.end],[-0.5,-0.5],color= color(self.num))
      plt.text((self.start+self.end)/2.0,-0.4,self.num,fontsize='8')
    else: #common mainline
      if stnclass[self.index-1].ml=="common" or stnclass[self.index-1].end!=self.start:
        plt.plot([self.start,(self.end+self.start)/2.0],[0,0],color= color(self.num))
        plt.plot([self.start],[0],'r|')
      else:
        plt.plot([self.start,self.start+0.2,self.start],[0.5,0,-0.5],color= color(self.num))
        plt.plot([self.start+0.2,(self.end+self.start)/2.0],[0,0],color= color(self.num))
      if stnclass[self.index].ml=="common" or stnclass[self.index].start!=self.end:
        plt.plot([(self.end+self.start)/2.0,self.end],[0,0],color= color(self.num))
        plt.plot([self.end],[0],'r|')
      else:
        plt.plot([self.end,self.end-0.2,self.end],[0.5,0,-0.5],color= color(self.num))
        plt.plot([(self.start+self.end)/2.0,self.end-0.2],[0,0],color= color(self.num))
      plt.text((self.start+self.end)/2.0,0.1,self.num,fontsize='8')
    # print self.num

class Loop: #patch not constructed yet, need to define function by reading from station list for start and end points and also functions to construct patch according to diection and type of loops
  def __init__(self,num,direction,typ,uplink,downlink):
    self.num=int(num)
    self.direction=direction
    self.typ=typ
    self.ml="updn"
    self.uplink=uplink
    self.downlink=downlink
    '''
    LoopCd =self.num
    LpTypCd=(int(num)%10000)/10
    StnCd=int(num)/10000
    LpTypCnt=int(num)%10
    self.start=stnclass[StnCd-1].start
    self.end=stnclass[StnCd-1].end'''

  def PlotLoop(self):
    LoopCd =self.num
    LpTypCd=(int(LoopCd)%10000)/10
    StnCd=int(LoopCd)/10000
    LpTypCnt=int(LoopCd)%10
    self.start=stnclass[StnCd-1].start
    self.end=stnclass[StnCd-1].end
    #print StnCd , LpTypCd , LpTypCnt 
    p1 = self.start + (self.end - self.start)*0.2
    p2 = self.end - (self.end - self.start)*0.2
    if self.typ == "loop":
      if self.direction == "up":
        plt.plot([self.start,p1,p2,self.end],[0.5,((LpTypCnt)*0.5+0.5),((LpTypCnt)*0.5+0.5),0.5],color= color(self.num))
        uplpcnt[(StnCd)-1]=uplpcnt[(StnCd)-1]+1
        plt.text(((self.start+self.end)/2.0)-0.2,(LpTypCnt)*0.5+0.6,'0'+str(LpTypCd)+str(LpTypCnt),fontsize='8')
      elif self.direction == "down":
        plt.plot([self.start,p1,p2,self.end],[-0.5,0-((LpTypCnt)*0.5+0.5),0-((LpTypCnt)*0.5+0.5),-0.5],color= color(self.num))
        dnlpcnt[(StnCd)-1]=dnlpcnt[(StnCd)-1]+1
        plt.text(((self.start+self.end)/2.0)-0.2,(0-((LpTypCnt)*0.5+0.4)),str(LpTypCd)+str(LpTypCnt),fontsize='8')
      else: # common
        pass
    else: #mainline
      if self.typ == "ml" and self.direction== "common":
        self.ml="common"
        stnclass[StnCd-1].ml="common"
        plt.plot([self.start,self.end],[0,0],'ro')
        plt.plot([self.start,self.end],[0,0],color= color(self.num))
      else:
        plt.plot([self.start,self.end],[0.5,0.5],'ro')
        plt.plot([self.start,self.end],[-0.5,-0.5],'ro')
        plt.plot([self.start,self.end],[0.5,0.5],color= color(self.num))
        plt.plot([self.start,self.end],[-0.5,-0.5],color= color(self.num))

  def PlotCommonLoop(self):
    LoopCd =self.num
    LpTypCd=(int(LoopCd)%10000)/10
    StnCd=int(LoopCd)/10000
    LpTypCnt=int(LoopCd)%10
    self.start=stnclass[StnCd-1].start
    self.end=stnclass[StnCd-1].end
    self.ml=stnclass[StnCd-1].ml
    p1 = self.start + (self.end - self.start)*0.2
    p2 = self.end - (self.end - self.start)*0.2
   
    if self.ml== "common":
      cmlpcnt[StnCd-1]= cmlpcnt[StnCd-1] + 1
      plt.text(((self.start+self.end)/2.0)-0.2,(cmlpcnt[(StnCd)-1])*0.5+0.1,'C'+str(LpTypCd)+str(LpTypCnt),fontsize='8')
      plt.plot([self.start,p1,p2,self.end],[0,((cmlpcnt[StnCd-1])*0.5),((cmlpcnt[StnCd-1])*0.5),0],color= color(self.num))
    else:
      if LpTypCd == 220:  #common on up
        uplpcnt[(StnCd)-1]=uplpcnt[(StnCd)-1]+1
        plt.plot([self.start,p1,p2,self.end],[0.5,(uplpcnt[(StnCd)-1])*0.5+0.5,(uplpcnt[(StnCd)-1])*0.5+0.5,0.5],color= color(self.num))
        plt.text(((self.start+self.end)/2.0),(uplpcnt[(StnCd)-1])*0.5+0.6,'C'+str(LpTypCd)+str(LpTypCnt))
      elif LpTypCd == 230:  #common on down
        dnlpcnt[(StnCd)-1]=dnlpcnt[(StnCd)-1]+1
        plt.plot([self.start,p1,p2,self.end],[-0.5,0-((dnlpcnt[(StnCd)-1])*0.5+0.5),0-((dnlpcnt[(StnCd)-1])*0.5+0.5),-0.5],color= color(self.num))
        plt.text((self.start+self.end)/2.0,0-((dnlpcnt[(StnCd)-1])*0.5+0.4),'C'+str(LpTypCd)+str(LpTypCnt),fontsize='8')
      else: #common on middle
        plt.plot([self.start,p1,p2,self.end],[0.5,0,0,0.5],color= color(self.num))
        plt.plot([self.start,p1,p2,self.end],[-0.5,0,0,-0.5],color= color(self.num))
        plt.text(((self.start+self.end)/2.0)-0.2,0.1,'C'+str(LpTypCd)+str(LpTypCnt),fontsize='8')
#-------------------------------------------------------------------------------------------------------------------------
stationsCount=len(stations)
stnclass=[]
for i in range(0,stationsCount):    # reading all three file values and assigning their values to classes, need to store in list so that it can be read later by funtions to design patches
    t1=stations[i][1]
    t2=stations[i][2]
    temp=Station(stations[i][0],float(t1),float(t2))
    stnclass.append(temp)
    plt.text(temp.start,-1.5,temp.name+" ("+str(i+1)+")",rotation=330)
print "Found", stationsCount, "stations"

lpclass=[]
loopsCount=len(loops)
for i in range(0,loopsCount):
    temp1=Loop(loops[i][0],loops[i][1],loops[i][2],loops[i][6],loops[i][10])
    temp1.PlotLoop()
    lpclass.append(temp1)
    print(temp1.ml,temp1.num)
for i in range(0,loopsCount):
    if lpclass[i].direction == "common" and lpclass[i].typ=="loop":
      lpclass[i].PlotCommonLoop()

print "Found", loopsCount, "loops"

blkclass=[]
blocksCount=len(blocks)
for i in range(0,blocksCount):
    t1=blocks[i][2]
    t2=blocks[i][3]
    temp1=Block(blocks[i][0],blocks[i][1],float(t1),float(t2),blocks[i][5],blocks[i][9])
    blkclass.append(temp1)
print "Found", blocksCount, "blocks"

plt.axis('scaled')
plt.show()
