/*
 *  Note-  "single_" and "two_" and "three_" attached to variable and methods have specific meaning.
 *          Comparator Frame contain two Tab. 
 *          1. Single File Statistics. 
 *          2. Two File Comparison By Train.
 *          3. Two File Comparison By Station.
 *
 *           @All component name functionality attached to "single file comparison" tab starts with "single_".
 *           @All component name functionality attached to "two file comparison" tab starts with "two_".
 *           @All component name functionality attached to "three file comparison" tab starts with "three_".
 * 
 */
package comparator;

import static comparator.StationName.stationName;
import static comparator.TrainAndLoopNumberSorting.two_TrainList_File2;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.TreeSet;

import javax.imageio.ImageIO;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JRootPane;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.ScrollPaneConstants;

public class Comparator {
	/*
	 * @All components from comparator are declared here.
	 */
	/*
	 * @Declaring JFrame
	 */
	public JFrame comparatorFrame;
	/*
	 * @Declaring JPanel.
	 * 
	 * @Used four JPanel for each tab.
	 * 
	 */
	private JPanel singleFileComparision, twoFileComparison, threeFileComparison, help;
	/*
	 * @Declaring JTabbedPane.
	 */
	private JTabbedPane tp;
	/*
	 * @Declaring JButtons used in all tab like search,Compare
	 */
	private JButton single_FileButton, single_SearchButton, two_FileButton1, two_FileButton2, two_CompareButton,
			three_FileButton1, three_FileButton2, three_Compare;
	/*
	 * @Declaring JComboBox(Time and station) for all tab.
	 */
	public static JComboBox single_TimeComboBox, two_TimeComboBox, three_TimeComboBox;
	public static JComboBox two_TrainList, three_StationComboBox;
	public static JComboBox single_TrainAndStation;
	public static JCheckBox single_CheckBox, two_CheckBox, three_CheckBox;

	/*
	 * @Declaring JTextArea to show result of comparison.
	 */
	public static JTextArea single_TextArea, two_TextArea, help_TextArea, three_TextArea;
	/*
	 * @Declaring JLabels used in all comparator.
	 */
	private JLabel single_FilePathLabel, single_TimeComboBoxLabel, two_FilePath1Label, two_FilePath2Label,
			two_TimeComboBoxLabel, two_TrainListLabel, three_FilePath1Label, three_FilePath2Label,
			three_TimeComoboBoxLabel, three_StationComboBoxLabel, single_OpenBraketLabel, single_CloseBraketLabel;
	/*
	 * @Declaring String array for Time
	 */
	private String[] time = { " ", "0", "6", "10", "15", "20", "25", "30", "35", "40", "45", "50", "55" };
	/*
	 * @Declaring JScrollPane to add Scroll bar to JTextArea in all tab.
	 */
	private JScrollPane single_Scroll, two_scroll, three_Scroll;
	/*
	 * @Declaring ArrayList/TreeSet Which holds data line by line after reading file
	 * .
	 */
	public static ArrayList<String[]> single_ArrayListFile, two_ArrayListFile1, two_ArrayListFile2,
			three_ArrayListFile1, three_ArrayListFile2;
	public static TreeSet loopNumber;
	public static TreeSet trainNumber;

	/*
	 * @Declaring JRadioButton like arrival/departure and train/station.
	 */
	public static JRadioButton by_Departure, by_Arrival, by_Train, by_Station, three_Arrival, three_Departure,
			single_SearchRadioButton;
	/*
	 * @Declaring ButtonGroupe to add JRadioButton.
	 */
	private ButtonGroup two_group, single_group, three_group;
	/*
	 * @Declaring two_path and three_path variable to know file-1 browsing path of
	 * directory . Which helps to set directory for second file.
	 */
	private String two_path, three_path;
	public static String single_Path_For_Station_File = null, two_Path_For_Station_File = null,
			three_Path_For_Station_File = null, single_fileFeedback = "", two_fileFeedback = "",
			three_fileFeedback = "";

	/*
	 * @Constructor
	 */
	public Comparator() {
		super();
		this.addComponent();

		try {
			comparatorFrame.setIconImage(ImageIO.read(new File(System.getProperty("user.dir") + "/res/logo.png")));
		} catch (IOException exc) {
			// exc.printStackTrace();
		}

		new Help(); // Creating help class object
		/*
		 * @ Adding listener to single_FileButton present in "Single File Statistics"
		 * Tab window.
		 * 
		 * @After clicking single_FileButton it will read file and pass it to
		 * singleFilereading() method present in FileReading class.
		 */
		single_FileButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				single_TextArea.setText("");
				single_FilePathLabel.setText("Select File . . .");
				single_TimeComboBox.setEnabled(false);
				single_TimeComboBox.setSelectedIndex(0);
				single_CheckBox.setForeground(Color.BLACK);
				single_CheckBox.setText("Station Name");
				single_CheckBox.setSelected(false);
				by_Train.setEnabled(false);
				by_Station.setEnabled(false);
				single_TrainAndStation.removeAllItems();
				single_TrainAndStation.setEnabled(false);
				single_SearchRadioButton.setSelected(false);
				File selectedFile;
				JFileChooser fileChooser = new JFileChooser();
				int result = fileChooser.showOpenDialog(comparatorFrame);
				if (result == JFileChooser.APPROVE_OPTION) {
					selectedFile = fileChooser.getSelectedFile();
					single_FilePathLabel.setText(selectedFile.getAbsolutePath());
					single_Path_For_Station_File = selectedFile.getParent();

					single_CheckBox.setEnabled(true);
					single_TimeComboBox.setEnabled(true);
					single_TimeComboBox.setSelectedIndex(2);
					by_Train.setEnabled(true);
					by_Station.setEnabled(true);
					single_SearchRadioButton.setEnabled(true);

					new FileReading().singleFileReading(selectedFile);

				}
			}

		});

		by_Train.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				if (single_SearchRadioButton.isSelected()) {
					single_TrainAndStation.setEnabled(true);
					SingleResult.getSingleResult().trainOrStation();
				}
				if (!single_SearchRadioButton.isSelected()) {
					single_TrainAndStation.setEnabled(false);
					single_TrainAndStation.removeAllItems();
				}

			}
		});

		by_Station.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {

				if (single_SearchRadioButton.isSelected()) {
					single_TrainAndStation.setEnabled(true);
					SingleResult.getSingleResult().trainOrStation();
				}
				if (!single_SearchRadioButton.isSelected()) {
					single_TrainAndStation.setEnabled(false);
					single_TrainAndStation.removeAllItems();
				}

			}
		});

		single_SearchRadioButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				if (single_SearchRadioButton.isSelected()) {
					single_TrainAndStation.setEnabled(true);
					SingleResult.getSingleResult().trainOrStation();
				}
				if (!single_SearchRadioButton.isSelected()) {
					single_TrainAndStation.setEnabled(false);
					single_TrainAndStation.removeAllItems();
				}

			}
		});

		/*
		 * @single_CheckBox is Checkbox from Single File Statistic tab window.
		 * 
		 * @This is used to read station.txt file from which file-1 is selected when we
		 * select checkbox it will call findStationFile() method form StationName class.
		 */
		single_CheckBox.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {

				if (!(single_CheckBox.isSelected())) {
					single_CheckBox.setForeground(Color.BLACK);
					single_CheckBox.setText("Station Name");
					single_fileFeedback = " ";
					single_SearchRadioButton.setSelected(false);
					single_TrainAndStation.removeAllItems();
					single_TrainAndStation.setEnabled(false);
				}
				if (single_CheckBox.isSelected()) {
					single_TrainAndStation.removeAllItems();
					single_TrainAndStation.setEnabled(false);
					single_SearchRadioButton.setSelected(false);
					single_fileFeedback = new StationName().findStationFile(single_Path_For_Station_File, 1);
					// System.out.println("FeedBack in Comparator--"+feedback);
				}

			}
		});

		/*
		 * @two_CheckBox is Checkbox from Two File Comparison By Train tab window.
		 * 
		 * @This is used to read station.txt file from which file-1 is selected when we
		 * select checkbox it will call findStationFile() method form StationName class.
		 */
		two_CheckBox.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				if (!(two_CheckBox.isSelected())) {
					two_CheckBox.setForeground(Color.BLACK);
					two_CheckBox.setText("Station Name");
					two_fileFeedback = " ";
				}
				if (two_CheckBox.isSelected()) {
					two_fileFeedback = new StationName().findStationFile(two_Path_For_Station_File, 2);
					// System.out.println("FeedBack in Comparator--"+feedback);
				}

			}
		});

		/*
		 * @three_CheckBox is Checkbox from Two File Comparison By Station tab window.
		 * 
		 * @This is used to read station.txt file from which file-1 is selected when we
		 * select checkbox it will call findStationFile() method form StationName class.
		 */
		three_CheckBox.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				if (!(three_CheckBox.isSelected())) {
					three_CheckBox.setForeground(Color.BLACK);
					three_CheckBox.setText("Station Name");
					three_fileFeedback = " ";
				}
				if (three_CheckBox.isSelected()) {
					three_fileFeedback = new StationName().findStationFile(three_Path_For_Station_File, 3);
					// System.out.println("FeedBack in Comparator--"+feedback);
					if (three_fileFeedback.equals("FileFound")) {
						three_CheckBox.setEnabled(false);
					}
				}

			}
		});

		/*
		 * @ Adding listener to two_FileButton1 present in
		 * "Two File Comparison By Train" Tab window.
		 * 
		 * @After clicking two_FileButton1 it will read file-1 and pass it to
		 * twoFilereading() method from FileReading class
		 */

		two_FileButton1.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				two_TextArea.setText("");
				two_FilePath1Label.setText("Select File-1 . . .");
				two_FilePath2Label.setText("Select File-2 . . .");
				two_TimeComboBox.setEnabled(false);
				two_TrainList.setEnabled(false);
				two_TrainList.removeAllItems();
				by_Arrival.setEnabled(false);
				by_Departure.setEnabled(false);
				two_CheckBox.setForeground(Color.BLACK);
				two_CheckBox.setSelected(false);
				two_CheckBox.setEnabled(false);
				two_CheckBox.setText("Station Name");
				two_TimeComboBox.setSelectedIndex(0);
				File selectedFile;
				JFileChooser fileChooser = new JFileChooser();
				int result = fileChooser.showOpenDialog(comparatorFrame);
				if (result == JFileChooser.APPROVE_OPTION) {
					selectedFile = fileChooser.getSelectedFile();
					two_FilePath1Label.setText(selectedFile.getAbsolutePath());
					two_path = selectedFile.getParent();
					two_Path_For_Station_File = selectedFile.getParent();
					System.out.println("Inside Comparator/ File Size-->" + selectedFile.length());

					new FileReading().twoFileReading(selectedFile, 1);

				}

			}
		});

		/*
		 * @ Adding listener to two_FileButton2 present in
		 * "Two File Comparison By Train" Tab window.
		 * 
		 * @After clicking two_FileButton2 it will read file-2 and pass it to
		 * twoFilereading() method from FileReading class
		 */

		two_FileButton2.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				if (two_FilePath1Label.getText().equals("Select File-1 . . .")) {
					JOptionPane.showMessageDialog(comparatorFrame, "Select File-1 ");
				} else {
					two_CheckBox.setForeground(Color.BLACK);
					two_CheckBox.setSelected(false);
					two_CheckBox.setText("Station Name");

					File selectedFile;
					JFileChooser fileChooser = new JFileChooser(new File(two_path));
					int result = fileChooser.showOpenDialog(comparatorFrame);
					if (result == JFileChooser.APPROVE_OPTION) {
						selectedFile = fileChooser.getSelectedFile();
						two_FilePath2Label.setText(selectedFile.getAbsolutePath());
						two_TimeComboBox.setEnabled(true);
						two_TimeComboBox.setSelectedIndex(2);
						two_CheckBox.setEnabled(true);
						System.out.println("Inside Comparator/ File Size-->" + selectedFile.length());
						by_Arrival.setEnabled(true);
						by_Departure.setEnabled(true);

						new FileReading().twoFileReading(selectedFile, 2);

					}
				}

			}
		});

		/*
		 * @ Adding listener to three_FileButton1 present in
		 * "Two File Comparison By Station" Tab window.
		 * 
		 * @After clicking three_FileButton1 it will read file-1 and pass it to
		 * threeFilereading() method from FileReading class
		 */
		three_FileButton1.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {

				three_TextArea.setText("");
				three_FilePath1Label.setText("Select File-1 . . .");
				three_FilePath2Label.setText("Select File-2 . . .");
				three_TimeComboBox.setEnabled(false);
				three_TimeComboBox.setSelectedIndex(0);
				three_StationComboBox.setEnabled(false);
				three_StationComboBox.removeAllItems();
				three_Arrival.setEnabled(false);
				three_Departure.setEnabled(false);
				three_CheckBox.setForeground(Color.BLACK);
				three_CheckBox.setSelected(false);
				three_CheckBox.setText("Station Name");
				three_fileFeedback = "";

				File selectedFile;
				JFileChooser fileChooser = new JFileChooser();
				int result = fileChooser.showOpenDialog(comparatorFrame);
				if (result == JFileChooser.APPROVE_OPTION) {
					selectedFile = fileChooser.getSelectedFile();
					three_FilePath1Label.setText(selectedFile.getAbsolutePath());
					three_path = selectedFile.getParent();
					three_Path_For_Station_File = selectedFile.getParent();
					System.out.println("Inside Comparator/ File Size-->" + selectedFile.length());
					three_CheckBox.setEnabled(true);

					new FileReading().threeFileReading(selectedFile, 1);

				}

			}
		});

		/*
		 * @ Adding listener to three_FileButton2 present in
		 * "Two File Comparison By Station" Tab window.
		 * 
		 * @After clicking three_FileButton2 it will read file-2 and pass it to
		 * threeFilereading() method from FileReading class
		 */
		three_FileButton2.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				if (three_FilePath1Label.getText().equals("Select File-1 . . .")) {
					JOptionPane.showMessageDialog(comparatorFrame, "Select File-1 ");
				} else {

					File selectedFile;
					JFileChooser fileChooser = new JFileChooser(new File(three_path));
					int result = fileChooser.showOpenDialog(comparatorFrame);
					if (result == JFileChooser.APPROVE_OPTION) {
						selectedFile = fileChooser.getSelectedFile();
						three_FilePath2Label.setText(selectedFile.getAbsolutePath());
						three_TimeComboBox.setEnabled(true);
						three_TimeComboBox.setSelectedIndex(2);
						three_Arrival.setEnabled(true);
						three_Departure.setEnabled(true);

						if (three_fileFeedback.equals("FileNotFound")) {
							three_CheckBox.setForeground(Color.BLACK);
							three_CheckBox.setSelected(false);
							three_CheckBox.setText("Station Name");

						}
						three_CheckBox.setEnabled(false);
						new FileReading().threeFileReading(selectedFile, 2);

					}
				}

			}
		});

		/*
		 * 
		 */
		single_SearchButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {

				if (single_FilePathLabel.getText().equals("Select File . . .")) {
					JOptionPane.showMessageDialog(comparatorFrame, "Select File ");
				} else {

					if (by_Train.isSelected()) {

						if (!single_SearchRadioButton.isSelected()) {
							single_TextArea.setText("");
							new FileReading().single_Search_All_ByTrain();
						}
						if (single_SearchRadioButton.isSelected()) {

							if (!single_TrainAndStation.getSelectedItem().equals("Select Train . . .")) {
								single_TextArea.setText("");
								SingleResult.getSingleResult().singleSearchByTrain();// ---------*************-----------*********

							} else {
								JOptionPane.showMessageDialog(comparatorFrame, "Select Train For Search");
							}

						}

					}
					if (by_Station.isSelected()) {

						if (!single_SearchRadioButton.isSelected()) {
							single_TextArea.setText("");
							new FileReading().single_Search_All_ByStation();
						}
						if (single_SearchRadioButton.isSelected()) {

							if (!single_TrainAndStation.getSelectedItem().equals("Select Station . . .")) {
								single_TextArea.setText("");
								SingleResult.getSingleResult().singleSearchByStation();
							} else {
								JOptionPane.showMessageDialog(comparatorFrame, "Select Station For Search");
							}
						}

					}
				}
			}
		});

		two_CompareButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				if (two_FilePath1Label.getText().equals("Select File-1 . . .")) {
					JOptionPane.showMessageDialog(comparatorFrame, "Select File-1 ");
				} else {
					if (two_FilePath2Label.getText().equals("Select File-2 . . .")) {
						JOptionPane.showMessageDialog(comparatorFrame, "Select File-2 ");
					} else {
						if (two_TrainList_File2.contains(two_TrainList.getSelectedItem())) {
							two_TextArea.setText("");
							// JOptionPane.showMessageDialog(comparatorFrame, "Clear Text");

							if (by_Departure.isSelected()) {
								new FileReading().two_Compare_ByDeparture();
							}
							if (by_Arrival.isSelected()) {
								new FileReading().two_Compare_ByArrival();
							}
						} else {
							JOptionPane.showMessageDialog(comparatorFrame, "Train Not present in File-2");
						}

					}
				}

			}
		});

		three_Compare.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {

				if (three_FilePath1Label.getText().equals("Select File-1 . . .")) {
					JOptionPane.showMessageDialog(comparatorFrame, "Select File-1 ");
				} else {
					if (three_FilePath2Label.getText().equals("Select File-2 . . .")) {
						JOptionPane.showMessageDialog(comparatorFrame, "Select File-2 ");
					} else {
						String comboSelectedStation = (String) three_StationComboBox.getSelectedItem();
						if (three_CheckBox.isSelected()) {
							System.out.println("################## Inside if at Compare Button");
							for (Integer o : stationName.keySet()) {
								if (stationName.get(o).equals(three_StationComboBox.getSelectedItem())) {
									comboSelectedStation = o.toString();
									if (comboSelectedStation.length() == 1) {
										comboSelectedStation = "00" + comboSelectedStation;
										// System.out.println("After substring " + loop1);
									}
									if (comboSelectedStation.length() == 2) {
										comboSelectedStation = "0" + comboSelectedStation;
										// System.out.println("After substring " + loop1);
									}

									System.out.println("Final Key + Length--------->" + comboSelectedStation + "  / "
											+ comboSelectedStation.length());
									break;
								}
							}
						}
						if (TrainAndLoopNumberSorting.three_StationFile2.contains(comboSelectedStation)) {
							three_TextArea.setText("");
							// JOptionPane.showMessageDialog(comparatorFrame, "Clear Text");
							if (three_Arrival.isSelected()) {
								new FileReading().three_Compare(1);
							}
							if (three_Departure.isSelected()) {
								new FileReading().three_Compare(2);
							}

						} else {
							JOptionPane.showMessageDialog(comparatorFrame, "Station Not present in File-2");
						}

					}
				}

			}
		});

	}

	/*
	 * @Adding Component to Comparator Frame.
	 */
	void addComponent() {
		JFrame.setDefaultLookAndFeelDecorated(true);
	    JDialog.setDefaultLookAndFeelDecorated(true);
		comparatorFrame = new JFrame("Detailed Statistics and Comparator");

		/*
		 * @ Component present in Single File Comparison Tab.
		 */
		single_FileButton = new JButton("File");
		single_FilePathLabel = new JLabel("Select File . . .");
		single_FilePathLabel.setToolTipText("Specify file from where you wish to display statistics");
		single_CheckBox = new JCheckBox("Station Name");
		single_CheckBox.setToolTipText("It will pick station list (station.txt) from directory where you select file.");
		single_CheckBox.setEnabled(false);
		single_TimeComboBoxLabel = new JLabel("Halt Time Difference (in Minutes)");
		single_TimeComboBoxLabel
				.setToolTipText("Specify time in minutes above which you would like differences to be tabulated");
		single_SearchButton = new JButton("Search");
		single_TimeComboBox = new JComboBox(time);
		single_TimeComboBox.setEnabled(false);
		single_group = new ButtonGroup();
		by_Train = new JRadioButton("Trains", true);
		by_Train.setToolTipText("Select this if you want train wise list - all relevant stations");
		by_Train.setEnabled(false);
		by_Station = new JRadioButton("Stations");
		by_Station.setToolTipText("Select this if you want station wise list - all relevant trains");
		by_Station.setEnabled(false);
		single_group.add(by_Train);
		single_group.add(by_Station);
		single_SearchRadioButton = new JRadioButton("For Single Search");
		single_SearchRadioButton.setToolTipText("Select this if you want a single train or a single station");
		single_SearchRadioButton.setEnabled(false);
		single_OpenBraketLabel = new JLabel("(");
		single_OpenBraketLabel.setFont(single_OpenBraketLabel.getFont().deriveFont(35.0f)); // Increasing font size
		single_TrainAndStation = new JComboBox();
		single_TrainAndStation.setEnabled(false);
		single_CloseBraketLabel = new JLabel(")");
		single_CloseBraketLabel.setFont(single_CloseBraketLabel.getFont().deriveFont(35.0f)); // Increasing font size

		single_TextArea = new JTextArea();
		single_TextArea.setFont(single_TextArea.getFont().deriveFont(16f));
		single_Scroll = new JScrollPane(single_TextArea, ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
				ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);

		singleFileComparision = new JPanel();
		singleFileComparision.setLayout(null);
		singleFileComparision.add(single_FileButton);
		singleFileComparision.add(single_FilePathLabel);
		singleFileComparision.add(single_CheckBox);
		singleFileComparision.add(single_TimeComboBoxLabel);
		singleFileComparision.add(single_TimeComboBox);
		singleFileComparision.add(by_Station);
		singleFileComparision.add(by_Train);
		singleFileComparision.add(single_OpenBraketLabel);
		singleFileComparision.add(single_SearchRadioButton);
		singleFileComparision.add(single_TrainAndStation);
		singleFileComparision.add(single_CloseBraketLabel);
		singleFileComparision.add(single_SearchButton);
		singleFileComparision.add(single_Scroll);

		single_FileButton.setBounds(30, 30, 100, 40);
		single_FilePathLabel.setBounds(150, 30, 1000, 40);
		single_CheckBox.setBounds(1200, 30, 120, 40);
		single_TimeComboBoxLabel.setBounds(30, 130, 200, 40);
		single_TimeComboBox.setBounds(240, 136, 160, 30);
		by_Train.setBounds(440, 138, 100, 20);
		by_Station.setBounds(550, 138, 100, 20);
		single_OpenBraketLabel.setBounds(650, 120, 30, 50);
		single_SearchRadioButton.setBounds(660, 138, 140, 20);
		single_TrainAndStation.setBounds(802, 136, 160, 30);
		single_CloseBraketLabel.setBounds(975, 120, 30, 50);
		single_SearchButton.setBounds(1060, 130, 100, 40);
		single_Scroll.setBounds(30, 190, 1285, 450);

		/*
		 * @Component present in Two File Comparision Tab.
		 */
		two_FileButton1 = new JButton("File-1");
		two_FilePath1Label = new JLabel("Select File-1 . . .");
		two_FilePath1Label.setToolTipText("File-1 path");
		two_FileButton2 = new JButton("File-2");
		two_FilePath2Label = new JLabel("Select File-2 . . .");
		two_FilePath2Label.setToolTipText("File-2 path");
		two_CheckBox = new JCheckBox("Station Name");
		two_CheckBox
				.setToolTipText("It will pick station list (station.txt) from directory where you select first file.");

		two_CheckBox.setEnabled(false);
		two_TimeComboBoxLabel = new JLabel(" Time Difference (in Minutes)");
		two_TimeComboBoxLabel
				.setToolTipText("Specify time in minutes above which you would like differences to be tabulated");

		two_TimeComboBox = new JComboBox(time);
		two_TimeComboBox.setEnabled(false);
		two_TrainListLabel = new JLabel("Common Trains from both File");
		two_TrainListLabel.setToolTipText("Showing common trains in both file.");
		two_TrainList = new JComboBox<>();
		two_TrainList.setEnabled(false);
		two_CompareButton = new JButton("Compare");
		two_TextArea = new JTextArea();
		two_TextArea.setFont(two_TextArea.getFont().deriveFont(16f));
		two_scroll = new JScrollPane(two_TextArea, ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
				ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
		two_group = new ButtonGroup();
		by_Arrival = new JRadioButton("Arrival");
		by_Arrival.setToolTipText("Select this if you want to compare train by Arrival Time ");
		by_Arrival.setEnabled(false);
		by_Departure = new JRadioButton("Departure", true);
		by_Departure.setToolTipText("Select this if you want to compare train by Departure Time ");
		by_Departure.setEnabled(false);
		two_group.add(by_Arrival);
		two_group.add(by_Departure);

		twoFileComparison = new JPanel();
		twoFileComparison.setLayout(null);

		twoFileComparison.add(two_FileButton1);
		twoFileComparison.add(two_FilePath1Label);
		twoFileComparison.add(two_FileButton2);
		twoFileComparison.add(two_FilePath2Label);
		twoFileComparison.add(two_CheckBox);
		twoFileComparison.add(two_TimeComboBoxLabel);
		twoFileComparison.add(two_TimeComboBox);
		twoFileComparison.add(two_TrainListLabel);
		twoFileComparison.add(two_TrainList);
		twoFileComparison.add(two_CompareButton);
		twoFileComparison.add(two_scroll);
		twoFileComparison.add(by_Arrival);
		twoFileComparison.add(by_Departure);

		two_FileButton1.setBounds(30, 30, 100, 40);
		two_FilePath1Label.setBounds(150, 30, 500, 40);
		two_FileButton2.setBounds(700, 30, 100, 40);
		two_FilePath2Label.setBounds(820, 30, 300, 40);
		two_CheckBox.setBounds(1200, 30, 120, 40);
		two_TimeComboBoxLabel.setBounds(30, 130, 230, 40);
		two_TimeComboBox.setBounds(210, 136, 160, 30);
		two_TrainListLabel.setBounds(380, 130, 190, 40);
		two_TrainList.setBounds(580, 136, 160, 30);
		two_CompareButton.setBounds(1100, 130, 100, 40);
		two_scroll.setBounds(30, 190, 1285, 450);
		by_Arrival.setBounds(800, 138, 100, 20);
		by_Departure.setBounds(900, 138, 100, 20);

		three_FileButton1 = new JButton("File-1");
		three_FilePath1Label = new JLabel("Select File-1 . . .");
		three_FilePath1Label.setToolTipText("File-1 path");
		three_FileButton2 = new JButton("File-2");
		three_FilePath2Label = new JLabel("Select File-2 . . .");
		three_FilePath2Label.setToolTipText("File-2 path");
		three_CheckBox = new JCheckBox("Station Name");
		three_CheckBox
				.setToolTipText("It will pick station list (station.txt) from directory where you select first file.");

		three_CheckBox.setEnabled(false);
		three_TimeComoboBoxLabel = new JLabel("Time Difference (in Minutes)");
		three_TimeComoboBoxLabel
				.setToolTipText("Specify time in minutes above which you would like differences to be tabulated");
		three_TimeComboBox = new JComboBox<>(time);

		three_TimeComboBox.setEnabled(false);
		three_StationComboBoxLabel = new JLabel("Common Stations from both File");
		three_StationComboBoxLabel.setToolTipText("Showing common stations in both file");
		three_StationComboBox = new JComboBox<>();
		three_StationComboBox.setEnabled(false);
		three_Compare = new JButton("Compare");
		three_TextArea = new JTextArea();
		three_TextArea.setFont(three_TextArea.getFont().deriveFont(16f));
		three_Scroll = new JScrollPane(three_TextArea, ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
				ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
		three_group = new ButtonGroup();
		three_Arrival = new JRadioButton("Arrival");
		three_Arrival.setToolTipText("Select this if you want to compare station by Arrival Time ");
		three_Arrival.setEnabled(false);
		three_Departure = new JRadioButton("Departure", true);
		three_Departure.setToolTipText("Select this if you want to compare station by Departure Time ");
		three_Departure.setEnabled(false);
		three_group.add(three_Arrival);
		three_group.add(three_Departure);

		threeFileComparison = new JPanel();
		threeFileComparison.setLayout(null);

		threeFileComparison.add(three_FileButton1);
		threeFileComparison.add(three_FilePath1Label);
		threeFileComparison.add(three_FileButton2);
		threeFileComparison.add(three_FilePath2Label);
		threeFileComparison.add(three_CheckBox);
		threeFileComparison.add(three_TimeComoboBoxLabel);
		threeFileComparison.add(three_TimeComboBox);
		threeFileComparison.add(three_StationComboBoxLabel);
		threeFileComparison.add(three_StationComboBox);
		threeFileComparison.add(three_Compare);
		threeFileComparison.add(three_Scroll);
		threeFileComparison.add(three_Arrival);
		threeFileComparison.add(three_Departure);

		three_FileButton1.setBounds(30, 30, 100, 40);
		three_FilePath1Label.setBounds(150, 30, 500, +40);
		three_FileButton2.setBounds(700, 30, 100, 40);
		three_FilePath2Label.setBounds(820, 30, 300, 40);
		three_CheckBox.setBounds(1200, 30, 120, 40);
		three_TimeComoboBoxLabel.setBounds(30, 130, 230, 40);
		three_TimeComboBox.setBounds(210, 136, 160, 30);
		three_StationComboBoxLabel.setBounds(385, 130, 190, 40);
		three_StationComboBox.setBounds(580, 136, 160, 30);
		three_Compare.setBounds(1100, 130, 100, 40);
		three_Scroll.setBounds(30, 190, 1285, 450);
		three_Arrival.setBounds(800, 138, 100, 20);
		three_Departure.setBounds(900, 138, 100, 20);

		/*
		 * three_FileButton1.setBounds(30, 30, 100, 40);
		 * three_FilePath1Label.setBounds(150, 30, 500, 40);
		 * three_FileButton2.setBounds(700, 30, 100, 40);
		 * three_FilePath2Label.setBounds(820, 30, 500, 40);
		 * three_StationComboBoxLabel.setBounds(30, 150, 120, 40);
		 * three_StationComboBox.setBounds(150, 154, 180, 30);
		 * three_Compare.setBounds(400, 150, 100, 40); three_ScrollFile1.setBounds(30,
		 * 260, 610, 380); three_ScrollFile2.setBounds(690, 260, 610, 380);
		 * 
		 */
		help_TextArea = new JTextArea();
		help_TextArea.setEditable(false);
		help_TextArea.setBackground(new Color(255, 250, 250));
		help_TextArea.setBounds(10, 10, 1300, 630);

		help = new JPanel();
		help.setLayout(null);
		help.add(help_TextArea);
		tp = new JTabbedPane();
		tp.setBounds(10, 0, 1335, 680);
		tp.addTab("Single File Statistics", singleFileComparision);
		tp.addTab("Train-wise comparison", twoFileComparison);
		tp.addTab("Station-wise comparison", threeFileComparison);
		tp.addTab("Help", help);
		comparatorFrame.add(tp);
		comparatorFrame.setSize(1370, 730);
		comparatorFrame.setLayout(null);
		comparatorFrame.setVisible(true);

	}

	public static void main() {
		new Comparator();

	}

}
