/**
 * 
 */
package comparator;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

import javax.imageio.ImageIO;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRootPane;
import javax.swing.JTextField;
import javax.swing.filechooser.FileNameExtensionFilter;

/**
 * Title: Freight Traversal Time Comparison: Copyright: Copyright (c) 2002
 * Company: IIT
 * 
 * @author Abhishek
 *
 */
@SuppressWarnings("serial")
public class FreightComparison extends simulator.outputFeatures.MainInterface {
	private static JLabel select = new JLabel("Select Files");
	private static JLabel Worst = new JLabel("Longest Freight Traversal Time");
	private static JLabel TrainIndex = new JLabel("Longest Traversal Time");
	private static JLabel TrainIndex1 = new JLabel("Train Index");
	private static JLabel Average = new JLabel("Avg Freight Traversal Time");
	private static JLabel first10 = new JLabel("1 to 10");
	private static JLabel oneto20 = new JLabel("1 to 20");
	private static JLabel oneto30 = new JLabel("1 to 30");
	private static JLabel oneto40 = new JLabel("1 to 40");
	private static JLabel oneto50 = new JLabel("1 to 50");
	private static JLabel oneto60 = new JLabel("1 to 60");

	private static JButton file1 = new JButton("File 1");
	private static JLabel file1path = new JLabel("");
	private static JTextField w1 = new JTextField(25);
	private static JTextField index1 = new JTextField(25);
	private static JTextField a1 = new JTextField(25);
	private static JTextField f1 = new JTextField(25);
	private static JTextField e1 = new JTextField(25);
	private static JTextField tw1 = new JTextField(25);
	private static JTextField th1 = new JTextField(25);
	private static JTextField fo1 = new JTextField(25);
	private static JTextField fi1 = new JTextField(25);

	private static JButton file2 = new JButton("File 2");
	private static JLabel file2path = new JLabel("");
	private static JTextField w2 = new JTextField(25);
	private static JTextField index2 = new JTextField(25);
	private static JTextField a2 = new JTextField(25);
	private static JTextField f2 = new JTextField(25);
	private static JTextField e2 = new JTextField(25);
	private static JTextField tw2 = new JTextField(25);
	private static JTextField th2 = new JTextField(25);
	private static JTextField fo2 = new JTextField(25);
	private static JTextField fi2 = new JTextField(25);

	private static JButton CompareButton = new JButton("Compare");
	private static JButton Reset = new JButton("Reset");
	private static int check1 = 0;
	private static int check2 = 0;
	private static JPanel panel = new JPanel();

	private static File myfile = null;
	private static File myfile2 = null;
	private static File file1open = null;
	private static File file2open = null;
	private static String file1p = "";
	private static String file2p = "";
	private static File fdetails1 = null;
	private static File fdetails2 = null;
	private static int k = 0;
	private static int l = 0;

	public static void CompareActionPerformed() {
		JFrame.setDefaultLookAndFeelDecorated(true);
	    JDialog.setDefaultLookAndFeelDecorated(true);
		JFrame Compare = new JFrame("Freight Train Statistics/Comparator");
		Compare.setVisible(true);
		Compare.setBounds(20, 20, 1300, 350);


		try {
			Compare.setIconImage(ImageIO.read(new File(System.getProperty("user.dir") + "/res/logo.png")));
		} catch (IOException exc) {
			// exc.printStackTrace();
		}

		Compare.setDefaultCloseOperation(DISPOSE_ON_CLOSE);

		// panel.setSize(getMaximumSize());
		panel.setLayout(null);

		setComponents();
		addComponents();
		addActionListeners();
		fieldsUneditable();
		setInfoForLabels();

		Compare.add(panel);

	}

	private static void setInfoForLabels() {
		/**
		 * Show information when mouse hovered over the labels
		 */

		select.setToolTipText("Select Files to Compare");
		Worst.setToolTipText(
				"Worst Freight Path: Traversal time of the train taking the longest time in the selected file");
		TrainIndex.setToolTipText("Index of the train taking the longest time (last train in the selected file)");
		TrainIndex1.setToolTipText("Index of the train taking the longest time (last train in the selected file)");
		Average.setToolTipText("Average traversal time of all freight trains in the selected file");
		first10.setToolTipText(
				"Average traversal time of top 10 freight trains taking least time in the selected file");
		oneto20.setToolTipText(
				"Average traversal time of top 20 freight trains taking least time in the selected file");
		oneto30.setToolTipText(
				"Average traversal time of top 30 freight trains taking least time in the selected file");
		oneto40.setToolTipText(
				"Average traversal time of top 40 freight trains taking least time in the selected file");
		oneto50.setToolTipText(
				"Average traversal time of top 50 freight trains taking least time in the selected file");
		oneto60.setToolTipText(
				"Average traversal time of top 60 freight trains taking least time in the selected file");
		file1.setToolTipText("Choose File 1 for comparison");
		file2.setToolTipText("Choose File 2 for comparison");
		file1path.setToolTipText("Path of the selected file 1");
		file2path.setToolTipText("Path of the selected file 2");
	}

	private static void fieldsUneditable() {
		/**
		 * Set text fields uneditable by the user
		 */

		w1.setEditable(false);
		index1.setEditable(false);
		a1.setEditable(false);
		f1.setEditable(false);
		e1.setEditable(false);
		tw1.setEditable(false);
		th1.setEditable(false);
		fo1.setEditable(false);
		fi1.setEditable(false);

		w2.setEditable(false);
		index2.setEditable(false);
		a2.setEditable(false);
		f2.setEditable(false);
		e2.setEditable(false);
		tw2.setEditable(false);
		th2.setEditable(false);
		fo2.setEditable(false);
		fi2.setEditable(false);
	}

	private static void addActionListeners() {
		/**
		 * Add functions to the buttons
		 */

		file1.addActionListener(new OpenFile1());
		file2.addActionListener(new OpenFile2());
		CompareButton.addActionListener(new CompareAction());
		Reset.addActionListener(new ResetAction());
	}

	private static void addComponents() {
		/**
		 * Add all the buttons, labels, text-fields in the panel
		 */

		panel.add(select);
		panel.add(Worst);
		panel.add(TrainIndex);
		panel.add(TrainIndex1);
		panel.add(Average);
		panel.add(first10);
		panel.add(oneto20);
		panel.add(oneto30);
		panel.add(oneto40);
		panel.add(oneto50);
		panel.add(oneto60);
		panel.add(file1);
		panel.add(file1path);
		panel.add(w1);
		panel.add(index1);
		panel.add(a1);
		panel.add(f1);
		panel.add(e1);
		panel.add(tw1);
		panel.add(th1);
		panel.add(fo1);
		panel.add(fi1);
		panel.add(file2);
		panel.add(file2path);
		panel.add(w2);
		panel.add(index2);
		panel.add(a2);
		panel.add(f2);
		panel.add(e2);
		panel.add(tw2);
		panel.add(th2);
		panel.add(fo2);
		panel.add(fi2);
		panel.add(CompareButton);
		panel.add(Reset);

		panel.setVisible(true);
	}

	private static void setComponents() {
		/**
		 * Set the location of all buttons, labels and text-fields
		 */

		int xdiff = 170;
		int ydiff = 50;
		int x0 = 10;
		int y0 = 10;
		int x = x0;
		int y = y0;
		int fieldwidth = 70;
		int fieldheight = 25;

		select.setBounds(x, y, fieldwidth, fieldheight);
		x += xdiff;
		Worst.setBounds(x - 50, y, fieldwidth + 120, fieldheight);
		x += xdiff;
		TrainIndex.setBounds(x - 25, y, fieldwidth + 100, fieldheight);
		TrainIndex1.setBounds(x + 3, y + 20, fieldwidth + 100, fieldheight);
		x += xdiff;
		Average.setBounds(x - 40, y, fieldwidth + 100, fieldheight);
		x += xdiff + 15;
		first10.setBounds(x, y, fieldwidth, fieldheight);
		xdiff = 100;
		x += xdiff;
		oneto20.setBounds(x, y, fieldwidth, fieldheight);
		x += xdiff;
		oneto30.setBounds(x, y, fieldwidth, fieldheight);
		x += xdiff;
		oneto40.setBounds(x, y, fieldwidth, fieldheight);
		x += xdiff;
		oneto50.setBounds(x, y, fieldwidth, fieldheight);
		x += xdiff;
		oneto60.setBounds(x, y, fieldwidth, fieldheight);

		x = x0;
		xdiff = 170;
		y += ydiff;
		file1.setBounds(x, y, fieldwidth + 30, fieldheight);
		x += xdiff;
		w1.setBounds(x, y, fieldwidth, fieldheight);
		x += xdiff;
		index1.setBounds(x, y, fieldwidth, fieldheight);
		x += xdiff;
		a1.setBounds(x, 60, fieldwidth, fieldheight);
		x += xdiff;
		f1.setBounds(x, 60, fieldwidth, fieldheight);
		xdiff = 100;
		x += xdiff;
		e1.setBounds(x, 60, fieldwidth, fieldheight);
		x += xdiff;
		tw1.setBounds(x, 60, fieldwidth, fieldheight);
		x += xdiff;
		th1.setBounds(x, 60, fieldwidth, fieldheight);
		x += xdiff;
		fo1.setBounds(x, 60, fieldwidth, fieldheight);
		x += xdiff;
		fi1.setBounds(x, 60, fieldwidth, fieldheight);

		x = x0;
		xdiff = 170;
		y += ydiff;
		file1path.setBounds(x, y, fieldwidth * 10, fieldheight);

		y += ydiff;
		file2.setBounds(x, y, 100, fieldheight);
		x += xdiff;
		w2.setBounds(x, y, 80, fieldheight);
		x += xdiff;
		index2.setBounds(x, y, fieldwidth, fieldheight);
		x += xdiff;
		a2.setBounds(x, y, fieldwidth, fieldheight);
		x += xdiff;
		f2.setBounds(x, y, fieldwidth, fieldheight);
		xdiff = 100;
		x += xdiff;
		e2.setBounds(x, y, fieldwidth, fieldheight);
		x += xdiff;
		tw2.setBounds(x, y, fieldwidth, fieldheight);
		x += xdiff;
		th2.setBounds(x, y, fieldwidth, fieldheight);
		x += xdiff;
		fo2.setBounds(x, y, fieldwidth, fieldheight);
		x += xdiff;
		fi2.setBounds(x, y, fieldwidth, fieldheight);

		x = x0;
		y += ydiff;
		file2path.setBounds(x, y, fieldwidth * 10, fieldheight);

		y += ydiff;
		CompareButton.setBounds(400, y, fieldwidth + 30, fieldheight + 5);
		Reset.setBounds(650, y, fieldwidth + 30, fieldheight + 5);
	}

	static class OpenFile1 implements ActionListener {
		/**
		 * This method is called when "File 1" button is pressed
		 */

		@Override
		public void actionPerformed(ActionEvent e) {
			// System.out.println("File1");
			JFileChooser chooser = new JFileChooser();
			if (k == 0) {
				k = 1;
				chooser.setCurrentDirectory(fdetails2);
			} else {
				chooser.setCurrentDirectory(fdetails1);
			}
			chooser.setFileFilter(new FileNameExtensionFilter("freight-details.xls file", "xls"));
			int response = JFileChooser.CANCEL_OPTION;
			response = chooser.showOpenDialog(null);
			if (response == JFileChooser.APPROVE_OPTION) {
				k = 1;
				file1open = chooser.getSelectedFile();
				try {
					file1p = file1open.getAbsolutePath();
				} catch (Exception e1) {
					return;
				}

				file1path.setText(file1p);
				fdetails1 = chooser.getCurrentDirectory();
				myfile = new File(file1open.getPath());
			} else {
				chooser.setCurrentDirectory(fdetails2);
			}
		}
	}

	static class OpenFile2 implements ActionListener {
		/**
		 * This method is called when "File 1" button is pressed
		 */

		@Override
		public void actionPerformed(ActionEvent e) {
			// System.out.println("File2");
			JFileChooser chooser2 = new JFileChooser();
			if (l == 0) {
				l = 1;
				chooser2.setCurrentDirectory(fdetails1);
			} else {
				chooser2.setCurrentDirectory(fdetails2);
			}
			chooser2.setFileFilter(new FileNameExtensionFilter("freight-details.xls file", "xls"));
			int response = JFileChooser.CANCEL_OPTION;
			response = chooser2.showOpenDialog(null);
			if (response == JFileChooser.APPROVE_OPTION) {
				l = 1;
				file2open = chooser2.getSelectedFile();
				try {
					file2p = file2open.getAbsolutePath();
				} catch (Exception e1) {
					return;
				}
				file2path.setText(file2p);
				fdetails2 = chooser2.getCurrentDirectory();
				myfile2 = new File(file2open.getPath());
			} else {
				chooser2.setCurrentDirectory(fdetails1);
			}
		}
	}

	static class CompareAction implements ActionListener {
		/**
		 * This method is called when "Compare" button is pressed
		 */

		@Override
		public void actionPerformed(ActionEvent e) {
			System.out.println("Compare");
			String line = null;
			String line2 = null;
			Double sum = 0.0;
			Double sum2 = 0.0;
			List<String> TraversalTime = new ArrayList<>();
			List<String> TraversalTime2 = new ArrayList<>();

			int flag1 = 0;
			int flag2 = 0;
			int flag3 = 0;
			int flag4 = 0;
			int flag5 = 0;

			int flag21 = 0;
			int flag22 = 0;
			int flag23 = 0;
			int flag24 = 0;
			int flag25 = 0;

			try {
				BufferedReader in = new BufferedReader(new FileReader(myfile));
				while ((line = in.readLine()) != null) {
					String[] array = line.split("\t");
					try {
						TraversalTime.add(array[3]);
					} catch (Exception e1) {
						if (myfile != null) {
							JOptionPane.showMessageDialog(null, "Please Select freight-details.xls in File 1", "Error",
									JOptionPane.INFORMATION_MESSAGE);
							check1 = 1;
							resetAction();
						}
						break;
					}
				}
				if (myfile != null) {
					for (int i = 1; i < TraversalTime.size(); i++) {
						sum += Double.parseDouble(TraversalTime.get(i));
						if (i == 10) {
							flag1 = 1;
							f1.setText(new DecimalFormat("##.###").format(sum / i));
						} else if (i == 20) {
							flag2 = 1;
							e1.setText(new DecimalFormat("##.###").format(sum / i));
						} else if (i == 30) {
							flag3 = 1;
							tw1.setText(new DecimalFormat("##.###").format(sum / i));
						} else if (i == 40) {
							flag4 = 1;
							th1.setText(new DecimalFormat("##.###").format(sum / i));
						} else if (i == 50) {
							flag5 = 1;
							fo1.setText(new DecimalFormat("##.###").format(sum / i));
						} else if (i == 60) {
							fi1.setText(new DecimalFormat("##.###").format(sum / i));
						} else if (i == TraversalTime.size() - 1) {
							if (flag5 == 1) {
								fi1.setText(new DecimalFormat("##.###").format(sum / i));
							} else if (flag4 == 1) {
								fo1.setText(new DecimalFormat("##.###").format(sum / i));
							} else if (flag3 == 1) {
								th1.setText(new DecimalFormat("##.###").format(sum / i));
							} else if (flag2 == 1) {
								tw1.setText(new DecimalFormat("##.###").format(sum / i));
							} else if (flag1 == 1) {
								e1.setText(new DecimalFormat("##.###").format(sum / i));
							}
						}
					}
					a1.setText(new DecimalFormat("##.###").format(sum / (TraversalTime.size() - 1)));
					System.out.println(TraversalTime.get(TraversalTime.size() - 1));
					w1.setText(new DecimalFormat("##.###")
							.format(Double.parseDouble(TraversalTime.get(TraversalTime.size() - 1))));
					index1.setText(Integer.toString(TraversalTime.size() - 1));
				}
				in.close();
			} catch (Exception e1) {
				if (myfile != null && check1 == 0) {
					JOptionPane.showMessageDialog(null, "Please Select freight-details.xls in File 1", "Error",
							JOptionPane.INFORMATION_MESSAGE);
				}
			}

			try {
				BufferedReader in2 = new BufferedReader(new FileReader(myfile2));
				while ((line2 = in2.readLine()) != null) {
					String[] array = line2.split("\t");
					try {
						TraversalTime2.add(array[3]);
					} catch (Exception e1) {
						if (myfile2 != null) {
							JOptionPane.showMessageDialog(null, "Please Select freight-details.xls in File 2", "Error",
									JOptionPane.INFORMATION_MESSAGE);
							check2 = 1;
							resetAction();
						}
						break;
					}

				}
				if (myfile2 != null) {
					for (int i = 1; i < TraversalTime2.size(); i++) {
						sum2 += Double.parseDouble(TraversalTime2.get(i));
						if (i == 10) {
							flag21 = 1;
							f2.setText(new DecimalFormat("##.###").format(sum2 / i));
						} else if (i == 20) {
							flag22 = 1;
							e2.setText(new DecimalFormat("##.###").format(sum2 / i));
						} else if (i == 30) {
							flag23 = 1;
							tw2.setText(new DecimalFormat("##.###").format(sum2 / i));
						} else if (i == 40) {
							flag24 = 1;
							th2.setText(new DecimalFormat("##.###").format(sum2 / i));
						} else if (i == 50) {
							flag25 = 1;
							fo2.setText(new DecimalFormat("##.###").format(sum2 / i));
						} else if (i == 60) {
							fi2.setText(new DecimalFormat("##.###").format(sum2 / i));
						} else if (i == TraversalTime2.size() - 1) {
							if (flag25 == 1) {
								fi2.setText(new DecimalFormat("##.###").format(sum2 / i));
							} else if (flag24 == 1) {
								fo2.setText(new DecimalFormat("##.###").format(sum2 / i));
							} else if (flag23 == 1) {
								th2.setText(new DecimalFormat("##.###").format(sum2 / i));
							} else if (flag22 == 1) {
								tw2.setText(new DecimalFormat("##.###").format(sum2 / i));
							} else if (flag21 == 1) {
								e2.setText(new DecimalFormat("##.###").format(sum2 / i));
							}
						}
					}
					a2.setText(new DecimalFormat("##.###").format(sum2 / (TraversalTime2.size() - 1)));
					System.out.println(TraversalTime2.get(TraversalTime2.size() - 1));
					w2.setText(new DecimalFormat("##.###")
							.format(Double.parseDouble(TraversalTime2.get(TraversalTime2.size() - 1))));
					index2.setText(Integer.toString(TraversalTime2.size() - 1));
				}
				in2.close();
			} catch (Exception e1) {
				if (myfile2 != null && check2 == 0) {
					JOptionPane.showMessageDialog(null, "Please Select freight-details.xls in File 2", "Error",
							JOptionPane.INFORMATION_MESSAGE);
				}
			}
		}
	}

	public static void resetAction() {
		/**
		 * This method is called when "Reset" button is pressed. It clears all the
		 * text-fields and file-paths, and reset all variables
		 * 
		 */

		System.out.println("Reset");
		myfile = null;
		myfile2 = null;
		file1open = null;
		file2open = null;
		file1p = "";
		file2p = "";
		fdetails1 = null;
		fdetails2 = null;
		file1path.setText("");
		w1.setText("");
		index1.setText("");
		a1.setText("");
		f1.setText("");
		e1.setText("");
		tw1.setText("");
		th1.setText("");
		fo1.setText("");
		fi1.setText("");
		file2path.setText("");
		w2.setText("");
		index2.setText("");
		a2.setText("");
		f2.setText("");
		e2.setText("");
		tw2.setText("");
		th2.setText("");
		fo2.setText("");
		fi2.setText("");
		k = 0;
		l = 0;
		check1 = 0;
		check2 = 0;
	}

	static class ResetAction implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			resetAction();
		}
	}

	public static void main(ActionEvent e) {
		CompareActionPerformed();
	}
}
