package gui.entities.sectionEntities.trackProperties;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;

import globalVariables.FileNames;
import globalVariables.GlobalVar;
import gui.entities.sectionEntities.Entity;
import gui.entities.sectionEntityList.GradientEffectList;
import simulator.util.Debug;

public class GradientEffect extends Entity {

	static GradientEffectList gradientEffectUpArray = new GradientEffectList();
	static GradientEffectList gradientEffectDownArray = new GradientEffectList();

	/**
	 * gradientValue
	 */
	public String gradientValue;

	public int direction;
	/**
	 * accelerationChange
	 */
	public double accelerationChange;
	/**
	 * decelerationChange
	 */
	public double decelerationChange;

	/**
	 * @param a
	 * @param c
	 * @param d
	 */
	public GradientEffect(String a, double c, double d) {
		setGradientValue(a);
		setAccelerationChange(c);
		setDecelerationChange(d);
	}

	public GradientEffect() {
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param Up_gray
	 * @param Down_gray
	 * @throws IOException
	 */
	@SuppressWarnings({ "static-access" })
	public static void readEffect() throws IOException {

		GradientEffectList upSideGradientEffects = new GradientEffectList();
		GradientEffectList downSideGradientEffects = new GradientEffectList();

		Debug.print("GradientEffect: readEffect: I am in gradient_effect");
		BufferedReader r = new BufferedReader(new FileReader(FileNames.getGradientEffectsFileName()));
		GradientEffect grad_eff;
		int upDirection = GlobalVar.UP_DIRECTION;
		int downDirection = GlobalVar.DOWN_DIRECTION;
		Debug.GradientDebug("Up direction corresponds to: " + upDirection + " and Down direction corresponds to: " + downDirection, true);
		String line = null;
		int flag = 0;
		try {
			while ((line = r.readLine()) != null) {
				if (line.contains("/*"))
					flag = 1;
				if (flag == 0) {
					String[] array = line.split(" ");
					array[0] = array[0].split("\"")[1];
					//System.out.println("Line read is: " + array[0] + " " + array[1] + " " + array[2] + " " + array[3]);
					Debug.GradientDebug("Line read is: " + array[0] + " " + array[1] + " " + array[2] + " " + array[3] + ";", true);
					double acceleration_change, deceleration_change;
					String value = "0";
					int direction = 2;

					value = array[0];
					//System.out.println("Value read is: " + value);
					Debug.GradientDebug("Value read is: " + value + ";", false);

					direction = Integer.valueOf(array[1]);
					//System.out.println("Direction read is: " + direction);
					Debug.GradientDebug("Direction read is: " + direction + ";", false);
					Debug.print("GradientEffect: readEffect: DIRECTION IS " + direction);

					acceleration_change = Double.valueOf(array[2]);
					//System.out.println("Acceleration change read is: " + acceleration_change);
					Debug.GradientDebug("Acceleration change read is: " + acceleration_change + ";", false);

					deceleration_change = Double.valueOf(array[3]);
					//System.out.println("Deceleration change read is: " + deceleration_change);
					Debug.GradientDebug("Deceleration change read is: " + deceleration_change + ";", false);

					if (direction == upDirection) {
						grad_eff = new GradientEffect(value, acceleration_change, deceleration_change);
						upSideGradientEffects.add(grad_eff);
						Debug.GradientDebug("Up Gradient added: " + grad_eff.gradientValue + "_"
								+ grad_eff.accelerationChange + "_" + grad_eff.decelerationChange + ";", false);
						/*System.out.println("Up Gradient added: " + grad_eff.gradientValue + "_"
								+ grad_eff.accelerationChange + "_" + grad_eff.decelerationChange);*/
						Debug.print("GradientEffect: readEffect: adding Up");
					}
					if (direction == downDirection) {
						grad_eff = new GradientEffect(value, acceleration_change, deceleration_change);
						downSideGradientEffects.add(grad_eff);
						Debug.GradientDebug("Down Gradient added: " + grad_eff.gradientValue + "_"
								+ grad_eff.accelerationChange + "_" + grad_eff.decelerationChange + ";", false);
						/*System.out.println("Down Gradient added: " + grad_eff.gradientValue + "_"
								+ grad_eff.accelerationChange + "_" + grad_eff.decelerationChange);*/
						Debug.print("GradientEffect: readEffect: adding down");
					}
				} else if (line.contains("*/"))
					flag = 0;
			}
		} catch (IOException e) {
			Debug.print("GradientEffect: readEffect: File Not Found");
		}

		GradientEffect.gradientEffectUpArray = upSideGradientEffects;
		GradientEffect.gradientEffectDownArray = downSideGradientEffects;
		r.close();
	}

	/**
	 * @param gradientValue
	 * @return acceleration
	 */
	public static double returnAcceleration(String gradientValue, int direction) {
		ArrayList<GradientEffect> gradientEffects = getGradientEffectsFromDirection(direction);
		double acc = 0;
		if (gradientEffects == null)
			return acc;

		String temp;
		Debug.print(
				"GradientEffect: returnAcceleration: In return acceleration " + "function of gradientList effects  ");
		for (int i = 0; i < gradientEffects.size(); i++) {
			temp = gradientEffects.get(i).getGradientValue();
			if (gradientValue.equalsIgnoreCase(temp)) {
				acc = (gradientEffects.get(i).getAccelerationChange());
			}
		}
		Debug.print("GradientEffect: returnAcceleration: returning " + acc);
		/*
		 * Debug.GradientDebug(
		 * "GradientEffect: returnAcceleration: In return acceleration function of gradientList effects: returning "
		 * + acc);
		 */
		return acc;
	}

	/**
	 * @param gradientValue
	 * @return deceleration
	 */
	public static double returnDeceleration(String gradientValue, int direction) {
		ArrayList<GradientEffect> gradientEffects = getGradientEffectsFromDirection(direction);
		double dec = 0;
		String temp;
		Debug.print(
				"GradientEffect: returnDeceleration: In return acceleration function" + " of gradientList effect up  ");
		for (int i = 0; i < gradientEffects.size(); i++) {
			temp = gradientEffects.get(i).getGradientValue();
			if (gradientValue.equalsIgnoreCase(temp)) {
				dec = (gradientEffects.get(i).getDecelerationChange());
			}
		}
		Debug.print(" returning " + dec);
		/*
		 * Debug.GradientDebug(
		 * "GradientEffect: returnDeceleration: In return deceleration function of gradientList effects: returning "
		 * + dec);
		 */
		return dec;
	}

	private static ArrayList<GradientEffect> getGradientEffectsFromDirection(int direction) {
		if (direction == GlobalVar.UP_DIRECTION)
			return gradientEffectUpArray;
		else if (direction == GlobalVar.DOWN_DIRECTION)
			return gradientEffectDownArray;
		else
			return null;
	}

	/**
	 * @param gradientEffect
	 */
	public void add(GradientEffect gradientEffect) {
		Debug.print("I am in add gradientList EFFECT");
		int direction = gradientEffect.getDirection();
		ArrayList<GradientEffect> gradientEffects = getGradientEffectsFromDirection(direction);
		gradientEffects.add(gradientEffect);
	}

	@Override
	public boolean hasError() {
		// TODO Auto-generated method stub
		return false;
	}

	public String getGradientValue() {
		return gradientValue;
	}

	public void setGradientValue(String gradientValue) {
		this.gradientValue = gradientValue;
	}

	public int getDirection() {
		return direction;
	}

	public void setDirection(int direction) {
		this.direction = direction;
	}

	public double getAccelerationChange() {
		return accelerationChange;
	}

	public void setAccelerationChange(double accelerationChange) {
		this.accelerationChange = accelerationChange;
	}

	public double getDecelerationChange() {
		return decelerationChange;
	}

	public void setDecelerationChange(double decelerationChange) {
		this.decelerationChange = decelerationChange;
	}

}
