package input;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.StreamTokenizer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import javax.imageio.ImageIO;
import javax.swing.ButtonGroup;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.AbstractTableModel;

import files.MultipleSpeedRestriction;
import globalVariables.FileNames;
import globalVariables.GlobalVar;
import gui.entities.sectionEntities.Station;
import gui.entities.sectionEntities.trackEntities.Block;
import gui.entities.sectionEntities.trackEntities.Link;
import gui.entities.sectionEntities.trackEntities.Loop;
import gui.entities.sectionEntities.trackProperties.SpeedRestriction;

public class BlockInput extends InputDialog {

	private static final long serialVersionUID = 1L;
	public JLabel stationinfoLabel = new JLabel("Please enter the initial station for inserting block section");
	public static JComboBox stationno = new JComboBox();
	String[] stationNames = null;
	String[] nextstationNames = null;
	public static JComboBox NumberofLines = new JComboBox();
	Integer[] LinesList = { 1, 2, 3};
	public static JLabel NumberofLinesLabel = new JLabel("Number of Lines");
	public JButton ViewAllBlockButton = new JButton("View All ");

	public JLabel succedingno = new JLabel();
	public JButton DoneButton = new JButton("Done");
	public static JLabel resultLabel = new JLabel("");

	public static JRadioButton CommonBlockButton = new JRadioButton("Bidirectional Section");

	// public JRadioButton UpDownBlockButton = new JRadioButton("Double Line");

	// sneha:earlier radio button group was having one of two possible selection
	// Bidirectional and Double Line
	// Now it have Bidirectional , up block and down block
	public static JRadioButton UpBlockButton = new JRadioButton("Up Block Section");
	public static JRadioButton DownBlockButton = new JRadioButton("Down Block Section");

	public ButtonGroup BlockTypeButtonGroup = new ButtonGroup();
	public JLabel BlockTypeLabel = new JLabel("Please choose block section type");
	public static String StationName;
	public static String NextStationName;
	static JPanel jpanel = new JPanel();
	public int mesut, ozil;
	public static JButton editBlock = new JButton("Edit Blocks");
	public static ArrayList<JLabel> LineNumberLabelList = new ArrayList<JLabel>();
	public static JLabel LineNumberLabel = new JLabel();
	public static ArrayList<JButton> LineNumberButtonList = new ArrayList<JButton>();
	public static JButton LineNumberButton = new JButton();
	int YMarker = 0;
	public static int LineNumber = -1;

	public BlockInput() {
		x = 30;
		y = 30;
		width = 450;
		height = 630;

		NumberofLines = new JComboBox<Integer>(LinesList);
		SectionInputDialog sectioninputdialog = GlobalVar.getSectionInputDialog();
		stationNames = sectioninputdialog.getStationNames();

		if (stationNames.length > 0) {
			String[] l = Arrays.copyOf(stationNames, stationNames.length - 1);

			stationno = new JComboBox<String>(l);
		}
		nextstationNames = sectioninputdialog.getStationNames();


		// cards = new JPanel(new CardLayout());

		this.setBounds(x, y, width, height);
		jpanel.setBounds(x, y, width, height);
		setComponentActionListeners();
		setComponentBounds();
		addComponents();

		this.add(jpanel);
		jpanel.setLayout(null);
		this.setTitle("Lines/Block Section Input");

		try {
			this.setIconImage(ImageIO.read(new File(System.getProperty("user.dir") + "/res/logo.png")));
		} catch (IOException exc) {
			// exc.printStackTrace();
		}

		addWindowListener(new java.awt.event.WindowAdapter() {
			@Override
			public void windowClosing(java.awt.event.WindowEvent windowEvent) {
				jpanel.removeAll();
				GlobalVar.BlockInputNewWindowObject = null;
				jpanel.removeAll();
				GlobalVar.blockInput = null;
		    }
		});
	}

	// sneha : this method updates the station names in blockinput stationno
	// Jcombobox.
	// called from add station action listner whenever new station is added.
	@SuppressWarnings("unchecked")
	public void updateStationNames() {
		SectionInputDialog sectioninputdialog = GlobalVar.getSectionInputDialog();
		stationno.setEnabled(false);

		stationNames = sectioninputdialog.getStationNames();
		if (stationNames.length > 0) {
			String[] l = Arrays.copyOf(stationNames, stationNames.length - 1);
			@SuppressWarnings("rawtypes")
			DefaultComboBoxModel model = (DefaultComboBoxModel) stationno.getModel();
			model.removeAllElements();
			for (int i = 0; i < l.length; i++) {
				model.addElement(l[i]);
			}
			stationno.setModel(model);
			nextstationNames = sectioninputdialog.getStationNames();
		}
		stationno.setEnabled(true);
	}

	@Override
	public void addComponents() {
		jpanel.add(stationno);
		jpanel.add(stationinfoLabel);
		jpanel.add(succedingno);
		jpanel.add(resultLabel);

		jpanel.add(BlockTypeLabel);
		jpanel.add(CommonBlockButton);
		jpanel.add(ViewAllBlockButton);
		ViewAllBlockButton.setVisible(true);
		jpanel.add(NumberofLines);
		jpanel.add(NumberofLinesLabel);
		NumberofLinesLabel.setVisible(false);
		NumberofLines.setVisible(false);
		// this.add(UpDownBlockButton);

		BlockTypeButtonGroup.add(CommonBlockButton);
		// BlockTypeButtonGroup.add(UpDownBlockButton);

		// sneha : added folowwing two button
		jpanel.add(UpBlockButton);
		jpanel.add(DownBlockButton);
		BlockTypeButtonGroup.add(UpBlockButton);
		BlockTypeButtonGroup.add(DownBlockButton);
		UpBlockButton.setVisible(false);
		DownBlockButton.setVisible(false);
		CommonBlockButton.setVisible(false);
		jpanel.add(DoneButton);
		DoneButton.setVisible(true);
		BlockTypeLabel.setVisible(false);
		ViewAllBlockButton.setVisible(true);
		jpanel.add(editBlock);
		editBlock.setVisible(false);
	};

	@Override
	public void setComponentBounds() {
		x = 10;
		y = 100;
		width = 800;
		height = 800;

		int yDifference = 25;
		labelWidth += 80;
		x2 += 40;
		fieldWidth = 2 * fieldWidth / 5;

		y1 += yDifference;
		stationinfoLabel.setBounds(x1 + 10, y1, 3 * labelWidth, labelHeight);

		y1 += 2 * yDifference;
		stationno.setBounds(x1 + 10, y1, 5 * fieldWidth / 2, fieldHeight);
		succedingno.setBounds(x1 + x2 - 10, y1, 2 * labelWidth, labelHeight);

		y1 += 2 * yDifference;
		BlockTypeLabel.setBounds(x1 + 10, y1, 3 * labelWidth, labelHeight);

		y1 += yDifference;

		// UpDownBlockButton.setBounds(x1 + (x2 / 2) , y1, labelWidth,
		// labelHeight);
		CommonBlockButton.setBounds(x1 + 10, y1, labelWidth, labelHeight);
		y1 += yDifference;
		UpBlockButton.setBounds(x1 + 10, y1, labelWidth, labelHeight);
		y1 += yDifference;
		DownBlockButton.setBounds(x1 + 10, y1, labelWidth, labelHeight);

		y1 += 2 * yDifference;
		NumberofLinesLabel.setBounds(x1 + 10, y1, labelWidth, labelHeight);
		
		y1 += yDifference;
		NumberofLines.setBounds(x1 + 30, y1, fieldWidth, fieldHeight);
		YMarker = y1 + yDifference + 20;
		y1 += 8 * yDifference;
		editBlock.setBounds(8 * x1 + 10, y1, labelWidth / 2, labelHeight);
		ViewAllBlockButton.setBounds(x1 + 10, y1, labelWidth / 2, labelHeight);
		DoneButton.setBounds(15 * x1 + 10, y1, 2 * labelWidth / 5, labelHeight);
		y1 += 2 * yDifference;
		resultLabel.setBounds(x1, y1, labelWidth * 2, labelHeight);

	};

	@Override
	public void setComponentActionListeners() {
		stationno.addActionListener(stationnoActionListener);

		/*
		 * CommonBlockButton.addItemListener(BlockTypeItemListener);
		 * UpDownBlockButton.addItemListener(BlockTypeItemListener);
		 */

		// Sneha:implemented new BLOCKTypeIntemListener_new()
		// older implementation of BlockTypeIntemListener was
		// updating the panel based on two radio button mainly CommonBlockButton
		// and UpDownBlockButton
		// Now new implementation is based on three radio button mainly
		// CommonBlockButton ,DownBlockButton and UpBlockButton
		CommonBlockButton.addItemListener(BlockInputNewWindow.BlockTypeItemListener_new);
		UpBlockButton.addItemListener(BlockInputNewWindow.BlockTypeItemListener_new);
		DownBlockButton.addItemListener(BlockInputNewWindow.BlockTypeItemListener_new);

		ViewAllBlockButton.addActionListener(viewAllBlockActionListener);
		editBlock.addActionListener(EditBlockActionListener);
		NumberofLines.addItemListener(NumberofLinesListener);
		DoneButton.addActionListener(DoneButtonActionListener);
	};
	
	ItemListener NumberofLinesListener = new ItemListener() {

		@Override
		public void itemStateChanged(ItemEvent arg0) {
			System.out.println("Item Changed");
			boolean UpBlockSelected = UpBlockButton.isSelected();
			boolean CommonBlockSelected = CommonBlockButton.isSelected();
			boolean DownBlockSelected = DownBlockButton.isSelected();
			
			for (int i = 0; i < LineNumberLabelList.size(); i++) {
				LineNumberLabel = LineNumberLabelList.get(i);
				LineNumberButton = LineNumberButtonList.get(i);

				jpanel.remove(LineNumberLabel);
				jpanel.remove(LineNumberButton);
				jpanel.revalidate();
				jpanel.repaint();

			}
			LineNumberLabelList.clear();
			LineNumberButtonList.clear();
			if (UpBlockSelected)
				BlockInputNewWindow.UpBlockIdList.clear();
			else if (DownBlockSelected)
				BlockInputNewWindow.DownBlockIdList.clear();
			else if (CommonBlockSelected)
				BlockInputNewWindow.CommonBlockIdList.clear();
			
			// Reset the number of lines as well

			int  NumberofLinesSelected = (int) NumberofLines.getSelectedItem();
			JLabel[] LineLabelArray = new JLabel[NumberofLinesSelected];
			JButton[] LineButtonArray = new JButton[NumberofLinesSelected];// Abhishek
			String BlockType = "Up";
			if (CommonBlockSelected)
				BlockType = "Common";
			if (DownBlockSelected)
				BlockType = "Down";
			int yDiff = 35;
			int yCoord = YMarker;
			for (int i = 0; i < NumberofLinesSelected; i++) {
				String LabelName = "Enter " + BlockType + "-" + "Line " + String.valueOf(i+1);
				LineLabelArray[i] = new JLabel(LabelName);
				LineButtonArray[i] = new JButton("+");
				LineNumberLabelList.add(LineLabelArray[i]);
				LineNumberButtonList.add(LineButtonArray[i]);
				LineButtonArray[i].addMouseListener(EnterLineButtonListener(i));
				LineLabelArray[i].setBounds(x1 + 10, yCoord, labelWidth, fieldHeight);
				LineButtonArray[i].setBounds(x1 + 160, yCoord, 50, buttonHeight);
				yCoord += yDiff;
				jpanel.add(LineLabelArray[i]);
				jpanel.add(LineButtonArray[i]);// Abhishek

				jpanel.revalidate();
				jpanel.repaint();
				jpanel.setLayout(null);
			}
		};
	};
	
	protected MouseListener EnterLineButtonListener(int i) {
		MouseListener mouseListener = new MouseListener() {
			
			@Override
			public void mouseReleased(MouseEvent e) {
				// TODO Auto-generated method stub
				LineNumber = i;
				System.out.println("Row: " + LineNumber);
				BlockInputNewWindow binw = GlobalVar.getBlockInputNewWindowObject();
				binw.setVisible(true);
			}
			
			@Override
			public void mousePressed(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void mouseExited(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void mouseEntered(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void mouseClicked(MouseEvent e) {
				// TODO Auto-generated method stub
			}
		};
		return mouseListener;
	};
	
	ActionListener EditBlockActionListener = new ActionListener() {
		@Override
		public void actionPerformed(ActionEvent arg0) {
			resultLabel.setText("");
			SectionInputDialog sectioninputdialog = GlobalVar.getSectionInputDialog();
			// Sneha:Come here to ensure why substring is just 1st
			// digit?????????????
			// test with bit bigger input having more then 10 station

			ArrayList tempArray = sectioninputdialog.blockList;
			ArrayList temploopArray = SectionInputDialog.loopList;
			int stationId = stationno.getSelectedIndex() + 1;
			int nextStationId = stationId + 1;
			for (int l = 0; l < temploopArray.size(); l++) {
				Loop tempLoop = (Loop) temploopArray.get(l);
				String tempLoopNo = String.format("%07d", tempLoop.blockNo);
				int checkLoopNo = Integer.parseInt(tempLoopNo.substring(0, 3));
				if (stationId == checkLoopNo) {
					tempLoop.upLinks.clear();

				} else if (nextStationId == checkLoopNo) {
					tempLoop.downLinks.clear();

				}
			}

			for (int b = tempArray.size() - 1; b >= 0; b--) {
				Block tempBlock = (Block) tempArray.get(b);
				String tempBlockNo = String.format("%07d", tempBlock.getBlockNo());
				int checkBlockNo = Integer.parseInt(tempBlockNo.substring(0, 3).toString());
				if (stationId == checkBlockNo) {
					sectioninputdialog.blockList.remove(tempBlock);
					// System.out.println("tempBlock.blockNo: " + " " +
					// tempBlock.blockNo);
				}
			}

			/*
			 * if(startkm3FieldList.size()==0){
			 * 
			 * CommonBlockButton.doClick(); UpDownBlockButton.setSelected(true);
			 * succedingno.setText(nextstationNames[(stationno .getSelectedIndex() + 1)]);
			 * }else{ UpDownBlockButton.doClick(); CommonBlockButton.setSelected(true);
			 * succedingno.setText(nextstationNames[(stationno .getSelectedIndex() + 1)]); }
			 */
			resultLabel.setText("All the blocks between the two specified stations removed successfully");
		}

	};

	ActionListener stationnoActionListener = new ActionListener() {
		@Override
		public void actionPerformed(ActionEvent arg0) {
			resultLabel.setText("");

			// Sneha : added another check whether stationno dialogbox is
			// enabled or not
			// if new station is added then adding new item generates an event
			// so to
			// avoid this temp stationno is disabled
			// check updatestationnames method.
			if (stationno.getSelectedIndex() >= 0 && stationno.isEnabled()) {

				BlockTypeButtonGroup.clearSelection();
				CommonBlockButton.setVisible(false);
				// UpDownBlockButton.setVisible(false);
				UpBlockButton.setVisible(false);
				DownBlockButton.setVisible(false);
				BlockTypeLabel.setVisible(false);
				ViewAllBlockButton.setVisible(true);

				int count = 0;
				SectionInputDialog sectioninputdialog = GlobalVar.getSectionInputDialog();
				ArrayList<Block> blockList = sectioninputdialog.blockList;
				for (Block block : blockList) {
					String blockId = String.format("%07d", block.getBlockNo());

					int blockstationId = 0;
					if (blockId.length() == 6) {
						blockstationId = Integer.parseInt(blockId.substring(0, 2)) - 1;
					} else {
						blockstationId = Integer.parseInt(blockId.substring(0, 3)) - 1;
					}

					if (blockstationId == stationno.getSelectedIndex()) {
						count++;
					}
				}

				if (count == 0) {

					succedingno.setText(nextstationNames[(stationno.getSelectedIndex() + 1)]);
					StationName = stationNames[(stationno.getSelectedIndex())];
					NextStationName = nextstationNames[(stationno.getSelectedIndex() + 1)];

					// sneha : implemented allowedblock type test between two
					// station
					boolean allowUpBlock = testAllowedUpBlock(StationName, NextStationName);
					boolean allowDownBlock = testAllowedDownBlock(StationName, NextStationName);
					boolean allowCommonBlock = testAllowedcommonBlock(StationName, NextStationName);

					if (allowCommonBlock)
						CommonBlockButton.setVisible(true);
					// UpDownBlockButton.setVisible(true);

					if (allowUpBlock)
						UpBlockButton.setVisible(true);

					if (allowDownBlock)
						DownBlockButton.setVisible(true);
					BlockTypeLabel.setVisible(true);
				} else {

					int editResponse = JOptionPane.showConfirmDialog(null,
							"Do you want to edit the block details of selected station", "Confirm",
							JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
					if (editResponse == JOptionPane.YES_NO_OPTION) {
						int confirmEdit = JOptionPane.showConfirmDialog(null,
								"All existing block details will be erased", "Confirm", JOptionPane.OK_CANCEL_OPTION,
								JOptionPane.QUESTION_MESSAGE);
						if (confirmEdit == JOptionPane.OK_OPTION) {
							editBlock.doClick();

							/*
							 * if(startkm3FieldList.size()==0){ UpDownBlockButton.setSelected(true);
							 * succedingno.setText(nextstationNames[(stationno .getSelectedIndex() + 1)]);
							 * }else{ CommonBlockButton.setSelected(true);
							 * succedingno.setText(nextstationNames[(stationno .getSelectedIndex() + 1)]); }
							 */
							succedingno.setText(nextstationNames[(stationno.getSelectedIndex() + 1)]);
							StationName = stationNames[(stationno.getSelectedIndex())];
							NextStationName = nextstationNames[(stationno.getSelectedIndex() + 1)];

							// sneha : implemented allowedblock type test
							// between two station
							boolean allowUpBlock = testAllowedUpBlock(StationName, NextStationName);
							boolean allowDownBlock = testAllowedDownBlock(StationName, NextStationName);
							boolean allowCommonBlock = testAllowedcommonBlock(StationName, NextStationName);

							if (allowUpBlock)
								UpBlockButton.setVisible(true);

							if (allowDownBlock)
								DownBlockButton.setVisible(true);
							BlockTypeLabel.setVisible(true);

							if (allowCommonBlock)
								CommonBlockButton.setVisible(true);
							// UpDownBlockButton.setVisible(true);
						}
					}

					/*
					 * CommonBlockButton.setVisible(false); UpDownBlockButton.setVisible(false);
					 * BlockTypeLabel.setVisible(false);
					 */
				}
				// jpanel.revalidate();
				// jpanel.repaint();

			}

			// jpanel.revalidate();
			// jpanel.repaint();
		}

	};
	ActionListener DoneButtonActionListener = new ActionListener() {
		@Override
		public void actionPerformed(ActionEvent arg0) {
			{
				jpanel.removeAll();
				NumberofLines.setVisible(false);
				NumberofLinesLabel.setVisible(false);
				GlobalVar.blockInput = null;
				dispose();
			}
		}

	};

	/*
	 * ItemListener BlockTypeItemListener = new ItemListener() {
	 * 
	 * @Override public void itemStateChanged(ItemEvent arg0) {
	 * resultLabel.setText(""); boolean UpDownBlockSelected =
	 * UpDownBlockButton.isSelected(); boolean CommonBlockSelected =
	 * CommonBlockButton.isSelected();
	 * 
	 * startkm1Label.setVisible(UpDownBlockSelected);
	 * startkm2Label.setVisible(UpDownBlockSelected);
	 * endkm1Label.setVisible(UpDownBlockSelected);
	 * endkm2Label.setVisible(UpDownBlockSelected);
	 * downloopsLabel.setVisible(UpDownBlockSelected);
	 * uploopsLabel.setVisible(UpDownBlockSelected);
	 * uploops.setVisible(UpDownBlockSelected);
	 * downloops.setVisible(UpDownBlockSelected);
	 * BlockVelocity1Label.setVisible(UpDownBlockSelected);
	 * BlockVelocity2Label.setVisible(UpDownBlockSelected);
	 * Submit1Button.setVisible(UpDownBlockSelected);
	 * ViewAllBlockButton.setVisible(UpDownBlockSelected || CommonBlockSelected);
	 * editBlock.setVisible(UpDownBlockSelected || CommonBlockSelected);
	 * DoneButton.setVisible(UpDownBlockSelected || CommonBlockSelected);
	 * Speedrestrictionstartkm1Label.setVisible(UpDownBlockSelected);
	 * Speedrestrictionendkm1Label.setVisible(UpDownBlockSelected);
	 * Speedrestrictionmaxspeed1Label.setVisible(UpDownBlockSelected);
	 * Speedrestrictionstartkm2Label.setVisible(UpDownBlockSelected);
	 * Speedrestrictionendkm2Label.setVisible(UpDownBlockSelected);
	 * Speedrestrictionmaxspeed2Label.setVisible(UpDownBlockSelected);
	 * Speedrestrictionstartkm3Label.setVisible(CommonBlockSelected);
	 * Speedrestrictionendkm3Label.setVisible(CommonBlockSelected);
	 * Speedrestrictionmaxspeed3Label.setVisible(CommonBlockSelected);
	 * commonloops.setVisible(CommonBlockSelected);
	 * commonloopsLabel.setVisible(CommonBlockSelected);
	 * endkm3Label.setVisible(CommonBlockSelected);
	 * startkm3Label.setVisible(CommonBlockSelected);
	 * BlockVelocity3Label.setVisible(CommonBlockSelected);
	 * Submit2Button.setVisible(CommonBlockSelected); if (!CommonBlockSelected) { if
	 * (startkm3FieldList.size() > 0) { for (int i = 0; i <
	 * startkm3FieldList.size(); i++) { startkm3Field = startkm3FieldList.get(i);
	 * endkm3Field = endkm3FieldList.get(i); BlockVelocity3Field =
	 * BlockVelocity3FieldList.get(i); Speedrestrictionstartkm3Field =
	 * Speedrestrictionstartkm3FieldList .get(i); Speedrestrictionendkm3Field =
	 * Speedrestrictionendkm3FieldList .get(i); Speedrestrictionmaxspeed3Field =
	 * Speedrestrictionmaxspeed3FieldList .get(i);
	 * 
	 * jpanel.remove(startkm3Field); jpanel.remove(endkm3Field);
	 * jpanel.remove(BlockVelocity3Field);
	 * jpanel.remove(Speedrestrictionstartkm3Field);
	 * jpanel.remove(Speedrestrictionendkm3Field);
	 * jpanel.remove(Speedrestrictionmaxspeed3Field); jpanel.revalidate();
	 * jpanel.repaint();
	 * 
	 * } Speedrestrictionstartkm3FieldList.clear();
	 * Speedrestrictionendkm3FieldList.clear();
	 * Speedrestrictionmaxspeed3FieldList.clear(); startkm3FieldList.clear();
	 * endkm3FieldList.clear(); BlockVelocity3FieldList.clear();
	 * CommonBlockIdList.clear(); } if (UpDownBlockSelected) {
	 * uploops.setSelectedIndex(0); downloops.setSelectedIndex(0); } } if
	 * (!UpDownBlockSelected) { if (startkm1FieldList.size() > 0)
	 * 
	 * { for (int i = 0; i < startkm1FieldList.size(); i++) { startkm1Field =
	 * startkm1FieldList.get(i); endkm1Field = endkm1FieldList.get(i);
	 * BlockVelocity1Field = BlockVelocity1FieldList.get(i);
	 * Speedrestrictionstartkm1Field = Speedrestrictionstartkm1FieldList .get(i);
	 * Speedrestrictionendkm1Field = Speedrestrictionendkm1FieldList .get(i);
	 * Speedrestrictionmaxspeed1Field = Speedrestrictionmaxspeed1FieldList .get(i);
	 * 
	 * jpanel.remove(startkm1Field); jpanel.remove(endkm1Field);
	 * jpanel.remove(BlockVelocity1Field);
	 * jpanel.remove(Speedrestrictionstartkm1Field);
	 * jpanel.remove(Speedrestrictionendkm1Field);
	 * jpanel.remove(Speedrestrictionmaxspeed1Field); jpanel.revalidate();
	 * jpanel.repaint();
	 * 
	 * } startkm1FieldList.clear(); endkm1FieldList.clear();
	 * BlockVelocity1FieldList.clear(); Speedrestrictionstartkm1FieldList.clear();
	 * Speedrestrictionendkm1FieldList.clear();
	 * Speedrestrictionmaxspeed1FieldList.clear(); UpBlockIdList.clear();
	 * 
	 * }
	 * 
	 * if (startkm2FieldList.size() > 0) { for (int i = 0; i <
	 * startkm2FieldList.size(); i++) { startkm2Field = startkm2FieldList.get(i);
	 * endkm2Field = endkm2FieldList.get(i); BlockVelocity2Field =
	 * BlockVelocity2FieldList.get(i);
	 * 
	 * Speedrestrictionstartkm2Field = Speedrestrictionstartkm2FieldList .get(i);
	 * Speedrestrictionendkm2Field = Speedrestrictionendkm2FieldList .get(i);
	 * Speedrestrictionmaxspeed2Field = Speedrestrictionmaxspeed2FieldList .get(i);
	 * 
	 * jpanel.remove(Speedrestrictionstartkm2Field);
	 * jpanel.remove(Speedrestrictionendkm2Field);
	 * jpanel.remove(Speedrestrictionmaxspeed2Field);
	 * 
	 * jpanel.remove(startkm2Field); jpanel.remove(endkm2Field);
	 * jpanel.remove(BlockVelocity2Field); jpanel.revalidate(); jpanel.repaint();
	 * 
	 * } startkm2FieldList.clear(); endkm2FieldList.clear();
	 * BlockVelocity2FieldList.clear(); DownBlockIdList.clear();
	 * Speedrestrictionstartkm2FieldList.clear();
	 * Speedrestrictionendkm2FieldList.clear();
	 * Speedrestrictionmaxspeed2FieldList.clear();
	 * 
	 * } if (CommonBlockSelected) { commonloops.setSelectedIndex(0);
	 * 
	 * } } } };
	 */


	static ActionListener viewAllBlockActionListener = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			resultLabel.setText("");
			ArrayList<Block> UniqueBlocks = new ArrayList<>();
			SectionInputDialog sectioninputdialog = GlobalVar.getSectionInputDialog();
			System.out.println("Size: " + sectioninputdialog.blockList.size());
			for (Block block: sectioninputdialog.blockList) {
				System.out.println("Block No. is: " + block.blockNo);
				int flag = 0;
				for (Block blockNew: UniqueBlocks) {
					if (block.blockNo == blockNew.blockNo) {
						flag = 1;
						break;
					}
				}
				if (flag == 0)
					UniqueBlocks.add(block);
			}
			sectioninputdialog.blockList = UniqueBlocks;
			AllBlockData1 allBlockData = new AllBlockData1();
		}
	};

	// sneha: added following check to test to check if both left and right
	// station have up loop
	boolean testAllowedUpBlock(String StationName, String NextStationName) {
		boolean uploopLeftStation = false;
		boolean uploopRightStation = false;
		boolean allowed = false;

		SectionInputDialog sectioninputdialog = GlobalVar.getSectionInputDialog();
		ArrayList<Loop> temploopList = SectionInputDialog.loopList;

		for (Loop loop : temploopList) {
			if (loop.stationName.equals(StationName)) {
				if (loop.direction == GlobalVar.UP_DIRECTION)
					uploopLeftStation = true;
				if (loop.direction == GlobalVar.COMMON_DIRECTION)
					uploopLeftStation = true;
			}

			if (loop.stationName.equals(NextStationName)) {
				if (loop.direction == GlobalVar.UP_DIRECTION)
					uploopRightStation = true;
				if (loop.direction == GlobalVar.COMMON_DIRECTION)
					uploopRightStation = true;
			}
		}
		if (uploopLeftStation && uploopRightStation)
			allowed = true;
		return (allowed);
	}

	// sneha: added following check to test to check if both left and right
	// station have down loop
	boolean testAllowedDownBlock(String StationName, String NextStationName) {
		boolean downloopLeftStation = false;
		boolean downloopRightStation = false;
		boolean allowed = false;

		SectionInputDialog sectioninputdialog = GlobalVar.getSectionInputDialog();
		ArrayList<Loop> temploopList = SectionInputDialog.loopList;

		for (Loop loop : temploopList) {
			if (loop.stationName.equals(StationName)) {
				if (loop.direction == GlobalVar.DOWN_DIRECTION)
					downloopLeftStation = true;
				if (loop.direction == GlobalVar.COMMON_DIRECTION)
					downloopLeftStation = true;
			}

			if (loop.stationName.equals(NextStationName)) {
				if (loop.direction == GlobalVar.DOWN_DIRECTION)
					downloopRightStation = true;
				if (loop.direction == GlobalVar.COMMON_DIRECTION)
					downloopRightStation = true;
			}
		}

		if (downloopLeftStation && downloopRightStation)
			allowed = true;
		return (allowed);
	}

	// sneha: added following check to test to check if both left and right
	// station have common loop
	boolean testAllowedcommonBlock(String StationName, String NextStationName) {
		boolean commonloopLeftStation = false;
		boolean commonloopRightStation = false;
		boolean allowed = false;

		SectionInputDialog sectioninputdialog = GlobalVar.getSectionInputDialog();
		ArrayList<Loop> temploopList = SectionInputDialog.loopList;

		// Sneha: check this condition again when should be common block allowed
		// as of now allow common always
		for (Loop loop : temploopList) {
			if (loop.stationName.equals(StationName)) {
				commonloopLeftStation = true;
				// if(loop.direction==GlobalVar.COMMON_DIRECTION)commonloopLeftStation=true;
				// if((loop.direction==GlobalVar.UP_DIRECTION)&&(loop.direction==GlobalVar.DOWN_DIRECTION))commonloopLeftStation=true;
			}

			if (loop.stationName.equals(NextStationName)) {
				commonloopRightStation = true;
				// if(loop.direction==GlobalVar.COMMON_DIRECTION)commonloopRightStation=true;
				// if((loop.direction==GlobalVar.UP_DIRECTION)&&(loop.direction==GlobalVar.DOWN_DIRECTION))commonloopRightStation=true;
			}
		}
		if (commonloopLeftStation && commonloopRightStation)
			allowed = true;
		return (allowed);
	}

	public static void main(String args[]) {
		BlockInput blockInput = GlobalVar.getBlockInput();
	}
	
	public void writeBlocks(ArrayList<Block> blockList) throws IOException {
		String blockFileName = FileNames.getBlockFileName();
		BufferedWriter bw = new BufferedWriter(new FileWriter(blockFileName));
		String formatString = "/*Block-Number Direction Starting-Mile-Post(Km) Ending-Mile-Post(Km) Block-Velocity(kmph) Uplinks Up-Link-Length Priority Cross-over Down-link Down-Link-Length Priority Cross-over Speed-Restrictions(kmph,kmph) Starting-Mile-Posts(startkm1,startkm2) Ending-Mile-Posts(endkm1,endkm2)*/\n\n";
		bw.write(formatString);
		ArrayList<Block> BlockList = new ArrayList<Block>();
		for (Block block : blockList) {
			int flag = 0;
			for (int i = 0; i < BlockList.size(); i++) {
				if (BlockList.get(i).getBlockNo() == block.getBlockNo()) {
					flag = 1;
					break;
				}
			}
			if (flag == 0) {
				BlockList.add(block);
			}
		}
		Collections.sort(BlockList, new CompareBlockNumber());

		for (Block block : BlockList) {
			bw.write(String.valueOf(block.blockNo));
			bw.write(" ");

			int blockDirection = block.direction;
			String directionString = GlobalVar.getDirectionStringFromDirection(blockDirection);
			bw.write(directionString);

			bw.write(" ");
			bw.write(String.valueOf(block.startMilePost - StationInputDialog.offsetDistance));
			bw.write(" ");
			bw.write(String.valueOf(block.endMilePost - StationInputDialog.offsetDistance));
			bw.write(" ");

			writeCommonBlockLoopAttributes(bw, block);

			bw.write("\n");
		}
		bw.close();
	}

	public void writeLoops(ArrayList<Loop> loopList) throws IOException {
		String loopFileName = FileNames.getLoopFileName();
		BufferedWriter bw = new BufferedWriter(new FileWriter(loopFileName));
		String formatString = "/*Loop-Number Direction Type Station-Code Type-of-Trains-allowed Loop-Velocity(kmph) Uplinks Uplink-lengths(km) Priority Cross-over Down-links Downlink-Lengths(kmph) Priority Cross-over Speed-Restriction(kmph) Start-Mile-Post(km) End-Mile-Post(km)*/\n\n";
		bw.write(formatString);
		
		Collections.sort(loopList, new CompareLoopNumber());
		
		for (Loop loop : loopList) {
			bw.write(String.valueOf(loop.blockNo));
			bw.write(" ");

			int direction = loop.direction;
			String directionString = GlobalVar.getDirectionStringFromDirection(direction);
			bw.write(directionString);
			bw.write(" ");

			String loopType = "ml";
			if (loop.whetherMainLine == 1)
				loopType = "loop";
			bw.write(loopType);
			bw.write(" ");

			bw.write("\"" + loop.stationName + "\"");
			bw.write(" ");

			bw.write(loop.getLoopTrainType());
			bw.write(" ");

			writeCommonBlockLoopAttributes(bw, loop);

			bw.write("\n");
		}
		bw.close();
	}

	private void writeCommonBlockLoopAttributes(BufferedWriter bw, Block block) throws IOException {
		bw.write(String.valueOf((int) (block.maximumPossibleSpeed)));
		bw.write(" ");

		writeLinkStrings(bw, GlobalVar.UP_DIRECTION, block);
		writeLinkStrings(bw, GlobalVar.DOWN_DIRECTION, block);
		writeSpeedLimitStrings(bw, block);
	}

	private void writeSpeedLimitStrings(BufferedWriter bw, Block block) throws IOException {
		bw.write("\"");
		String speedLimitString = block.getSpeedLimitsString();
		bw.write(speedLimitString);
		bw.write("\" ");

		bw.write("\"");
		String speedLimitStartMilePostsString = block.getSpeedLimitStartMilePostsString();
		bw.write(speedLimitStartMilePostsString);
		bw.write("\" ");

		bw.write("\"");
		String speedLimitEndMilePostsString = block.getSpeedLimitEndMilePostsString();
		bw.write(speedLimitEndMilePostsString);
		bw.write("\" ");
	}

	private void writeLinkStrings(BufferedWriter bw, int direction, Block block) throws IOException {
		bw.write("\"");
		String linkString = block.getLinkListString(direction);
		bw.write(linkString);
		bw.write("\" ");

		bw.write("\"");
		String linkLengthString = block.getLinkLengthsString(direction);
		bw.write(linkLengthString);
		bw.write("\" ");

		bw.write("\"");
		String linkPrioritiesString = block.getLinkPrioritiesString(direction);
		bw.write(linkPrioritiesString);
		bw.write("\" ");

		bw.write("\"");
		String linkCrossoversString = block.getLinkCrossoversString(direction);
		bw.write(linkCrossoversString);
		bw.write("\" ");
	}

	public void readBlocks(ArrayList<Block> blockList) throws IOException {
		String blockFileName = FileNames.getBlockFileName();
		StreamTokenizer streamTokenizer = new StreamTokenizer(new FileReader(blockFileName));
		streamTokenizer.slashSlashComments(true);
		streamTokenizer.slashStarComments(true);

		while (streamTokenizer.nextToken() != StreamTokenizer.TT_EOF) {
			Block block = new Block();
			int blockId = (int) streamTokenizer.nval;

			streamTokenizer.nextToken();
			String directionString = streamTokenizer.sval;

			streamTokenizer.nextToken();
			double startKM = streamTokenizer.nval + StationInputDialog.offsetDistance;

			streamTokenizer.nextToken();
			double endKM = streamTokenizer.nval + StationInputDialog.offsetDistance;

			block.blockNo = blockId;
			block.direction = GlobalVar.getDirectionFromDirectionString(directionString);
			block.startMilePost = startKM;
			block.endMilePost = endKM;

			block.readCommonBlockLoopProperties(streamTokenizer);
			blockList.add(block);
		}
	}

	public void readLoops(ArrayList<Loop> loopList) throws IOException {
		String loopFileName = FileNames.getLoopFileName();
		StreamTokenizer streamTokenizer = new StreamTokenizer(new FileReader(loopFileName));
		streamTokenizer.slashSlashComments(true);
		streamTokenizer.slashStarComments(true);

		while (streamTokenizer.nextToken() != StreamTokenizer.TT_EOF) {
			Loop loop = new Loop();
			int blockId = (int) streamTokenizer.nval;
			Loop.AllLoops.add(blockId);

			streamTokenizer.nextToken();
			String directionString = streamTokenizer.sval;

			streamTokenizer.nextToken();
			String loopType = streamTokenizer.sval;

			streamTokenizer.nextToken();
			String stationName = streamTokenizer.sval;

			streamTokenizer.nextToken();
			String loopTrainType = streamTokenizer.sval;

			loop.blockNo = blockId;
			loop.direction = GlobalVar.getDirectionFromDirectionString(directionString);
			loop.whetherMainLine = Loop.getWhetherMainLineFromType(loopType);
			loop.stationName = stationName;
			loop.setLoopTrainType(loopTrainType);

			loop.readCommonBlockLoopProperties(streamTokenizer);
			loopList.add(loop);
			Loop.loopNumToDirType.put(blockId, directionString + "-" + loopType);
			Loop.loopNumToStn.put(blockId, stationName);
		}
	}

}

class AllBlockData1 extends JFrame implements TableModelListener {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	JTable blockDataTable;

	public AllBlockData1() {
		super("List of blocks");

		blockDataTable = new JTable(new AbstractTableModel() {

			/**
			 * 
			 */
			int i = 0;
			private static final long serialVersionUID = 1L;
			String[] columnNames = { "Id", "Direction", "Start Km", "End Km", "Maximum Speed", "Up Links", "Priorities",
					"Crossovers", "Down Links", "Priorities", "Crossovers", "Speed Limits", "SL - Start Km",
					"SL - End Km" };
			SectionInputDialog sectioninputdialog = GlobalVar.getSectionInputDialog();

			ArrayList<Block> blockList = sectioninputdialog.blockList;

			@Override
			public String getColumnName(int col) {
				return columnNames[col];
			}

			@Override
			public int getRowCount() {

				return blockList.size();
			}

			@Override
			public int getColumnCount() {
				return columnNames.length;
			}

			@Override
			public Object getValueAt(int row, int col) {

				switch (col) {
				case 0:
					return blockList.get(row).blockNo;
				case 1: {

					// Sneha: Some how getDirection method is not working
					// properly and so
					// using variable direction to assign values.
					// otherwise view results in "direction" "common" for all
					// blocks
					// int direction = blockList.get(row).getDirection();
					int direction = blockList.get(row).direction;
					String directionString = GlobalVar.getDirectionStringFromDirection(direction);
					return directionString;
				}
				case 2:
					return blockList.get(row).startMilePost;
				case 3:
					return blockList.get(row).endMilePost;
				case 4:
					return blockList.get(row).maximumPossibleSpeed;
				case 5:
					return blockList.get(row).getLinkListString(GlobalVar.UP_DIRECTION);
				case 6:
					return blockList.get(row).getLinkPrioritiesString(GlobalVar.UP_DIRECTION);
				case 7:
					return blockList.get(row).getLinkCrossoversString(GlobalVar.UP_DIRECTION);
				case 8:
					return blockList.get(row).getLinkListString(GlobalVar.DOWN_DIRECTION);
				case 9:
					return blockList.get(row).getLinkPrioritiesString(GlobalVar.DOWN_DIRECTION);
				case 10:
					return blockList.get(row).getLinkCrossoversString(GlobalVar.DOWN_DIRECTION);
				case 11:
					return blockList.get(row).getSpeedLimitsString();
				case 12:
					return blockList.get(row).getSpeedLimitStartMilePostsString();
				case 13:
					return blockList.get(row).getSpeedLimitEndMilePostsString();

				}
				return null;
			}
		});

		JScrollPane scrollPane = new JScrollPane(blockDataTable);
		blockDataTable.setPreferredScrollableViewportSize(new Dimension(500, 70));
		getContentPane().add(scrollPane);
		setBounds(70, 70, 900, 400);
		setVisible(true);
	}

	@Override
	public void tableChanged(TableModelEvent arg0) {
	}

	void j() {
	}

}
