package input;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.WindowAdapter;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.StreamTokenizer;
import java.util.ArrayList;
import java.util.LinkedHashSet;

import javax.imageio.ImageIO;
import javax.swing.ButtonGroup;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JRootPane;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.AbstractTableModel;

//import com.sun.glass.events.WindowEvent; //Commented by Abhishek

import globalVariables.FileNames;
import globalVariables.GlobalVar;
import gui.entities.sectionEntities.Station;
import gui.entities.sectionEntities.trackProperties.Gradient;
import gui.entities.sectionEntities.trackProperties.GradientEffect;

public class GradientInputDialog extends InputDialog {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public JLabel slopeLabel = new JLabel("Gradient Value ");
	public JComboBox<String> GradientList = null;
	public JLabel directionLabel = new JLabel("Direction");
	public ButtonGroup directionButtonGroup = new ButtonGroup();
	public JRadioButton upRadioButton = new JRadioButton("Up");
	public JRadioButton downRadioButton = new JRadioButton("Down");
	public JRadioButton levelRadioButton = new JRadioButton("Level");
	public JTextField leveldirectionLabel = new JTextField("0");

	public JLabel startKmLabel = new JLabel("Start Km");
	public JTextField startKmField = new JTextField();

	public JLabel endKmLabel = new JLabel("End Km");
	public JTextField endKmField = new JTextField();

	public JButton addButton = new JButton("Add");
	public JButton viewAllGradientsButton = new JButton("View all gradients");

	public JLabel editDeleteOptionLabel = new JLabel("Edit/Delete");
	public JLabel editDeleteSlopeLabel = new JLabel("Gradient Value e.g. 1/100");
	public JLabel editDeleteSlopeLengthLabel = new JLabel("Select Slope Distance");
	public static JComboBox<String> editDeleteSlopeLengthField = new JComboBox<>(SectionInputDialog.MilePosts); // Abhishek
	public JLabel editDeleteDirectionLabel = new JLabel("Direction");

	public static JComboBox<String> editDeleteSlopeField = new JComboBox<>(SectionInputDialog.GradientValue);// Abhishek
	public ButtonGroup editDeleteDirectionButtonGroup = new ButtonGroup();
	public static JRadioButton editDeleteUpDirectionButton = new JRadioButton("Up");
	public JRadioButton editDeleteDownDirectionButton = new JRadioButton("Down");
	public static JRadioButton editDeleteLevelDirectionButton = new JRadioButton("Level");

	public JButton editButton = new JButton("Edit");
	public JButton deleteButton = new JButton("Delete");
	// public JButton updateButton = new JButton("Update");
	public JButton doneButton = new JButton("Exit Gradient");
	public static JLabel resultLabel = new JLabel("");

	public static updateFrame Updateobject = null; // Abhishek
	public static int updateY = 0;
	public static int updateX = 0;

	SectionInputDialog sectioninputdialog = GlobalVar.getSectionInputDialog();

	ArrayList<Gradient> gradientFormatList = sectioninputdialog.gradientFormatList;

	public static Gradient gradientFormatToBeEdited = null;
	public static GradientEffect gradientEffectToBeEdited = null;
	public static int index = -1;
	public static String[] gradienttype = { "1/100", "1/150", "1/200", "1/250", "1/300", "1/350", "1/400", "1/450" };

	public GradientInputDialog() {
		this.setBounds(30, 30, width, height);
		GradientList = new JComboBox<String>(gradienttype);

		setUndecorated(true);
		getRootPane().setWindowDecorationStyle(JRootPane.INFORMATION_DIALOG);

		try {
			this.setIconImage(ImageIO.read(new File(System.getProperty("user.dir") + "/res/logo.png")));
		} catch (IOException exc) {
			// exc.printStackTrace();
		}

		SectionInputDialog sectioninputdialog = GlobalVar.getSectionInputDialog();
		ArrayList<Station> stationList = sectioninputdialog.stationList;
		if (stationList.size() > 0) {
			String startmilepost = String.valueOf(stationList.get(0).getStartMilePost());
			String endmilepost = String.valueOf(stationList.get(stationList.size() - 1).getEndMilePost());
			startKmField.setText(startmilepost);
			endKmField.setText(endmilepost);
		}
		setComponentActionListeners();
		setComponentBounds();
		addComponents();
		this.add(jpanel);

		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		this.setTitle("Gradients Input");
		// this.setVisible(true);

		addWindowListener(new java.awt.event.WindowAdapter() {
			@Override
			public void windowClosing(java.awt.event.WindowEvent windowEvent) {
				GradientList.setSelectedItem("Select");
				updateFrame.UlevelRadioButton.setSelected(true);
				setDefaultCloseOperation(DISPOSE_ON_CLOSE);
			}
		});
	}

	@Override
	public void addComponents() {
		this.getContentPane().add(slopeLabel);

		this.getContentPane().add(directionLabel);

		this.getContentPane().add(upRadioButton);
		this.getContentPane().add(downRadioButton);
		this.getContentPane().add(levelRadioButton);
		directionButtonGroup.add(upRadioButton);
		directionButtonGroup.add(downRadioButton);
		directionButtonGroup.add(levelRadioButton);

		levelRadioButton.setSelected(true);
		this.getContentPane().add(leveldirectionLabel);
		leveldirectionLabel.disable();
		this.getContentPane().add(startKmLabel);
		this.getContentPane().add(startKmField);
		this.getContentPane().add(endKmLabel);
		this.getContentPane().add(endKmField);

		this.getContentPane().add(addButton);
		this.getContentPane().add(viewAllGradientsButton);
		this.getContentPane().add(GradientList);

		this.getContentPane().add(editDeleteOptionLabel);
		this.getContentPane().add(editDeleteSlopeLabel);
		this.getContentPane().add(editDeleteSlopeLengthLabel);
		this.getContentPane().add(editDeleteSlopeLengthField);
		this.getContentPane().add(editDeleteDirectionLabel);

		this.getContentPane().add(editDeleteSlopeField);
		this.getContentPane().add(editDeleteUpDirectionButton);
		this.getContentPane().add(editDeleteDownDirectionButton);
		this.getContentPane().add(editDeleteLevelDirectionButton);
		editDeleteDirectionButtonGroup.add(editDeleteUpDirectionButton);
		editDeleteDirectionButtonGroup.add(editDeleteDownDirectionButton);
		editDeleteDirectionButtonGroup.add(editDeleteLevelDirectionButton);
		editDeleteUpDirectionButton.setSelected(true);

		this.getContentPane().add(editButton);

		this.getContentPane().add(deleteButton);
		// this.getContentPane().add(updateButton);
		this.getContentPane().add(resultLabel);
		this.getContentPane().add(doneButton);

	}

	@Override
	public void setComponentBounds() {
		int yDifference = 25;
		buttonWidth = 100;
		labelWidth = 200;
		x2 = x1 + labelWidth + 20;

		slopeLabel.setBounds(x1, y1, labelWidth, labelHeight);
		GradientList.setBounds(x2, y1, 3 * fieldWidth / 4, fieldHeight);
		leveldirectionLabel.setBounds(x2, y1, 3 * fieldWidth / 4, fieldHeight);

		y1 += yDifference;
		directionLabel.setBounds(x1, y1, labelWidth, labelHeight);
		upRadioButton.setBounds(x2, y1, fieldWidth, fieldHeight);
		y1 += yDifference;
		downRadioButton.setBounds(x2, y1, fieldWidth, fieldHeight);
		y1 += yDifference;
		levelRadioButton.setBounds(x2, y1, fieldWidth, fieldHeight);

		y1 += yDifference;
		startKmLabel.setBounds(x1, y1, labelWidth, labelHeight);
		startKmField.setBounds(x2, y1, fieldWidth, fieldHeight);

		y1 += yDifference;
		endKmLabel.setBounds(x1, y1, labelWidth, labelHeight);
		endKmField.setBounds(x2, y1, fieldWidth, fieldHeight);

		y1 += yDifference;
		addButton.setBounds(x1, y1, buttonWidth, buttonHeight);
		viewAllGradientsButton.setBounds(x2, y1, 200, fieldHeight);

		y1 += 3 * yDifference;
		updateX = x1;
		updateY = y1;
		editDeleteOptionLabel.setBounds(x1, y1, labelWidth, labelHeight);

		y1 += yDifference;
		editDeleteSlopeLabel.setBounds(x1, y1, labelWidth, labelHeight);
		editDeleteSlopeField.setBounds(x2, y1, fieldWidth, fieldHeight);

		y1 += yDifference;
		editDeleteSlopeLengthLabel.setBounds(x1, y1, labelWidth, labelHeight);
		editDeleteSlopeLengthField.setBounds(x2, y1, fieldWidth, fieldHeight);

		y1 += yDifference;
		editDeleteDirectionLabel.setBounds(x1, y1, labelWidth, labelHeight);
		editDeleteUpDirectionButton.setBounds(x2, y1, fieldWidth, fieldHeight);

		y1 += yDifference;
		editDeleteDownDirectionButton.setBounds(x2, y1, fieldWidth, fieldHeight);
		y1 += yDifference;

		editDeleteLevelDirectionButton.setBounds(x2, y1, fieldWidth, fieldHeight);

		y1 += yDifference;
		editButton.setBounds(x1, y1, buttonWidth, buttonHeight);
		deleteButton.setBounds(x2, y1, buttonWidth, buttonHeight);

		y1 += yDifference;
		// updateButton.setBounds(x1, y1, buttonWidth, buttonHeight);
		doneButton.setBounds(x2, y1, buttonWidth + 10, buttonHeight);

		y1 += yDifference;
		resultLabel.setBounds(x1, y1, 300, labelHeight);

	}

	@Override
	public void setComponentActionListeners() {
		addButton.addActionListener(addActionListener);
		editButton.addActionListener(editActionListener);
		deleteButton.addActionListener(deleteActionListener);
		// updateButton.addActionListener(updateActionListener);
		viewAllGradientsButton.addActionListener(viewAllGradientsActionListener);
		doneButton.addActionListener(doneActionListener);
		upRadioButton.addItemListener(GradienttypeItemListener);
		downRadioButton.addItemListener(GradienttypeItemListener);
		levelRadioButton.addItemListener(GradienttypeItemListener);
		editDeleteSlopeField.addActionListener(editDeleteSlopeFieldActionListener);
	}

	/*
	 * Abhishek starts
	 */
	ActionListener editDeleteSlopeFieldActionListener = new ActionListener() {
		@Override
		public void actionPerformed(ActionEvent e) {
			JComboBox editDeleteSlopeField = (JComboBox) e.getSource();
			SectionInputDialog.MilePosts.removeAllElements();
			SectionInputDialog.MilePosts.addElement("Select");
			Object selected = editDeleteSlopeField.getSelectedItem();
			try {
				for (Gradient gradient : SectionInputDialog.gradientFormatList) {
					if (gradient.getGradientValue().equals(selected.toString())) {
						SectionInputDialog.MilePosts.addElement(String.valueOf(gradient.getRelativeStartMilePost())
								+ " to " + String.valueOf(gradient.getRelativeEndMilePost()));
					}
				}
			} catch (Exception e1) {
				// System.out.println("NO Error Thrown");
				e1.printStackTrace();
			} finally {
				System.out.println("");
			}
		}

	};

	/*
	 * Abhishek has finished
	 */

	ItemListener GradienttypeItemListener = new ItemListener() {

		@Override
		public void itemStateChanged(ItemEvent arg0) {
			boolean levelButtonSelected = levelRadioButton.isSelected();
			leveldirectionLabel.setVisible(levelButtonSelected);
			GradientList.setVisible(!levelButtonSelected);

		}
	};

	ActionListener addActionListener = new ActionListener() {

		Double g = 10.0;

		@Override
		public void actionPerformed(ActionEvent arg0) {
			try {

				String slopeString = GradientList.getSelectedItem().toString();
				if (GradientList.getSelectedIndex() == -1) {
					resultLabel.setText("Choose a station name to edit station properties ");
				} else {
					boolean isGradientLevel = levelRadioButton.isSelected();
					boolean isGradientUp = upRadioButton.isSelected();

					Gradient gradientFormatCheck = GlobalVar.getSectionInputDialog().getGradientBySlopeDirection(
							slopeString, isGradientUp, isGradientLevel,
							String.valueOf(Double.valueOf(startKmField.getText())),
							String.valueOf(Double.valueOf(endKmField.getText())));

					if (gradientFormatCheck != null) {
						resultLabel.setText("Gradient already exists");
						return;
					}

					GradientEffect gradientEffect = new GradientEffect();
					Gradient gradientFormat = new Gradient();

					gradientFormat.setGradientValue("0");
					gradientEffect.setGradientValue("0");
					if (!isGradientLevel) {
						gradientFormat.setGradientValue(slopeString);
						gradientEffect.setGradientValue(slopeString);

						if (isGradientUp) {
							gradientFormat.setDirection("Up");
							gradientEffect.setDirection(GlobalVar.UP_DIRECTION);
						} else {
							gradientFormat.setDirection("Down");
							gradientEffect.setDirection(GlobalVar.DOWN_DIRECTION);
						}
						gradientFormat.setRelativeStartMilePost(Double.parseDouble(startKmField.getText()));
						gradientFormat.setRelativeEndMilePost(Double.parseDouble(endKmField.getText()));

						Double slopeDouble = 0.0;
						if (slopeString.contains("/")) {
							String[] slopeArray = slopeString.split("/");
							slopeDouble = Double.parseDouble(slopeArray[0]) / Double.parseDouble(slopeArray[1]);
						} else {
							slopeDouble = Double.parseDouble(slopeString);
						}

						double g = GlobalVar.g;
						if (GradientList.getSelectedIndex() < 1 && !isGradientUp) {
							gradientEffect.setAccelerationChange(g * slopeDouble);
							gradientEffect.setDecelerationChange(-g * slopeDouble);
						} else if (GradientList.getSelectedIndex() < 2 && !isGradientUp) {
							gradientEffect.setAccelerationChange(g * slopeDouble);
							gradientEffect.setDecelerationChange(-g * slopeDouble);
						} else if (GradientList.getSelectedIndex() < 3 && !isGradientUp) {
							gradientEffect.setAccelerationChange(g * slopeDouble);
							gradientEffect.setDecelerationChange(-g * slopeDouble);
						} else if (GradientList.getSelectedIndex() < 4 && !isGradientUp) {
							gradientEffect.setAccelerationChange(g * slopeDouble);
							gradientEffect.setDecelerationChange(-g * slopeDouble);
						} else if (GradientList.getSelectedIndex() < 5 && !isGradientUp) {
							gradientEffect.setAccelerationChange(g * slopeDouble);
							gradientEffect.setDecelerationChange(-g * slopeDouble);
						} else if (GradientList.getSelectedIndex() < 6 && !isGradientUp) {
							gradientEffect.setAccelerationChange(g * slopeDouble);
							gradientEffect.setDecelerationChange(-g * slopeDouble);
						} else if (GradientList.getSelectedIndex() < 7 && !isGradientUp) {
							gradientEffect.setAccelerationChange(g * slopeDouble);
							gradientEffect.setDecelerationChange(-g * slopeDouble);
						} else if (GradientList.getSelectedIndex() < 8 && !isGradientUp) {
							gradientEffect.setAccelerationChange(g * slopeDouble);
							gradientEffect.setDecelerationChange(-g * slopeDouble);
						}

						else if (GradientList.getSelectedIndex() < 1 && isGradientUp) {
							gradientEffect.setAccelerationChange(-g * slopeDouble);
							gradientEffect.setDecelerationChange(g * slopeDouble);
						} else if (GradientList.getSelectedIndex() < 2 && isGradientUp) {
							gradientEffect.setAccelerationChange(-g * slopeDouble);
							gradientEffect.setDecelerationChange(g * slopeDouble);
						} else if (GradientList.getSelectedIndex() < 3 && isGradientUp) {
							gradientEffect.setAccelerationChange(-g * slopeDouble);
							gradientEffect.setDecelerationChange(g * slopeDouble);
						} else if (GradientList.getSelectedIndex() < 4 && isGradientUp) {
							gradientEffect.setAccelerationChange(-g * slopeDouble);
							gradientEffect.setDecelerationChange(g * slopeDouble);
						} else if (GradientList.getSelectedIndex() < 5 && isGradientUp) {
							gradientEffect.setAccelerationChange(-g * slopeDouble);
							gradientEffect.setDecelerationChange(g * slopeDouble);
						} else if (GradientList.getSelectedIndex() < 6 && isGradientUp) {
							gradientEffect.setAccelerationChange(-g * slopeDouble);
							gradientEffect.setDecelerationChange(g * slopeDouble);
						} else if (GradientList.getSelectedIndex() < 7 && isGradientUp) {
							gradientEffect.setAccelerationChange(-g * slopeDouble);
							gradientEffect.setDecelerationChange(g * slopeDouble);
						} else if (GradientList.getSelectedIndex() < 8 && isGradientUp) {
							gradientEffect.setAccelerationChange(-g * slopeDouble);
							gradientEffect.setDecelerationChange(g * slopeDouble);
						}

					} else {
						gradientFormat.setDirection("Level");
						gradientEffect.setDirection(GlobalVar.COMMON_DIRECTION);

						gradientFormat.setRelativeStartMilePost(Double.parseDouble(startKmField.getText()));
						gradientFormat.setRelativeEndMilePost(Double.parseDouble(endKmField.getText()));
						gradientEffect.setAccelerationChange(0);
						gradientEffect.setDecelerationChange(0);
					}

					GlobalVar.getSectionInputDialog().addGradientFormat(gradientFormat);
					GlobalVar.getSectionInputDialog().addGradientEffect(gradientEffect);
					// santhosh
					/*
					 * ArrayList stationList=GlobalVar.getSectionInputDialog(). stationList;
					 * ArrayList stationStartKmArray=new ArrayList(); ArrayList
					 * stationEndKmArray=new ArrayList(); for (int s=0;s<stationList.size();s++){
					 * Station tempStation=(Station)stationList.get(s); double
					 * startKm=tempStation.startMilePost; double endKm=tempStation.endMilePost;
					 * stationStartKmArray.add(startKm); stationEndKmArray.add(endKm); }
					 * Collections.sort(stationStartKmArray); Collections.sort(stationEndKmArray);
					 * double startChainage=(double)stationStartKmArray.get(0); double
					 * endChainage=(double)stationEndKmArray.get( stationEndKmArray.size()-1);
					 * 
					 * ArrayList tempGradientFormatList=GlobalVar.getSectionInputDialog().
					 * gradientFormatList; ArrayList<Gradient> tempUpGradientFormatList=new
					 * ArrayList<Gradient>(); ArrayList<Gradient> tempDownGradientFormatList=new
					 * ArrayList<Gradient>(); for (int r=0;r<tempGradientFormatList.size();r++){
					 * Gradient tempGradient=(Gradient)tempGradientFormatList.get(r);
					 * if(tempGradient.getDirection().equals("Up")){
					 * tempUpGradientFormatList.add(tempGradient); }else{
					 * tempDownGradientFormatList.add(tempGradient); } } if(isGradientUp){
					 * if(tempUpGradientFormatList.size()==1){ Gradient
					 * lastAddedUpGradient=(Gradient)tempUpGradientFormatList.
					 * get(tempUpGradientFormatList.size()-1); double
					 * laststmile=lastAddedUpGradient.getRelativeStartMilePost() ; double
					 * lastenmile=lastAddedUpGradient.getRelativeEndMilePost(); String
					 * lastSlope=lastAddedUpGradient.getGradientValue(); String
					 * lastDir=lastAddedUpGradient.getDirection();
					 * 
					 * 
					 * double tempStMile=startChainage; double tempEndMile=endChainage; String
					 * tempSlope="0"; String tempDir=lastDir;
					 * //GlobalVar.getSectionInputDialog().gradientFormatList.
					 * remove(lastAddedUpGradient);
					 * tempUpGradientFormatList.remove(lastAddedUpGradient); Gradient grad1 = new
					 * Gradient(); //tempGradientEffect=new GradientEffect();
					 * 
					 * //tempGradientEffect.setGradientValue("0");
					 * 
					 * //tempGradientEffect.setDirection(GlobalVar.UP_DIRECTION) ;
					 * //gradientEffect.setAccelerationChange(0);
					 * //gradientEffect.setDecelerationChange(0);
					 * grad1.setRelativeStartMilePost(tempStMile);
					 * grad1.setRelativeEndMilePost(laststmile); grad1.setGradientValue(tempSlope);
					 * grad1.setDirection(lastDir); tempUpGradientFormatList.add(grad1);
					 * //GlobalVar.getSectionInputDialog().gradientFormatList. add(grad1); Gradient
					 * grad2=new Gradient(); grad2.setRelativeStartMilePost(laststmile);
					 * grad2.setRelativeEndMilePost(lastenmile); grad2.setGradientValue(lastSlope);
					 * grad2.setDirection(lastDir); tempUpGradientFormatList.add(grad2);
					 * //GlobalVar.getSectionInputDialog().gradientFormatList. add(grad2); Gradient
					 * grad3=new Gradient(); grad3.setRelativeStartMilePost(lastenmile);
					 * grad3.setRelativeEndMilePost(tempEndMile); grad3.setGradientValue(tempSlope);
					 * grad3.setDirection(lastDir); tempUpGradientFormatList.add(grad3);
					 * //GlobalVar.getSectionInputDialog().gradientFormatList. add(grad3);
					 * 
					 * 
					 * 
					 * }else{ Gradient lastAddedUpGradient=(Gradient)tempUpGradientFormatList.
					 * get(tempUpGradientFormatList.size()-1); double
					 * laststmile=lastAddedUpGradient.getRelativeStartMilePost() ; double
					 * lastenmile=lastAddedUpGradient.getRelativeEndMilePost(); String
					 * lastSlope=lastAddedUpGradient.getGradientValue(); String
					 * lastDir=lastAddedUpGradient.getDirection(); for(int
					 * u=0;u<tempUpGradientFormatList.size();u++){ Gradient
					 * tempGradientFormat=(Gradient)tempUpGradientFormatList.get (u); double
					 * tempStMile=tempGradientFormat.getRelativeStartMilePost(); double
					 * tempEndMile=tempGradientFormat.getRelativeEndMilePost(); String
					 * tempSlope=tempGradientFormat.getGradientValue(); if(laststmile>tempStMile &&
					 * lastenmile<tempEndMile){
					 * //GlobalVar.getSectionInputDialog().gradientFormatList.
					 * remove(tempGradientFormat);
					 * //GlobalVar.getSectionInputDialog().gradientFormatList.
					 * remove(lastAddedUpGradient);
					 * tempUpGradientFormatList.remove(tempGradientFormat);
					 * tempUpGradientFormatList.remove(lastAddedUpGradient); Gradient grad1 = new
					 * Gradient(); //tempGradientEffect=new GradientEffect();
					 * 
					 * //tempGradientEffect.setGradientValue("0");
					 * 
					 * //tempGradientEffect.setDirection(GlobalVar.UP_DIRECTION) ;
					 * //gradientEffect.setAccelerationChange(0);
					 * //gradientEffect.setDecelerationChange(0);
					 * grad1.setRelativeStartMilePost(tempStMile);
					 * grad1.setRelativeEndMilePost(laststmile); grad1.setGradientValue(tempSlope);
					 * grad1.setDirection(lastDir);
					 * //GlobalVar.getSectionInputDialog().gradientFormatList. add(grad1);
					 * tempUpGradientFormatList.add(grad1); Gradient grad2=new Gradient();
					 * grad2.setRelativeStartMilePost(laststmile);
					 * grad2.setRelativeEndMilePost(lastenmile); grad2.setGradientValue(lastSlope);
					 * grad2.setDirection(lastDir);
					 * //GlobalVar.getSectionInputDialog().gradientFormatList. add(grad2);
					 * tempUpGradientFormatList.add(grad2); Gradient grad3=new Gradient();
					 * grad3.setRelativeStartMilePost(lastenmile);
					 * grad3.setRelativeEndMilePost(tempEndMile); grad3.setGradientValue(tempSlope);
					 * grad3.setDirection(lastDir);
					 * //GlobalVar.getSectionInputDialog().gradientFormatList. add(grad3);
					 * tempUpGradientFormatList.add(grad3); }
					 * 
					 * } } }else{
					 * 
					 * if(tempDownGradientFormatList.size()==1){ Gradient
					 * lastAddedDownGradient=(Gradient)
					 * tempDownGradientFormatList.get(tempDownGradientFormatList .size()-1); double
					 * laststmile=lastAddedDownGradient.getRelativeStartMilePost (); double
					 * lastenmile=lastAddedDownGradient.getRelativeEndMilePost() ; String
					 * lastSlope=lastAddedDownGradient.getGradientValue(); String
					 * lastDir=lastAddedDownGradient.getDirection();
					 * 
					 * 
					 * double tempStMile=startChainage; double tempEndMile=endChainage; String
					 * tempSlope="0"; String tempDir=lastDir;
					 * //GlobalVar.getSectionInputDialog().gradientFormatList.
					 * remove(lastAddedDownGradient);
					 * tempDownGradientFormatList.remove(lastAddedDownGradient); Gradient grad1 =
					 * new Gradient(); //tempGradientEffect=new GradientEffect();
					 * 
					 * //tempGradientEffect.setGradientValue("0");
					 * 
					 * //tempGradientEffect.setDirection(GlobalVar.UP_DIRECTION) ;
					 * //gradientEffect.setAccelerationChange(0);
					 * //gradientEffect.setDecelerationChange(0);
					 * grad1.setRelativeStartMilePost(tempStMile);
					 * grad1.setRelativeEndMilePost(laststmile); grad1.setGradientValue(tempSlope);
					 * grad1.setDirection(lastDir); tempDownGradientFormatList.add(grad1);
					 * //GlobalVar.getSectionInputDialog().gradientFormatList. add(grad1); Gradient
					 * grad2=new Gradient(); grad2.setRelativeStartMilePost(laststmile);
					 * grad2.setRelativeEndMilePost(lastenmile); grad2.setGradientValue(lastSlope);
					 * grad2.setDirection(lastDir); tempDownGradientFormatList.add(grad2);
					 * //GlobalVar.getSectionInputDialog().gradientFormatList. add(grad2); Gradient
					 * grad3=new Gradient(); grad3.setRelativeStartMilePost(lastenmile);
					 * grad3.setRelativeEndMilePost(tempEndMile); grad3.setGradientValue(tempSlope);
					 * grad3.setDirection(lastDir); tempDownGradientFormatList.add(grad3);
					 * //GlobalVar.getSectionInputDialog().gradientFormatList. add(grad3);
					 * 
					 * 
					 * 
					 * }else{ Gradient lastAddedUpGradient=(Gradient)tempGradientFormatList.get(
					 * tempGradientFormatList.size()-1); double
					 * laststmile=lastAddedUpGradient.getRelativeStartMilePost() ; double
					 * lastenmile=lastAddedUpGradient.getRelativeEndMilePost(); String
					 * lastSlope=lastAddedUpGradient.getGradientValue(); String
					 * lastDir=lastAddedUpGradient.getDirection(); for(int
					 * u=0;u<tempGradientFormatList.size();u++){ Gradient
					 * tempGradientFormat=(Gradient)tempGradientFormatList.get(u ); double
					 * tempStMile=tempGradientFormat.getRelativeStartMilePost(); double
					 * tempEndMile=tempGradientFormat.getRelativeEndMilePost(); String
					 * tempSlope=tempGradientFormat.getGradientValue(); if(laststmile>tempStMile &&
					 * lastenmile<tempEndMile){
					 * //GlobalVar.getSectionInputDialog().gradientFormatList.
					 * remove(tempGradientFormat);
					 * //GlobalVar.getSectionInputDialog().gradientFormatList.
					 * remove(lastAddedUpGradient);
					 * tempDownGradientFormatList.remove(tempGradientFormat);
					 * tempDownGradientFormatList.remove(lastAddedUpGradient); Gradient grad1 = new
					 * Gradient(); //tempGradientEffect=new GradientEffect();
					 * 
					 * //tempGradientEffect.setGradientValue("0");
					 * 
					 * //tempGradientEffect.setDirection(GlobalVar.UP_DIRECTION) ;
					 * //gradientEffect.setAccelerationChange(0);
					 * //gradientEffect.setDecelerationChange(0);
					 * grad1.setRelativeStartMilePost(tempStMile);
					 * grad1.setRelativeEndMilePost(laststmile); grad1.setGradientValue(tempSlope);
					 * grad1.setDirection(lastDir);
					 * //GlobalVar.getSectionInputDialog().gradientFormatList. add(grad1);
					 * tempDownGradientFormatList.add(grad1); Gradient grad2=new Gradient();
					 * grad2.setRelativeStartMilePost(laststmile);
					 * grad2.setRelativeEndMilePost(lastenmile); grad2.setGradientValue(lastSlope);
					 * grad2.setDirection(lastDir); tempDownGradientFormatList.add(grad2);
					 * //GlobalVar.getSectionInputDialog().gradientFormatList. add(grad2); Gradient
					 * grad3=new Gradient(); grad3.setRelativeStartMilePost(lastenmile);
					 * grad3.setRelativeEndMilePost(tempEndMile); grad3.setGradientValue(tempSlope);
					 * grad3.setDirection(lastDir); tempDownGradientFormatList.add(grad3);
					 * //GlobalVar.getSectionInputDialog().gradientFormatList. add(grad3); }
					 * 
					 * } }
					 * 
					 * } GlobalVar.getSectionInputDialog().gradientFormatList. clear();
					 * GlobalVar.getSectionInputDialog().gradientFormatList.
					 * addAll(tempUpGradientFormatList);
					 * GlobalVar.getSectionInputDialog().gradientFormatList.
					 * addAll(tempDownGradientFormatList);
					 */
					resultLabel.setText("Gradient added");
				}
			} catch (Exception ex) {
				ex.printStackTrace();
				resultLabel.setText("Check all inputs");
			}
		}
	};

	public static class updateFrame extends JFrame {
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		public JLabel UslopeLabel = new JLabel("Gradient Value ");
		public static JComboBox<String> UGradientList = null;
		public JLabel UdirectionLabel = new JLabel("Direction");
		public ButtonGroup UdirectionButtonGroup = new ButtonGroup();
		public static JRadioButton UupRadioButton = new JRadioButton("Up");
		public static JRadioButton UdownRadioButton = new JRadioButton("Down");
		public static JRadioButton UlevelRadioButton = new JRadioButton("Level");

		public JTextField UleveldirectionLabel = new JTextField("0");

		public JLabel UstartKmLabel = new JLabel("Start Km");
		public static JTextField UstartKmField = new JTextField();

		public JLabel UendKmLabel = new JLabel("End Km");
		public static JTextField UendKmField = new JTextField();
		public JButton updateButton = new JButton("Update");
		public static JLabel UresultLabel = new JLabel("");
		public static JPanel panel = new JPanel();

		public String[] Ugradienttype = { "1/100", "1/150", "1/200", "1/250", "1/300", "1/350", "1/400", "1/450" };

		public updateFrame(Gradient gradientFormat) {
			JFrame update = new JFrame();
			this.setTitle("Edit Gradient");
			this.setBounds(updateX + 80, updateY + 90, 480, 275);

			setUndecorated(true);
			getRootPane().setWindowDecorationStyle(JRootPane.WARNING_DIALOG);

			try {
				this.setIconImage(ImageIO.read(new File(System.getProperty("user.dir") + "/res/logo.png")));
			} catch (IOException exc) {
				// exc.printStackTrace();
			}

			this.setVisible(true);
			update.setDefaultCloseOperation(DISPOSE_ON_CLOSE);

			UGradientList = new JComboBox<String>(Ugradienttype);

			UsetComponents();
			UaddComponents();
			UaddActionListeners();
			panel.setLayout(null);
			this.add(panel);

			UGradientList.setSelectedItem(gradientFormat.getGradientValue());
			if (gradientFormat.getDirection().equalsIgnoreCase("Up")) {
				UupRadioButton.setSelected(true);
			} else if (gradientFormat.getDirection().equalsIgnoreCase("Down")) {
				UdownRadioButton.setSelected(true);
			} else {
				UlevelRadioButton.setSelected(true);
			}

			UstartKmField.setText(String.valueOf(gradientFormat.getRelativeStartMilePost()));
			UendKmField.setText(String.valueOf(gradientFormat.getRelativeEndMilePost()));
		}

		private void UaddActionListeners() {
			updateButton.addActionListener(updateActionListener);
			UupRadioButton.addItemListener(UGradienttypeItemListener);
			UdownRadioButton.addItemListener(UGradienttypeItemListener);
			UlevelRadioButton.addItemListener(UGradienttypeItemListener);
		}

		static ActionListener updateActionListener = new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				if (UstartKmField.getText().length() == 0 || UendKmField.getText().length() == 0) {
					System.out.println("StartKm " + UstartKmField.getText());
					UresultLabel.setText("Please enter valid Start Km and End Km to update");
				} else {
					Updateobject.dispose();
					updateAction();
				}
			}
		};

		ItemListener UGradienttypeItemListener = new ItemListener() {

			@Override
			public void itemStateChanged(ItemEvent arg0) {
				boolean UlevelButtonSelected = UlevelRadioButton.isSelected();
				UleveldirectionLabel.setVisible(UlevelButtonSelected);
				UGradientList.setVisible(!UlevelButtonSelected);

			}
		};

		private void UaddComponents() {
			panel.add(UslopeLabel);
			panel.add(UdirectionLabel);
			panel.add(UupRadioButton);
			panel.add(UdownRadioButton);
			panel.add(UlevelRadioButton);
			UdirectionButtonGroup.add(UupRadioButton);
			UdirectionButtonGroup.add(UdownRadioButton);
			UdirectionButtonGroup.add(UlevelRadioButton);

			UlevelRadioButton.setSelected(true);
			panel.add(UleveldirectionLabel);
			UleveldirectionLabel.disable();
			UleveldirectionLabel.setVisible(true);
			panel.add(UstartKmLabel);
			panel.add(UstartKmField);
			panel.add(UendKmLabel);
			panel.add(UendKmField);
			panel.add(updateButton);
			panel.add(UGradientList);
			UGradientList.setVisible(false);
			panel.add(UresultLabel);
		}

		private void UsetComponents() {
			int yDifferenceU = 25;
			int labelWidthU = 200;
			int x1U = 20;
			int y1U = 20;
			int x2U = x1U + labelWidthU + 20;
			int fieldWidthU = 100;
			int fieldHeightU = 20;
			x2U = x1U + labelWidthU + 20;

			UslopeLabel.setBounds(x1U, y1U, labelWidthU, labelHeight);
			UGradientList.setBounds(x2U, y1U, 3 * fieldWidthU / 4, fieldHeightU);
			UleveldirectionLabel.setBounds(x2U, y1U, 3 * fieldWidthU / 4, fieldHeightU);

			y1U += yDifferenceU;
			UdirectionLabel.setBounds(x1U, y1U, labelWidthU, labelHeight);
			UupRadioButton.setBounds(x2U, y1U, fieldWidthU, fieldHeightU);
			y1U += yDifferenceU;
			UdownRadioButton.setBounds(x2U, y1U, fieldWidthU, fieldHeightU);
			y1U += yDifferenceU;
			UlevelRadioButton.setBounds(x2U, y1U, fieldWidthU, fieldHeightU);

			y1U += yDifferenceU;
			UstartKmLabel.setBounds(x1U, y1U, labelWidthU, labelHeight);
			UstartKmField.setBounds(x2U, y1U, fieldWidthU, fieldHeightU);

			y1U += yDifferenceU;
			UendKmLabel.setBounds(x1U, y1U, labelWidthU, labelHeight);
			UendKmField.setBounds(x2U, y1U, fieldWidthU, fieldHeightU);

			y1U += yDifferenceU;
			updateButton.setBounds(x1U + 105, y1U + 5, buttonWidth, buttonHeight);

			y1U += yDifferenceU;
			UresultLabel.setBounds(x1U, y1U + 10, 300, labelHeight);
		}
	}

	ActionListener editActionListener = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			if (editDeleteSlopeLengthField.getSelectedItem().toString().equals("Select")) {
				resultLabel.setText("Choose a gradient to edit");
				return;
			}
			boolean isGradientUp = editDeleteUpDirectionButton.isSelected();
			boolean isGradientLevel = editDeleteLevelDirectionButton.isSelected();
			String slopeString = editDeleteSlopeField.getSelectedItem().toString();
			String[] MilePost = editDeleteSlopeLengthField.getSelectedItem().toString().split(" to ");// Abhishek

			Gradient gradientFormat = GlobalVar.getSectionInputDialog().getGradientBySlopeDirection(slopeString,
					isGradientUp, isGradientLevel, MilePost[0], MilePost[1]);

			if (gradientFormat == null) {
				resultLabel.setText("No such gradient exists");
				return;
			}

			gradientFormatToBeEdited = gradientFormat;
			gradientEffectToBeEdited = SectionInputDialog.getGradientEffectByGradientIndex(); // Abhishek

			updateFrame.UresultLabel.setText("Required gradient is shown");

			Updateobject = new updateFrame(gradientFormat);
		}
	};

	public Gradient getGradientFormatBySlopeDirection(String slopeString, boolean isGradientUp,
			boolean isGradientlevel) {
		String directionString = "Up";
		if (!isGradientUp && !isGradientlevel)
			directionString = "Down";
		if (isGradientlevel)
			directionString = "Level";

		for (Gradient gradientFormat : gradientFormatList) {
			if (gradientFormat.getGradientValue().equalsIgnoreCase(slopeString)
					&& gradientFormat.getDirection().equalsIgnoreCase(directionString))
				return gradientFormat;
		}

		return null;
	}

	ActionListener deleteActionListener = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			if (editDeleteSlopeLengthField.getSelectedItem().toString().equals("Select")) {
				resultLabel.setText("Choose a gradient to delete");
				return;
			}

			boolean isGradientUp = editDeleteUpDirectionButton.isSelected();
			boolean isGradientLevel = editDeleteLevelDirectionButton.isSelected();
			String slopeString = editDeleteSlopeField.getSelectedItem().toString();
			String[] MilePost = editDeleteSlopeLengthField.getSelectedItem().toString().split(" to "); // Abhishek

			Gradient gradientFormat = GlobalVar.getSectionInputDialog().getGradientBySlopeDirection(slopeString,
					isGradientUp, isGradientLevel, MilePost[0], MilePost[1]);

			if (gradientFormat == null) {
				resultLabel.setText("No such gradient exists");
				return;
			}

			GradientEffect gradientEffectToBeDeleted = SectionInputDialog.getGradientEffectByGradientIndex(); // Abhishek
			GlobalVar.getSectionInputDialog().removeGradientEffect(gradientEffectToBeDeleted);

			GlobalVar.getSectionInputDialog().removeGradient(gradientFormat);
			if (SectionInputDialog.MilePosts
					.getIndexOf(editDeleteSlopeLengthField.getSelectedItem().toString()) != -1) {
				SectionInputDialog.MilePosts.removeElement(editDeleteSlopeLengthField.getSelectedItem().toString());
				editDeleteSlopeField.setSelectedItem("Select");
				editDeleteSlopeLengthField.setSelectedItem("Select");
			}
			if (SectionInputDialog.MilePosts.getSize() == 1) {
				SectionInputDialog.GradientValue.removeElement(gradientFormat.getGradientValue());
				LinkedHashSet<String> SetofUniqueGradientValues = new LinkedHashSet<>();
				String[] GradientsListForDropDown = new String[SectionInputDialog.gradientFormatList.size() + 1];
				SetofUniqueGradientValues.add("Select");
				for (int s = 0; s < SectionInputDialog.gradientFormatList.size(); s++) {
					SetofUniqueGradientValues.add(SectionInputDialog.gradientFormatList.get(s).getGradientValue());
					// System.out.println("Abhishek" +
					// SectionInputDialog.GradientValue.getElementAt(s) + "ABs" +
					// GradientsListForDropDown[s]);
					// editDeleteSlopeField.addItem(SectionInputDialog.GradientValue.getElementAt(s).toString());
				}
				GradientsListForDropDown = SetofUniqueGradientValues
						.toArray(new String[SetofUniqueGradientValues.size()]);
				editDeleteSlopeField.setModel(new DefaultComboBoxModel<String>(GradientsListForDropDown));
				editDeleteSlopeField.setSelectedItem("Select");
				editDeleteSlopeLengthField.setSelectedItem("Select");
			}
			resultLabel.setText("Gradient deleted");

		}
	};

	public static void updateAction() {
		try {

			String slopeString = (String) updateFrame.UGradientList.getSelectedItem();

			boolean isGradientUp = updateFrame.UupRadioButton.isSelected();
			boolean isGradientDown = updateFrame.UdownRadioButton.isSelected();

			Gradient gradientFormat = gradientFormatToBeEdited;
			GradientEffect gradientEffect = gradientEffectToBeEdited;

			Double slopeDouble = 0.0;
			if (slopeString.contains("/")) {
				String[] slopeArray = slopeString.split("/");
				slopeDouble = Double.parseDouble(slopeArray[0]) / Double.parseDouble(slopeArray[1]);
			} else {
				slopeDouble = Double.parseDouble(slopeString);
			}

			double g = GlobalVar.g;
			if (isGradientUp) {
				gradientFormat.setDirection("Up");
				gradientEffect.setDirection(GlobalVar.UP_DIRECTION);
				gradientEffect.setAccelerationChange(-g * slopeDouble);
				gradientEffect.setDecelerationChange(g * slopeDouble);
			} else if (isGradientDown) {
				gradientFormat.setDirection("Down");
				gradientEffect.setDirection(GlobalVar.DOWN_DIRECTION);
				gradientEffect.setAccelerationChange(0.0);
				gradientEffect.setDecelerationChange(g * slopeDouble);
			} else {
				slopeString = "0";
				gradientFormat.setDirection("Level");
				gradientEffect.setDirection(GlobalVar.COMMON_DIRECTION);
				gradientEffect.setAccelerationChange(0.0);
				gradientEffect.setDecelerationChange(0.0);
			}

			gradientFormat.setGradientValue(slopeString);
			gradientFormat.setRelativeStartMilePost(Double.parseDouble(updateFrame.UstartKmField.getText()));
			gradientFormat.setRelativeEndMilePost(Double.parseDouble(updateFrame.UendKmField.getText()));

			gradientEffect.setGradientValue(slopeString);

			resultLabel.setText("Gradient updated");

			SectionInputDialog.MilePosts.removeAllElements();
			SectionInputDialog.MilePosts.addElement("Select");

			DefaultComboBoxModel<String> tempGradientValue = new DefaultComboBoxModel<>(new String[] { "Select" });

			SectionInputDialog sectioninputdialog = GlobalVar.getSectionInputDialog();
			ArrayList<Gradient> gradientFormatList = SectionInputDialog.gradientFormatList;
			int i = 0;
			for (Gradient grad : gradientFormatList) {
				tempGradientValue.addElement(grad.getGradientValue());
				System.out.println("Sushil " + tempGradientValue.getElementAt(i));
				i++;
			}
			SectionInputDialog.GradientValue = tempGradientValue;
			LinkedHashSet<String> SetofUniqueGradientValues = new LinkedHashSet<>();
			String[] GradientsListForDropDown = new String[SectionInputDialog.GradientValue.getSize()];
			for (int s = 0; s < SectionInputDialog.GradientValue.getSize(); s++) {
				SetofUniqueGradientValues.add(SectionInputDialog.GradientValue.getElementAt(s));
				System.out.println("Abhishek" + SectionInputDialog.GradientValue.getElementAt(s) + "ABs"
						+ GradientsListForDropDown[s]);
				// editDeleteSlopeField.addItem(SectionInputDialog.GradientValue.getElementAt(s).toString());
			}
			GradientsListForDropDown = SetofUniqueGradientValues.toArray(new String[SetofUniqueGradientValues.size()]);
			editDeleteSlopeField.setModel(new DefaultComboBoxModel<String>(GradientsListForDropDown));
			editDeleteSlopeField.setSelectedItem("Select");

		} catch (Exception ex) {
			ex.printStackTrace();
			updateFrame.UresultLabel.setText("Check all inputs");
		}
		updateFrame.UupRadioButton.setSelected(false);
		updateFrame.UdownRadioButton.setSelected(false);
		updateFrame.UlevelRadioButton.setSelected(false);
		Updateobject = null;
		System.gc();
	}

	ActionListener viewAllGradientsActionListener = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			AllGradientData allGradientData = new AllGradientData();
		}
	};

	/*
	 * ActionListener SlopeLengthActionListener = new ActionListener() {
	 * 
	 * @Override public void actionPerformed(ActionEvent arg0) {
	 * 
	 * }
	 * 
	 * };
	 */

	ActionListener doneActionListener = new ActionListener() {
		@Override
		public void actionPerformed(ActionEvent arg0) {
			GradientList.setSelectedItem("Select");
			updateFrame.UlevelRadioButton.setSelected(true);
			dispose();
		}
	};

	public static void main(String[] args) {
		editDeleteSlopeField = new JComboBox(SectionInputDialog.gradientFormatList.toArray());// Abhishek
		GradientInputDialog gradientInputDialog = GlobalVar.getGradientInputDialog();
	}

	public void write(ArrayList<Gradient> gradientFormatList) throws IOException {
		String gradientFileName = FileNames.getGradientFileName();
		BufferedWriter bw = new BufferedWriter(new FileWriter(gradientFileName));

		String formatString = "/*GradientValue direction startKM endKM*/" + "\n";
		bw.write(formatString);

		for (Gradient gradientFormat : gradientFormatList) {

			bw.write("\"" + gradientFormat.getGradientValue() + "\"");
			bw.write(" ");

			bw.write(gradientFormat.getDirection());
			bw.write(" ");

			bw.write(String.valueOf(gradientFormat.getRelativeStartMilePost() - StationInputDialog.offsetDistance));
			bw.write(" ");

			bw.write(String.valueOf(gradientFormat.getRelativeEndMilePost() - StationInputDialog.offsetDistance));
			bw.write(" ");

			bw.write("\n");
		}
		bw.close();

	}

	public void readGradients(ArrayList<Gradient> gradientFormatList) throws IOException {
		String gradientFileName = FileNames.getGradientFileName();
		StreamTokenizer streamTokenizer = new StreamTokenizer(new FileReader(gradientFileName));
		streamTokenizer.slashSlashComments(true);
		streamTokenizer.slashStarComments(true);

		while (streamTokenizer.nextToken() != StreamTokenizer.TT_EOF) {
			String gradientValue = streamTokenizer.sval;

			streamTokenizer.nextToken();
			String directionString = streamTokenizer.sval;

			streamTokenizer.nextToken();
			double startKm = streamTokenizer.nval + StationInputDialog.offsetDistance;

			streamTokenizer.nextToken();
			double endKm = streamTokenizer.nval + StationInputDialog.offsetDistance;

			Gradient gradientFormat = new Gradient(gradientValue, directionString, startKm, endKm);
			gradientFormatList.add(gradientFormat);

		}
	}

}

class AllGradientData extends JFrame implements TableModelListener {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	JTable gradientFormatDataTable;

	public AllGradientData() {
		super("List of gradients");

		gradientFormatDataTable = new JTable(new AbstractTableModel() {

			/**
			 * 
			 */
			private static final long serialVersionUID = 1L;
			String[] columnNames = { "Slope", "Direction", "Start Km", "End Km", };
			SectionInputDialog sectioninputdialog = GlobalVar.getSectionInputDialog();
			ArrayList<Gradient> gradientFormatList = sectioninputdialog.gradientFormatList;

			@Override
			public String getColumnName(int col) {
				return columnNames[col];
			}

			@Override
			public int getRowCount() {
				return gradientFormatList.size();
			}

			@Override
			public int getColumnCount() {
				return columnNames.length;
			}

			@Override
			public Object getValueAt(int row, int col) {
				switch (col) {
				case 0:
					return gradientFormatList.get(row).getGradientValue();
				case 1:
					return gradientFormatList.get(row).getDirection();
				case 2:
					return gradientFormatList.get(row).getRelativeStartMilePost();
				case 3:
					return gradientFormatList.get(row).getRelativeEndMilePost();

				}

				return null;
			}

		});

		JScrollPane scrollPane = new JScrollPane(gradientFormatDataTable);
		gradientFormatDataTable.setPreferredScrollableViewportSize(new Dimension(500, 70));
		getContentPane().add(scrollPane);
		setBounds(100, 100, 400, 400);
		setVisible(true);
	}

	@Override
	public void tableChanged(TableModelEvent arg0) {
	}

}
