package input;

import java.awt.Color;
import java.awt.Font;

import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

public class MultipleSpeedRestrictionFieldOverlapCheck implements DocumentListener {
	
	/**
	 * Title: Freight Traversal Time Comparison: Copyright: Copyright (c) 2002
	 * Company: IIT
	 * 
	 * @author Abhishek
	 *
	 */
	
	static int Row = 0;
	static int Column = 0;

	@Override
	public void changedUpdate(DocumentEvent arg0) {
		OverlapCheck();
	}

	@Override
	public void insertUpdate(DocumentEvent arg0) {
		OverlapCheck();
	}

	@Override
	public void removeUpdate(DocumentEvent arg0) {
		OverlapCheck();
	}

	private void OverlapCheck() {
		int n = Integer.valueOf(MultipleSpeedRestrictionInputDialog.NumberOfSpeedRestriction.getSelectedItem().toString()) - 1;
		MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setText("");
		for (int i = 0; i < n; i++) {
			MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setText("");
		}
		//First row if empty check
		if (MultipleSpeedRestrictionInputDialog.startkmField.getText().equals("") || MultipleSpeedRestrictionInputDialog.endkmField.getText().equals("") || MultipleSpeedRestrictionInputDialog.BlockVelocityField.getText().equals("") || MultipleSpeedRestrictionInputDialog.SpeedrestrictionstartkmField.getText().equals("") || MultipleSpeedRestrictionInputDialog.SpeedrestrictionendkmField.getText().equals("") || MultipleSpeedRestrictionInputDialog.SpeedrestrictionmaxspeedField.getText().equals("")) {
			MultipleSpeedRestrictionInputDialog.Submit.setEnabled(false);
			MultipleSpeedRestrictionInputDialog.NumberOfSpeedRestriction.setEnabled(false);
			MultipleSpeedRestrictionInputDialog.ResultLabel.setText("Please fill all the fields");
			MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setText("!");
			MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setForeground(Color.red);
			MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setFont(new Font("Serif", Font.BOLD, 26));
			return;
		}
		//First row if numeral check
		try {
			Double.valueOf(MultipleSpeedRestrictionInputDialog.startkmField.getText());
			Double.valueOf(MultipleSpeedRestrictionInputDialog.endkmField.getText());
			Double.valueOf(MultipleSpeedRestrictionInputDialog.BlockVelocityField.getText());
			Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionstartkmField.getText());
			Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionendkmField.getText());
			Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionmaxspeedField.getText());
		} catch (Exception e2) {
			MultipleSpeedRestrictionInputDialog.Submit.setEnabled(false);
			MultipleSpeedRestrictionInputDialog.ResultLabel.setText("Fields must be numerals");
			MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setText("!");
			MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setForeground(Color.red);
			MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setFont(new Font("Serif", Font.BOLD, 26));
			return;
		}
		//Block Start Km greater than Block End Km check
		if (Double.valueOf(MultipleSpeedRestrictionInputDialog.startkmField.getText()) >= Double.valueOf(MultipleSpeedRestrictionInputDialog.endkmField.getText())) {
			MultipleSpeedRestrictionInputDialog.Submit.setEnabled(false);
			MultipleSpeedRestrictionInputDialog.NumberOfSpeedRestriction.setEnabled(false);
			MultipleSpeedRestrictionInputDialog.ResultLabel.setText("Block Start Km should be greater than Block End Km");
			MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setText("!");
			MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setForeground(Color.red);
			MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setFont(new Font("Serif", Font.BOLD, 26));
			return;
		}
		//First Row Speed Restriction within block boundaries check
		if (Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionstartkmField.getText()) < Double.valueOf(MultipleSpeedRestrictionInputDialog.startkmField.getText()) || Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionendkmField.getText()) > Double.valueOf(MultipleSpeedRestrictionInputDialog.endkmField.getText()) || Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionstartkmField.getText()) > Double.valueOf(MultipleSpeedRestrictionInputDialog.endkmField.getText()) || Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionendkmField.getText()) < Double.valueOf(MultipleSpeedRestrictionInputDialog.startkmField.getText())) {
			MultipleSpeedRestrictionInputDialog.Submit.setEnabled(false);
			MultipleSpeedRestrictionInputDialog.NumberOfSpeedRestriction.setEnabled(false);
			MultipleSpeedRestrictionInputDialog.ResultLabel.setText("Speed Restrictions must be within the Block boundaries");
			MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setText("!");
			MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setForeground(Color.red);
			MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setFont(new Font("Serif", Font.BOLD, 26));
			return;
		}
		//First row Speed Restriction Start Km != End Km check
		else if (MultipleSpeedRestrictionInputDialog.SpeedrestrictionstartkmField.getText().equals(MultipleSpeedRestrictionInputDialog.SpeedrestrictionendkmField.getText())) {
			MultipleSpeedRestrictionInputDialog.Submit.setEnabled(false);
			MultipleSpeedRestrictionInputDialog.NumberOfSpeedRestriction.setEnabled(false);
			MultipleSpeedRestrictionInputDialog.ResultLabel.setText("Speed restriction region must have non-zero length");
			MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setText("!");
			MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setForeground(Color.red);
			MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setFont(new Font("Serif", Font.BOLD, 26));
			return;
		}
		
		MultipleSpeedRestrictionInputDialog.NumberOfSpeedRestriction.setEnabled(true);
		
		for (int i = 0; i < n; i++) {
			if (MultipleSpeedRestrictionInputDialog.SpeedrestrictionstartkmFieldList.get(i).getText().equals("") || MultipleSpeedRestrictionInputDialog.SpeedrestrictionendkmFieldList.get(i).getText().equals("") || MultipleSpeedRestrictionInputDialog.SpeedrestrictionmaxspeedFieldList.get(i).getText().equals("")) {
				MultipleSpeedRestrictionInputDialog.Submit.setEnabled(false);
				MultipleSpeedRestrictionInputDialog.ResultLabel.setText("Please fill all the fields");
				MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setText("!");
				MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setForeground(Color.red);
				MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setFont(new Font("Serif", Font.BOLD, 26));
				return;
			}
			else if (MultipleSpeedRestrictionInputDialog.SpeedrestrictionstartkmFieldList.get(i).getText().equals(MultipleSpeedRestrictionInputDialog.SpeedrestrictionendkmFieldList.get(i).getText())) {
				MultipleSpeedRestrictionInputDialog.Submit.setEnabled(false);
				MultipleSpeedRestrictionInputDialog.NumberOfSpeedRestriction.setEnabled(false);
				MultipleSpeedRestrictionInputDialog.ResultLabel.setText("Speed restriction region must have non-zero length");
				MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setText("!");
				MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setForeground(Color.red);
				MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setFont(new Font("Serif", Font.BOLD, 26));
				return;
			}
			else {
				try {
					Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionstartkmFieldList.get(i).getText());
					Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionendkmFieldList.get(i).getText());
					Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionmaxspeedFieldList.get(i).getText());
				} catch (Exception e) {
					MultipleSpeedRestrictionInputDialog.Submit.setEnabled(false);
					MultipleSpeedRestrictionInputDialog.ResultLabel.setText("Fields must be numerals");
					MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setText("!");
					MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setForeground(Color.red);
					MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setFont(new Font("Serif", Font.BOLD, 26));
					return;
				}
			}
			if (Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionstartkmFieldList.get(i).getText()) < Double.valueOf(MultipleSpeedRestrictionInputDialog.startkmField.getText()) || Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionendkmFieldList.get(i).getText()) > Double.valueOf(MultipleSpeedRestrictionInputDialog.endkmField.getText())) {
				MultipleSpeedRestrictionInputDialog.Submit.setEnabled(false);
				MultipleSpeedRestrictionInputDialog.ResultLabel.setText("Speed Restrictions must be within the Block boundaries");
				MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setText("!");
				MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setForeground(Color.red);
				MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setFont(new Font("Serif", Font.BOLD, 26));
				return;
			}
		}
		MultipleSpeedRestrictionInputDialog.Submit.setEnabled(true);
		MultipleSpeedRestrictionInputDialog.ResultLabel.setText("");
		MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setText("");
		for (int i = 0; i < n; i++) {
			MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setText("");
		}
		
		for (int i = 0; i < n; i++) {
			
			if (!MultipleSpeedRestrictionInputDialog.SpeedrestrictionstartkmFieldList.get(i).getText().equals("") && !MultipleSpeedRestrictionInputDialog.SpeedrestrictionendkmFieldList.get(i).getText().equals("") && MultipleSpeedRestrictionInputDialog.SpeedrestrictionstartkmFieldList.get(i).getText().equals(MultipleSpeedRestrictionInputDialog.SpeedrestrictionendkmFieldList.get(i).getText())) {
				MultipleSpeedRestrictionInputDialog.Submit.setEnabled(false);
				MultipleSpeedRestrictionInputDialog.ResultLabel.setText("Speed restriction region must have non-zero length");
				MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setText("!");
				MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setForeground(Color.red);
				MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setFont(new Font("Serif", Font.BOLD, 26));
				break;
			}
			
			for (int j = i; j < n; j++) {
				MultipleSpeedRestrictionInputDialog.ResultLabel.setText("");
				double StartKmCurr = Math.min(Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionstartkmField.getText()),Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionendkmField.getText()));
				double StartKmNext = Math.min(Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionstartkmFieldList.get(j).getText()),Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionendkmFieldList.get(j).getText()));
				double EndKmCurr = Math.max(Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionstartkmField.getText()),Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionendkmField.getText()));
				double EndKmNext = Math.max(Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionstartkmFieldList.get(j).getText()),Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionendkmFieldList.get(j).getText()));
				if (StartKmCurr <= StartKmNext && EndKmCurr >= EndKmNext || StartKmCurr >= StartKmNext && EndKmCurr <= EndKmNext) {
					MultipleSpeedRestrictionInputDialog.Submit.setEnabled(false);
					MultipleSpeedRestrictionInputDialog.ResultLabel.setText("Region inside region detected");
					MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setText("!");
					MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setForeground(Color.red);
					MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setFont(new Font("Serif", Font.BOLD, 26));
					MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(j).setText("!");
					MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(j).setForeground(Color.red);
					MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(j).setFont(new Font("Serif", Font.BOLD, 26));
					return;
				}
				else if (StartKmCurr <= StartKmNext && EndKmCurr <= EndKmNext && EndKmCurr > StartKmNext || StartKmNext <= StartKmCurr && EndKmNext <= EndKmCurr && EndKmNext > StartKmCurr) {
					MultipleSpeedRestrictionInputDialog.Submit.setEnabled(false);
					MultipleSpeedRestrictionInputDialog.ResultLabel.setText("Partial overlap detected");
					MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setText("!");
					MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setForeground(Color.red);
					MultipleSpeedRestrictionInputDialog.ErrorCheckLabel1.setFont(new Font("Serif", Font.BOLD, 26));
					MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(j).setText("!");
					MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(j).setForeground(Color.red);
					MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(j).setFont(new Font("Serif", Font.BOLD, 26));
					return;
				}
			}
			if (i < n - 1) {
				for (int j = i + 1; j < n; j++) {
					MultipleSpeedRestrictionInputDialog.ResultLabel.setText("");
					double StartKmCurr = Math.min(Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionstartkmFieldList.get(i).getText()),Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionendkmFieldList.get(i).getText()));
					double StartKmNext = Math.min(Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionstartkmFieldList.get(j).getText()),Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionendkmFieldList.get(j).getText()));
					double EndKmCurr = Math.max(Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionstartkmFieldList.get(i).getText()),Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionendkmFieldList.get(i).getText()));
					double EndKmNext = Math.max(Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionstartkmFieldList.get(j).getText()),Double.valueOf(MultipleSpeedRestrictionInputDialog.SpeedrestrictionendkmFieldList.get(j).getText()));
					if (StartKmCurr <= StartKmNext && EndKmCurr >= EndKmNext || StartKmCurr >= StartKmNext && EndKmCurr <= EndKmNext) {
						MultipleSpeedRestrictionInputDialog.Submit.setEnabled(false);
						MultipleSpeedRestrictionInputDialog.ResultLabel.setText("Region inside region detected");
						MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setText("!");
						MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setForeground(Color.red);
						MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setFont(new Font("Serif", Font.BOLD, 26));
						MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(j).setText("!");
						MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(j).setForeground(Color.red);
						MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(j).setFont(new Font("Serif", Font.BOLD, 26));
						return;
					}
					else if (StartKmCurr <= StartKmNext && EndKmCurr <= EndKmNext && EndKmCurr > StartKmNext || StartKmNext <= StartKmCurr && EndKmNext <= EndKmCurr && EndKmNext > StartKmCurr) {
						MultipleSpeedRestrictionInputDialog.Submit.setEnabled(false);
						MultipleSpeedRestrictionInputDialog.ResultLabel.setText("Partial overlap detected");
						MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setText("!");
						MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setForeground(Color.red);
						MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(i).setFont(new Font("Serif", Font.BOLD, 26));
						MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(j).setText("!");
						MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(j).setForeground(Color.red);
						MultipleSpeedRestrictionInputDialog.ErrorCheckLabelList.get(j).setFont(new Font("Serif", Font.BOLD, 26));
						return;
					}
				}
			}
		}
	}

}
