package input;

import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;

import javax.imageio.ImageIO;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.WindowConstants;

import files.MultipleSpeedRestriction;

public class MultipleSpeedRestrictionInputDialog extends JFrame{

	/**
	 * Title: Multiple Speed Restriction GUI: Copyright: Copyright (c) 2018
	 * Company: IIT
	 * 
	 * @author Abhishek
	 *
	 */
	private static final long serialVersionUID = 1L;
	
	public static JPanel panel = new JPanel();
	public static JLabel DropdownLabel = new JLabel("Number of speed restrictions");
	static Integer[] NumberOfSpeedRestrictionList = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };
	public static JComboBox<Integer> NumberOfSpeedRestriction = new JComboBox<Integer>(NumberOfSpeedRestrictionList);
	public JLabel startkmLabel = new JLabel("Block Start km.");
	public JLabel endkmLabel = new JLabel("Block End km.");
	public JLabel BlockVelocityLabel = new JLabel("Max Speed");
	public JLabel SpeedrestrictionstartkmLabel = new JLabel("<html>Speed Rest.<br>    Start kms.</html>");
	public JLabel SpeedrestrictionendkmLabel = new JLabel("<html>Speed Rest.<br>    End kms.</html>");
	public JLabel SpeedrestrictionmaxspeedLabel = new JLabel("Speed Limit");
	public static JLabel ErrorCheckLabel1 = new JLabel("");
	
	public static JTextField startkmField = new JTextField("");
	public static JTextField endkmField = new JTextField("");
	public static JTextField BlockVelocityField = new JTextField("");
	public static JTextField SpeedrestrictionstartkmField = new JTextField("");
	public static JTextField SpeedrestrictionendkmField = new JTextField("");
	public static JTextField SpeedrestrictionmaxspeedField = new JTextField("");
	
	public static ArrayList<JTextField> SpeedrestrictionstartkmFieldList = new ArrayList<JTextField>();
	public static ArrayList<JTextField> SpeedrestrictionendkmFieldList = new ArrayList<JTextField>();
	public static ArrayList<JTextField> SpeedrestrictionmaxspeedFieldList = new ArrayList<JTextField>();
	public static ArrayList<JLabel> ErrorCheckLabelList = new ArrayList<JLabel>();
	int X = 0;
	int Y = 0;
	public int x = 100;
	public int y = 100;
	public int width = 480;
	public int height = 510;
	public int x1 = 20;
	public int y1 = 20;
	public int panelHeight = 0;
	public int labelWidth = 150;

	public static int labelHeight = 30;
	public int fieldWidth = 100;
	public int fieldHeight = 20;
	public static int buttonWidth = 150;
	public static int buttonHeight = 20;
	public int heightDifference = 40;
	int x2 = x1 + labelWidth + 20;
	int x3 = x2 + fieldWidth + 20;
	int x5 = x3 + fieldWidth + 20;
	int x4 = x1 + 20;
	public static JButton Submit = new JButton("Submit");
	public JButton Cancel = new JButton("Cancel");
	public static JLabel ResultLabel = new JLabel("");
	
	public MultipleSpeedRestrictionInputDialog(int numberofSpeedRest, ArrayList<Double> startKms, ArrayList<Double> endKms, ArrayList<Double> speeds, String startKm, String endKm, String maxSpeed, String speedRestStart, String speedRestEnd, String speedRest) {
		javax.swing.JFrame.setDefaultLookAndFeelDecorated(true);
		javax.swing.JDialog.setDefaultLookAndFeelDecorated(true);
		setTitle("Multiple Speed Restrictions");
		setBounds(x + 200, y + 10, 750, 500);
		setVisible(true);
		setAlwaysOnTop(true);
		try {
			setIconImage(ImageIO.read(new File(System.getProperty("user.dir") + "/res/logo.png")));
		} catch (IOException exc) {
			// exc.printStackTrace();
		}

		System.out.println("ROW VALUE " + BlockInputNewWindow.RowValue);
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		addWindowListener(new java.awt.event.WindowAdapter() {
			@Override
			public void windowClosing(java.awt.event.WindowEvent windowEvent) {
				BlockInputNewWindow.MultipleSpeedRestrictionObject = null;
				setFields(1, null, null, null, "", "", "", "", "", "");
				NumberOfSpeedRestriction.setSelectedIndex(0);
				dispose();
		    }
		});
		addComponents();
		setComponentBounds();
		setComponentActionListeners();
		setFields(numberofSpeedRest, startKms, endKms, speeds, startKm, endKm, maxSpeed, speedRestStart, speedRestEnd, speedRest);
		if (startkmField.getText().equals("") || endkmField.getText().equals("") || BlockVelocityField.getText().equals("") || SpeedrestrictionstartkmField.getText().equals("") || SpeedrestrictionendkmField.getText().equals("") || SpeedrestrictionmaxspeedField.getText().equals("")) {
			Submit.setEnabled(false);
			NumberOfSpeedRestriction.setEnabled(false);
			ResultLabel.setText("Please fill all the fields");
		}
		else if (Double.valueOf(startkmField.getText()) >= Double.valueOf(endkmField.getText())) {
			Submit.setEnabled(false);
			NumberOfSpeedRestriction.setEnabled(false);
			ResultLabel.setText("Block Start Km should be greater than Block End Km");
		}

		add(panel);
		panel.setLayout(null);
	}

	static void setFields(int numberofSpeedRest, ArrayList<Double> startKms, ArrayList<Double> endKms, ArrayList<Double> speeds, String startKm, String endKm, String maxSpeed, String speedRestStart, String speedRestEnd, String speedRest) {
		System.out.println("SetFields: " + startKm + " " + endKm + " " + maxSpeed + " " + speedRestStart + " " + speedRestEnd + " " + speedRest);
		NumberOfSpeedRestriction.setSelectedItem(numberofSpeedRest);
		startkmField.setText(startKm);
		endkmField.setText(endKm);
		BlockVelocityField.setText(maxSpeed);
		SpeedrestrictionstartkmField.setText(speedRestStart);
		SpeedrestrictionendkmField.setText(speedRestEnd);
		SpeedrestrictionmaxspeedField.setText(speedRest);
		for (int i = 1; i < numberofSpeedRest; i++) {
			SpeedrestrictionstartkmFieldList.get(i-1).setText(startKms.get(i-1).toString());
			SpeedrestrictionendkmFieldList.get(i-1).setText(endKms.get(i-1).toString());
			SpeedrestrictionmaxspeedFieldList.get(i-1).setText(speeds.get(i-1).toString());
		}
	}

	public void addComponents() {
		// TODO Auto-generated method stub
		panel.add(DropdownLabel);
		panel.add(NumberOfSpeedRestriction);
		panel.add(startkmLabel);
		panel.add(endkmLabel);
		panel.add(BlockVelocityLabel);
		panel.add(SpeedrestrictionstartkmLabel);
		panel.add(SpeedrestrictionendkmLabel);
		panel.add(SpeedrestrictionmaxspeedLabel);
		panel.add(ErrorCheckLabel1);
		panel.add(startkmField);
		panel.add(endkmField);
		panel.add(BlockVelocityField);
		panel.add(SpeedrestrictionstartkmField);
		panel.add(SpeedrestrictionendkmField);
		panel.add(SpeedrestrictionmaxspeedField);
		panel.add(Submit);
		panel.add(Cancel);
		panel.add(ResultLabel);
	}

	public void setComponentBounds() {
		// TODO Auto-generated method stub
		int x = 20;
		int y = 10;
		int labelwidth = 200;
		int xdiff = labelwidth + 20;
		int ydiff = 25;
		DropdownLabel.setBounds(x, y, labelwidth, fieldHeight);
		x += xdiff;
		NumberOfSpeedRestriction.setBounds(x, y, fieldWidth/2, fieldHeight);
		y += ydiff;
		x = 20;
		xdiff = labelwidth/2 + 20;
		startkmLabel.setBounds(x, y, fieldWidth + 100, fieldHeight);
		x += xdiff;
		endkmLabel.setBounds(x, y, fieldWidth + 100, fieldHeight);
		x += xdiff;
		BlockVelocityLabel.setBounds(x, y, 5 * fieldWidth / 3, fieldHeight);
		x += xdiff;
		SpeedrestrictionstartkmLabel.setBounds(x, y, 2 * fieldWidth, 2 * fieldHeight);
		x += xdiff;
		SpeedrestrictionendkmLabel.setBounds(x, y, 2 * fieldWidth, 2 * fieldHeight);
		x += xdiff;
		SpeedrestrictionmaxspeedLabel.setBounds(x, y, fieldWidth + 100, fieldHeight);
		
		y += 2 * ydiff;
		x = 20;
		xdiff = labelwidth/2 + 20;
		startkmField.setBounds(x, y, fieldWidth, fieldHeight);
		x += xdiff;
		endkmField.setBounds(x, y, fieldWidth, fieldHeight);
		x += xdiff;
		BlockVelocityField.setBounds(x, y, fieldWidth, fieldHeight);
		x += xdiff;
		X = x;
		Y = y;
		SpeedrestrictionstartkmField.setBounds(x, y, fieldWidth, fieldHeight);
		x += xdiff;
		SpeedrestrictionendkmField.setBounds(x, y, fieldWidth, fieldHeight);
		x += xdiff;
		SpeedrestrictionmaxspeedField.setBounds(x, y, fieldWidth, fieldHeight);
		x += xdiff - 10;
		ErrorCheckLabel1.setBounds(x, y, fieldWidth, fieldHeight);
		
		x = 200;
		y = 350;
		Submit.setBounds(x, y, fieldWidth, fieldHeight);
		x += 2 * xdiff;
		Cancel.setBounds(x, y, fieldWidth, fieldHeight);
		x = 20;
		y += ydiff;
		ResultLabel.setBounds(x, y, 1000, labelHeight);
	}

	public void setComponentActionListeners() {
		NumberOfSpeedRestriction.addActionListener(DropDownListener);
		Submit.addMouseListener(SubmitButtonListener());
		Cancel.addActionListener(CancelButtonListener);
		startkmField.getDocument().addDocumentListener(new MultipleSpeedRestrictionFieldOverlapCheck());
		endkmField.getDocument().addDocumentListener(new MultipleSpeedRestrictionFieldOverlapCheck());
		BlockVelocityField.getDocument().addDocumentListener(new MultipleSpeedRestrictionFieldOverlapCheck());
		SpeedrestrictionstartkmField.getDocument().addDocumentListener(new MultipleSpeedRestrictionFieldOverlapCheck());
		SpeedrestrictionendkmField.getDocument().addDocumentListener(new MultipleSpeedRestrictionFieldOverlapCheck());
		SpeedrestrictionmaxspeedField.getDocument().addDocumentListener(new MultipleSpeedRestrictionFieldOverlapCheck());
	}
	
	private MouseListener SubmitButtonListener() {
		MouseListener MouseListener = new MouseListener() {
			@Override
			public void mouseClicked(MouseEvent e) {
			}

			@Override
			public void mouseEntered(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void mouseExited(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void mousePressed(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void mouseReleased(MouseEvent e) {
				if (Submit.isEnabled()) {
					String blockType = null;
					if (BlockInput.UpBlockButton.isSelected())
						blockType = "up";
					else if (BlockInput.DownBlockButton.isSelected())
						blockType = "down";
					else if (BlockInput.CommonBlockButton.isSelected())
						blockType = "common";
					/*for (MultipleSpeedRestriction msr: MultipleSpeedRestriction.MultipleSpeedRestrictionArray) {
						if (msr.BlockTypeParameter.equalsIgnoreCase(blockType) && msr.Row == BlockInputNewWindow.RowValue) {
							System.out.println("Removing :" + msr.BlockTypeParameter + " block, row " + msr.Row);
							MultipleSpeedRestriction.MultipleSpeedRestrictionArray.remove(msr);
							break;
						}
					}*/ // Was introduced to edit the previous value, but since the GUI replicates multiple times, this will remove the latest value as well - Abhishek
					int j = BlockInputNewWindow.RowValue;
					ArrayList<Double> StartKms = new ArrayList<Double>();
					ArrayList<Double> EndKms = new ArrayList<Double>();
					ArrayList<Double> Speeds = new ArrayList<Double>();
					System.out.println("Current Number of Speed Restriction Selected is: " + NumberOfSpeedRestriction.getSelectedItem());
					for (int i = 1; i < Integer.valueOf(NumberOfSpeedRestriction.getSelectedItem().toString()); i++) {
						StartKms.add(Double.valueOf(SpeedrestrictionstartkmFieldList.get(i-1).getText()));
						EndKms.add(Double.valueOf(SpeedrestrictionendkmFieldList.get(i-1).getText()));
						Speeds.add(Double.valueOf(SpeedrestrictionmaxspeedFieldList.get(i-1).getText()));
					}
					System.out.println("j: " + BlockInputNewWindow.RowValue);
					System.out.println(Double.valueOf(startkmField.getText()));
					System.out.println(Double.valueOf(endkmField.getText()));
					System.out.println(Double.valueOf(BlockVelocityField.getText()));
					System.out.println(Double.valueOf(SpeedrestrictionstartkmField.getText()));
					System.out.println(Double.valueOf(SpeedrestrictionendkmField.getText()));
					System.out.println(Double.valueOf(SpeedrestrictionmaxspeedField.getText()));
					new MultipleSpeedRestriction(Integer.valueOf(NumberOfSpeedRestriction.getSelectedItem().toString()), blockType, BlockInputNewWindow.RowValue,  Double.valueOf(startkmField.getText()), Double.valueOf(endkmField.getText()), Double.valueOf(BlockVelocityField.getText()), Double.valueOf(SpeedrestrictionstartkmField.getText()), Double.valueOf(SpeedrestrictionendkmField.getText()), Double.valueOf(SpeedrestrictionmaxspeedField.getText()), StartKms, EndKms, Speeds);
					
					BlockInputNewWindow.startkm1FieldList.get(j).setText(startkmField.getText());
					BlockInputNewWindow.endkm1FieldList.get(j).setText(endkmField.getText());
					BlockInputNewWindow.BlockVelocity1FieldList.get(j).setText(BlockVelocityField.getText());
					BlockInputNewWindow.Speedrestrictionstartkm1FieldList.get(j).setText(SpeedrestrictionstartkmField.getText());
					BlockInputNewWindow.Speedrestrictionendkm1FieldList.get(j).setText(SpeedrestrictionendkmField.getText());
					try {
						BlockInputNewWindow.startkm1FieldList.get(j + 1).setText(endkmField.getText());
					} catch (Exception e1) {
						
					}
					BlockInputNewWindow.Speedrestrictionmaxspeed1FieldList.get(j).setText(SpeedrestrictionmaxspeedField.getText());
					BlockInputNewWindow.MultipleSpeedRestrictionObject = null;
					dispose();
					NumberOfSpeedRestriction.setSelectedIndex(0);
				}
			}
			
		};
		return MouseListener;
	}

	ActionListener CancelButtonListener = new ActionListener() {
		@Override
		public void actionPerformed(ActionEvent e) {
			BlockInputNewWindow.MultipleSpeedRestrictionObject = null;
			setFields(1, null, null, null, "", "", "", "", "", "");
			dispose();
			NumberOfSpeedRestriction.setSelectedIndex(0);
		}
	};
	
	ActionListener DropDownListener = new ActionListener() {
		@Override
		public void actionPerformed(ActionEvent e) {
			ResultLabel.setText(null);
			int Count = (int) NumberOfSpeedRestriction.getSelectedItem();
			Submit.setEnabled(true);
			if (Count > 1) {
				Submit.setEnabled(false);
				ResultLabel.setText("Please fill all the fields");
			}
			int x = X;
			int y = Y;
			int labelwidth = 200;
			int xdiff = labelwidth/2 + 20;
			int ydiff = 25;
			
			for (int i = 0; i < SpeedrestrictionstartkmFieldList.size(); i++) {
				panel.remove(SpeedrestrictionstartkmFieldList.get(i));
				panel.remove(SpeedrestrictionendkmFieldList.get(i));
				panel.remove(SpeedrestrictionmaxspeedFieldList.get(i));
				panel.remove(ErrorCheckLabelList.get(i));
				panel.revalidate();
				panel.repaint();
			}
			SpeedrestrictionstartkmFieldList.clear();
			SpeedrestrictionendkmFieldList.clear();
			SpeedrestrictionmaxspeedFieldList.clear();
			ErrorCheckLabelList.clear();
			JTextField[][] Field = new JTextField[3][Count-1];
			JLabel[] ErrorCheckLabel = new JLabel[Count-1];
			for (int i = 0; i < 3; i++) {
				y = Y;
				for (int j = 0; j < Count - 1; j++) {
					y += ydiff;
					Field[i][j] = new JTextField(null);
					ErrorCheckLabel[j] = new JLabel();
					Field[i][j].setBounds(x, y, fieldWidth, fieldHeight);
					if (i < 1) {
						SpeedrestrictionstartkmFieldList.add(Field[i][j]);
					}
					else if (i < 2) {
						SpeedrestrictionendkmFieldList.add(Field[i][j]);
					}
					else if (i < 3) {
						SpeedrestrictionmaxspeedFieldList.add(Field[i][j]);
						ErrorCheckLabelList.add(ErrorCheckLabel[j]);
						ErrorCheckLabel[j].setBounds(x + xdiff - 10, y, fieldWidth, labelHeight);
						panel.add(ErrorCheckLabel[j]);
						ErrorCheckLabelList.get(j).setText("!");
						ErrorCheckLabelList.get(j).setForeground(Color.red);
						ErrorCheckLabelList.get(j).setFont(new Font("Serif", Font.BOLD, 26));
					}
					Field[i][j].getDocument().addDocumentListener(new MultipleSpeedRestrictionFieldOverlapCheck());
					panel.add(Field[i][j]);
					panel.revalidate();
					panel.repaint();
				}
				x += xdiff;
			}
		}
	};
}