package input;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.LinkedHashSet;

import javax.imageio.ImageIO;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JRootPane;
import javax.swing.WindowConstants;

import globalVariables.FileNames;
import globalVariables.GlobalVar;
import gui.entities.sectionEntities.Station;
import gui.entities.sectionEntities.trackEntities.Block;
import gui.entities.sectionEntities.trackEntities.Loop;
import gui.entities.sectionEntities.trackProperties.Gradient;
import gui.entities.sectionEntities.trackProperties.GradientEffect;
import gui.entities.trainEntities.Train;
import simulator.input.SortStation;

public class SectionInputDialog extends InputDialog {

	private static final long serialVersionUID = 1L;
	public JLabel sectionNameLabel = new JLabel("TextCase Name");

	public JLabel icon = new JLabel();

	public JButton stationButton = new JButton("Station,Loop ");
	public JButton blockButton = new JButton("Block Sections");
	public JButton parameterButton = new JButton("Parameters");
	public JButton gradientButton = new JButton("Gradient");
	public JButton trainButton = new JButton("Trains");
	public JLabel resultLabel = new JLabel("");
	private int labelWidth = 70;
	private int y1 = 20;
	private int x1 = 40;
	private int buttonHeight = 30;
	private int buttonWidth = 190;
	// shashank
	public JButton maintblockButton = new JButton("Maintenance Blocks");
	public JMenuBar menuBar = new JMenuBar();
	public JMenu fileMenu = new JMenu("File");
	public JMenuItem newMenuItem = new JMenuItem("New");
	public JMenuItem openMenuItem = new JMenuItem("Open");
	public JMenuItem saveMenuItem = new JMenuItem("Save");
	public JMenuItem saveAsMenuItem = new JMenuItem("Save As");
	public JMenuItem closeMenuItem = new JMenuItem("Close");

	public ArrayList<Station> stationList = new ArrayList<Station>();
	public ArrayList<Block> blockList = new ArrayList<Block>();
	public static ArrayList<Loop> loopList = new ArrayList<Loop>();
	public ArrayList<Train> trainList = new ArrayList<Train>();
	public static ArrayList<Gradient> gradientFormatList = new ArrayList<Gradient>();
	public static ArrayList<GradientEffect> gradientEffectList = new ArrayList<GradientEffect>();
	// shashank

	public ArrayList<String> blockloopList = new ArrayList<String>();
	public ArrayList<String> starttimeList = new ArrayList<String>();
	public ArrayList<String> endtimeList = new ArrayList<String>();
	public ArrayList<String> directionList = new ArrayList<String>();

	public static DefaultComboBoxModel<String> GradientValue = new DefaultComboBoxModel<>(new String[] { "Select" });// Abhishek
	public static DefaultComboBoxModel<String> MilePosts = new DefaultComboBoxModel<>(new String[] { "Select" });// Abhishek
	public int flag = 1;
	GradientInputDialog gradientInputDialog = null;

	public SectionInputDialog() {
		// super();
		x = 40;
		y = 40;
		this.setBounds(20, 20, 300, 500);

		setUndecorated(true);
		getRootPane().setWindowDecorationStyle(JRootPane.QUESTION_DIALOG);

		try {
			this.setIconImage(ImageIO.read(new File(System.getProperty("user.dir") + "/res/logo.png")));
		} catch (IOException exc) {
			// exc.printStackTrace();
		}

		setComponentActionListeners();
		setComponentBounds();
		addComponents();

		TweakInputDialog.save.setEnabled(false);

		/*
		 * Prompt to save file before closing GUI section - Abhishek
		 */

		this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);

		addWindowListener(new WindowAdapter() {

			@Override
			public void windowClosing(WindowEvent we) {
				if ((stationList.size() != 0 || blockList.size() != 0 || loopList.size() != 0
						|| gradientFormatList.size() != 0 || gradientEffectList.size() != 0 || trainList.size() != 0)
						&& flag == 1) {
					String ObjButtons[] = { "Yes", "No" };
					int PromptResult = JOptionPane.showOptionDialog(null, "     Do you want to save?", "Save",
							JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE, null, ObjButtons, ObjButtons[1]);

					if (PromptResult == 0) {
						try {
							if (FileNames.getTestCaseDirectory().equalsIgnoreCase("")) {
								int response = FileNames.chooseDirectory(FileNames.getTestCaseDirectory(), "save");
								if (response != JFileChooser.APPROVE_OPTION)
									return;
							}

							// saveFiles();

							GlobalVar.getStationInputDialog().write(stationList);
							GlobalVar.getBlockInput().writeBlocks(blockList);
							GlobalVar.getBlockInput().writeLoops(loopList);
							GlobalVar.getParameterInputDialog().write();
							GlobalVar.getGradientInputDialog().write(gradientFormatList);
							GlobalVar.getGradientEffectsInputDialog().write(gradientEffectList);
							GlobalVar.getTrainInputDialog().write(getTrainList(true), true);
							GlobalVar.getTrainInputDialog().write(getTrainList(false), false);
							// shashank
							GlobalVar.getMaintInputDialog().writemaintblocks(blockloopList, starttimeList, endtimeList,
									directionList);
							GlobalVar.getParameterInputDialog().resetAllFields();// Abhishek
							if (!FileNames.getTestCaseDirectory().isEmpty() && !TweakInputDialog.save.isEnabled())
								TweakInputDialog.writeLocoFile(); // Abhishek
							FileNames.writeFilePath();

						} catch (Exception f) {
							// openActionListener.actionPerformed(null);

							FileNames.chooseDirectory(FileNames.getTestCaseDirectory(), "new");
							saveActionListener.actionPerformed(null);
						}
						try {
							saveMenuItem.setEnabled(false);
							saveAsMenuItem.setEnabled(false);
							clearAllLists();
							FileNames.setTestCaseDirectory("");
						} catch (Exception e) {
							e.printStackTrace();
						}
						setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
					}
					if (PromptResult == 1) {
						try {
							saveMenuItem.setEnabled(false);
							saveAsMenuItem.setEnabled(false);
							clearAllLists();
							FileNames.setTestCaseDirectory("");
						} catch (Exception e) {
							e.printStackTrace();
						}

						setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
					}
					if (PromptResult == -1) {
						setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
					}
				} else {
					try {
						saveMenuItem.setEnabled(false);
						saveAsMenuItem.setEnabled(false);
						clearAllLists();
						FileNames.setTestCaseDirectory("");
					} catch (Exception e) {
						e.printStackTrace();
					}

					setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
				}
			}
		});
		/*
		 * 
		 */

		// JScrollPane scrollPane = new JScrollPane(jpanel);
		// this.add(scrollPane);
		this.add(jpanel);

		this.setTitle("Test Case Input");
		// this.setVisible(true);

	}

	@Override
	public void addComponents() {

		this.getContentPane().add(stationButton);
		this.getContentPane().add(parameterButton);
		this.getContentPane().add(gradientButton);
		this.getContentPane().add(trainButton);
		this.getContentPane().add(blockButton);
		this.getContentPane().add(resultLabel);
		this.getContentPane().add(maintblockButton);
		fileMenu.add(newMenuItem);
		fileMenu.add(openMenuItem);
		fileMenu.add(saveMenuItem);
		fileMenu.add(saveAsMenuItem);
		// sneha : enable save and saveas option only if new directory is
		// selected for saving files or opened
		// existing directory with previous files
		saveMenuItem.setEnabled(false);
		saveAsMenuItem.setEnabled(false);
		fileMenu.add(closeMenuItem);
		menuBar.add(fileMenu);
		this.setJMenuBar(menuBar);
	}

	@Override
	public void setComponentBounds() {
		int yDifference = 40;

		// y1 += yDifference;
		// RDSO.setBounds(x1, y1, 150,50);

		y1 += yDifference;
		stationButton.setBounds(x1, y1, buttonWidth, buttonHeight);

		y1 += yDifference;
		blockButton.setBounds(x1, y1, buttonWidth, buttonHeight);

		y1 += yDifference;
		parameterButton.setBounds(x1, y1, buttonWidth, buttonHeight);

		y1 += yDifference;
		gradientButton.setBounds(x1, y1, buttonWidth, buttonHeight);

		y1 += yDifference;
		maintblockButton.setBounds(x1, y1, buttonWidth, buttonHeight);

		y1 += yDifference;
		trainButton.setBounds(x1, y1, buttonWidth, buttonHeight);

		y1 += 7 * yDifference / 2;
		resultLabel.setBounds(x1 / 2, y1, buttonWidth, buttonHeight);

	}

	@Override
	public void setComponentActionListeners() {

		stationButton.addActionListener(stationActionListener);
		blockButton.addActionListener(blockActionListener);
		trainButton.addActionListener(trainActionListener);
		parameterButton.addActionListener(parameterActionListener);
		gradientButton.addActionListener(gradientActionListener);

		saveMenuItem.addActionListener(saveActionListener);
		closeMenuItem.addActionListener(closeActionListener);
		openMenuItem.addActionListener(openActionListener);
		newMenuItem.addActionListener(newMenuItemActionListener);
		saveAsMenuItem.addActionListener(saveAsActionListener);
		maintblockButton.addActionListener(maintblockActionListener);

	}

	ActionListener stationActionListener = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			flag = 1;
			StationInputDialog stationInputDialog = GlobalVar.getStationInputDialog();

			stationInputDialog.setVisible(true);

		}
	};

	ActionListener blockActionListener = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			flag = 1;
			if (stationList.size() > 1) {
				BlockInput blockInput = GlobalVar.getBlockInput();
				blockInput.setVisible(true);
			} else
				resultLabel.setText("Enter min. 2 stations");
		}
	};

	ActionListener trainActionListener = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			flag = 1;
			if (GlobalVar.trainInputDialog == null)
				GlobalVar.trainInputDialog = new TrainInputDialog();
			GlobalVar.trainInputDialog.setVisible(true);
		}
	};

	ActionListener parameterActionListener = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			flag = 1;
			ParameterInputDialog parameterInputDialog = GlobalVar.getParameterInputDialog();
			parameterInputDialog.setVisible(true);
		}
	};

	ActionListener gradientActionListener = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			flag = 1;
			gradientInputDialog = new GradientInputDialog();// GlobalVar.getGradientInputDialog();//Commented by
															// Abhishek
			gradientInputDialog.setVisible(true);
			gradientInputDialog = null;
			System.gc();
		}
	};

	ActionListener maintblockActionListener = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			flag = 1;
			//Maintblock maintblock = GlobalVar.getMaintInputDialog();
			GlobalVar.maintblock = new Maintblock();
			GlobalVar.maintblock.setVisible(true);
		}
	};

	ActionListener newMenuItemActionListener = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			int response = FileNames.chooseDirectory(FileNames.getTestCaseDirectory(), "new");
			if (response == JFileChooser.APPROVE_OPTION) {
				flag = 1;

				// Sneha: Added following two line
				// Enable both option if new test input creation option
				// selected.
				saveMenuItem.setEnabled(true);
				saveAsMenuItem.setEnabled(true);

				clearAllLists();

			}
		}

	};

	ActionListener saveActionListener = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			flag = 0;
			if (FileNames.getTestCaseDirectory().equalsIgnoreCase("")) {
				int response = FileNames.chooseDirectory(FileNames.getTestCaseDirectory(), "save");
				if (response != JFileChooser.APPROVE_OPTION)
					return;
			}

			saveFiles();
		}
	};

	ActionListener saveAsActionListener = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			int response = FileNames.chooseDirectory(FileNames.getTestCaseDirectory(), "save as");
			if (response != JFileChooser.APPROVE_OPTION) {
				flag = 0;
				return;
			}

			saveFiles();
		}
	};
	ActionListener openActionListener = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			int response = FileNames.chooseDirectory(FileNames.getTestCaseDirectory(), "open");

			if (response != JFileChooser.APPROVE_OPTION)
				return;
			try {
				flag = 1;
				clearAllLists();

				GlobalVar.getParameterInputDialog().readParameters();
				GlobalVar.getStationInputDialog().readStations(stationList);
				GlobalVar.getBlockInput().readBlocks(blockList);
				GlobalVar.getBlockInput().readLoops(loopList);
				GlobalVar.getGradientInputDialog().readGradients(gradientFormatList);
				for (Gradient gradient : gradientFormatList) {
					if (GradientValue.getIndexOf(gradient.getGradientValue()) == -1)
						GradientValue.addElement(gradient.getGradientValue());
				}
				GlobalVar.getGradientEffectsInputDialog().readGradientEffects(gradientEffectList);
				GlobalVar.getTrainInputDialog().readScheduledTrains(trainList, stationList.size());
				GlobalVar.getTrainInputDialog().readUnscheduledTrains(trainList);

				// GlobalVar.getParameterInputDialog().readOverlap(); // Abhishek
				TweakInputDialog.readLocoFile();// Abhishek
				// Sneha: Added following two line
				// enable save and save as only if openAction handler does not
				// result in exception
				saveMenuItem.setEnabled(true);
				saveAsMenuItem.setEnabled(true);

			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		}

	};

	ActionListener closeActionListener = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			System.out.println("Closed");
			System.exit(0);
		}
	};

	public Station getStationByStationName(String stationName) {
		int count = 0;

		for (Station station : stationList) {
			if (station.getStationName().equalsIgnoreCase(stationName)) {
				return station;
			}
		}
		return null;
	}

	public String getStationNameByStationId(int stationId) {
		int count = 0;
		String q = null;
		for (Station station : stationList) {
			count++;
			if (stationId == count) {
				q = station.getStationName();
				return q;
			}
		}
		return null;
	}

	public String getStationIdByStationName(String stationId) {
		int count = 1;
		String q = null;
		for (Station station : stationList) {

			if (stationId == station.getStationName())

				q = String.format("%02d", count);
			count++;
			return q;

		}
		return null;
	}

	// Added by Abhishek to return loop numbers to the dropdown menu in the
	// TrainInputDialog

	public static ArrayList<String> LoopListDropDown() {
		ArrayList<String> Loops = new ArrayList<String>();
		Loops.add("Select");
		for (Loop loop : loopList) {
			Loops.add(String.valueOf(loop.blockNo));
		}

		return Loops;

	}

	public Loop getupLoopByStationId(int blockstationId) {
		for (Loop loop : loopList) {
			int loopno = loop.getBlockNo();
			String loopId = String.format("%06d", loopno);
			int loopstationId = Integer.parseInt(loopId.substring(0, 2));
			if (loopstationId == blockstationId)
				return loop;

		}
		return null;
	}

	public void clearAllLists() {
		stationList.clear();
		blockList.clear();
		loopList.clear();
		gradientFormatList.clear();
		gradientEffectList.clear();
		trainList.clear();
		TrainInputDialog.tweakList.clear();

		GradientValue.removeAllElements();
		GradientValue.addElement("Select");
		MilePosts.removeAllElements();
		MilePosts.addElement("Select");

		StationInputDialog.stationNameField.setText("");
		StationInputDialog.startKilometreField.setText("");
		StationInputDialog.endKilometreField.setText("");
	}

	protected void saveFiles() {
		try {
			GlobalVar.getStationInputDialog().write(stationList);
			GlobalVar.getBlockInput().writeBlocks(blockList);
			GlobalVar.getBlockInput().writeLoops(loopList);
			GlobalVar.getParameterInputDialog().write();
			GlobalVar.getGradientInputDialog().write(gradientFormatList);
			GlobalVar.getGradientEffectsInputDialog().write(gradientEffectList);
			GlobalVar.getTrainInputDialog().write(getTrainList(true), true);
			GlobalVar.getTrainInputDialog().write(getTrainList(false), false);
			// shashank
			GlobalVar.getMaintInputDialog().writemaintblocks(blockloopList, starttimeList, endtimeList, directionList);
			GlobalVar.getParameterInputDialog().resetAllFields();// Abhishek
			if (!FileNames.getTestCaseDirectory().isEmpty() && !TweakInputDialog.save.isEnabled())
				TweakInputDialog.writeLocoFile(); // Abhishek
			FileNames.writeFilePath();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void addStation(Station station) {

		stationList.add(station);

		Collections.sort(stationList, new SortStation());

		BlockInput blockInput = GlobalVar.getBlockInput();
		blockInput.updateStationNames();

		ArrayList<Station> tempstationlist = stationList;

		JComboBox<String> stationNameComboBox;
		if (GlobalVar.stationInputDialog != null) {
			stationNameComboBox = GlobalVar.getStationInputDialog().stationNameComboBox;
			stationNameComboBox.removeAllItems();
			for (Station station2 : tempstationlist) {
				stationNameComboBox.addItem(station2.getStationName());
			}
		}

		/*
		 * if (GlobalVar.blockInput != null) { stationNameComboBox =
		 * GlobalVar.getBlockInput().stationNameComboBox;
		 * stationNameComboBox.removeAllItems(); for (Station station2 : stationList) {
		 * stationNameComboBox.addItem(station2.stationName); } }
		 */
		if (GlobalVar.trainInputDialog != null) {
			GlobalVar.trainInputDialog.setTimeTableEntryBounds();
		}
	}

	public String[] getStationNames() {
		String[] stationNames = new String[stationList.size()];
		int i = 0;
		for (Station station : stationList) {
			stationNames[i++] = station.getStationName();
		}

		return stationNames;
	}

	public String[] getPrefinalStationNames() {

		String[] stationNames = new String[stationList.size() - 1];
		int i = 0;
		int j = 0;

		for (Station station : stationList) {
			while (j < stationList.size() - 1) {
				stationNames[i++] = station.getStationName();

				j++;
			}
		}

		return stationNames;

	}

	public void removeStation(Station stationToDelete) {

		// Sneha : before removing station from stationList ensure that
		// corresponding block entries are
		// are removed as well.For that code added up to stationList.remove()
		// function call
		SectionInputDialog sectioninputdialog = GlobalVar.getSectionInputDialog();

		ArrayList<Loop> temploopList = SectionInputDialog.loopList;
		int foundcount = 0x0;
		for (Loop loop : temploopList) {

			if (loop.stationName.equals(stationToDelete.stationName)) {
				foundcount++;
			}
		}

		for (int count = 0x0; count < foundcount; count++) {

			for (Loop loop : temploopList) {
				if (loop.stationName.equals(stationToDelete.stationName)) {
					temploopList.remove(loop);
					break;
				}
			}
		}

		stationList.remove(stationToDelete);

		// After station is removed we have to sort the station array list as
		// per start and end kilometer
		// this will change station id so one need to update loop id
		// accordingly.
		ArrayList<Station> tempstationlist = sectioninputdialog.stationList;
		int count = 0x0;
		for (Station tempstation : tempstationlist) {
			count++;
			for (Loop loop : temploopList) {
				if (loop.stationName.equals(tempstation.stationName)) {
					if ((loop.blockNo / 10000) != count) {
						loop.blockNo = (loop.blockNo - ((loop.blockNo / 10000) * 10000)) + (count * 10000);
					}

				}
			}

		}

		JComboBox<String> stationNameComboBox;
		if (GlobalVar.stationInputDialog != null) {
			stationNameComboBox = GlobalVar.stationInputDialog.stationNameComboBox;
			stationNameComboBox.removeItem(stationToDelete.getStationName());
		}

		/*
		 * if (GlobalVar.blockInput != null) { stationNameComboBox =
		 * GlobalVar.getBlockInput().stationNameComboBox;
		 * stationNameComboBox.removeItem(stationToDelete.stationName); }
		 */
		if (GlobalVar.trainInputDialog != null) {
			GlobalVar.trainInputDialog.setTimeTableEntryBounds();
		}
	}

	public void addBlock(Block block) {
		blockList.add(block);
	}

	public void addLoop(Loop loop) {
		loopList.add(loop);
	}

	public Loop getLoopByBlockNo(int blockNo) {
		for (Loop loop : loopList) {
			if (loop.getBlockNo() == blockNo)
				return loop;
		}
		return null;
	}

	public Block getBlockByBlockNo(int blockNo) {
		for (Block block : blockList) {
			if (block.getBlockNo() == blockNo)
				return block;
		}
		return null;
	}

	public void removeBlock(Block block) {
		blockList.remove(block);
	}

	public void removeLoop(Loop loop) {
		loopList.remove(loop);

	}

	public ArrayList<Train> getTrainList(boolean isScheduled) {
		ArrayList<Train> returnTrainList = new ArrayList<Train>();
		for (Train train : trainList) {
			if (train.isScheduled() == isScheduled) {
				returnTrainList.add(train);
			}
		}

		return returnTrainList;
	}

	public static void main(String[] args) {
		GlobalVar.getInputFileInterface();
	}

	public Train getTrainByTrainNumber(int trainNumber) {
		for (Train train : trainList) {
			if (train.getTrainNo() == trainNumber)
				return train;
		}

		return null;
	}

	public void addTrain(Train train) {
		trainList.add(train);
	}

	public void removeTrain(Train train) {
		trainList.remove(train);
	}

	public void updateStationNames() {
		JComboBox<String> stationNameComboBox;
		Collections.sort(stationList, new SortStation());
		String[] stationNames = getStationNames();
		if (GlobalVar.stationInputDialog != null) {
			stationNameComboBox = GlobalVar.stationInputDialog.stationNameComboBox;
			stationNameComboBox.removeAllItems();
			for (int i = 0; i < stationNames.length; i++) {
				stationNameComboBox.addItem(stationNames[i]);
			}

			GlobalVar.stationInputDialog.repaint();
		}

		/*
		 * if (GlobalVar.blockInput != null) { stationNameComboBox =
		 * GlobalVar.blockInput.stationNameComboBox;
		 * stationNameComboBox.removeAllItems(); for (int i = 0; i <
		 * stationNames.length; i++) { stationNameComboBox.addItem(stationNames[i]); }
		 * 
		 * GlobalVar.blockInput.repaint(); }
		 */
	}

	@SuppressWarnings("unchecked")
	public Gradient getGradientBySlopeDirection(String slopeString, boolean isGradientUp, boolean isGradientlevel,
			String StartMilePost, String EndMilePost) {
		/**
		 * Searches and returns the gradient from the list of gradients. Also returns
		 * the index of the gradient when found which will be used to edit/delete the
		 * corresponding gradient effect.
		 */

		ArrayList<Gradient> gradientList = new ArrayList<Gradient>();
		String directionString = "Up";
		if (!isGradientUp && !isGradientlevel)
			directionString = "Down";
		if (isGradientlevel)
			directionString = "Level";

		int i = 0;
		GradientInputDialog.index = -1;
		for (Gradient gradientFormat : gradientFormatList) {
			i += 1;
			if (gradientFormat.getGradientValue().equalsIgnoreCase(slopeString)
					&& gradientFormat.getDirection().equalsIgnoreCase(directionString)
					&& String.valueOf(gradientFormat.getRelativeStartMilePost()).equals(StartMilePost)
					&& String.valueOf(gradientFormat.getRelativeEndMilePost()).equals(EndMilePost)) {
				GradientInputDialog.index = i;
				return gradientFormat;
			}
		}
		return null;
	}

	public void addGradientFormat(Gradient gradientFormat) {
		gradientFormatList.add(gradientFormat);
		/*
		 * Abhishek
		 */
		DefaultComboBoxModel<String> tempGradientValue = new DefaultComboBoxModel<>(new String[] { "Select" });

		int i = 0;
		for (Gradient g : gradientFormatList) {
			tempGradientValue.addElement(g.getGradientValue());
			// System.out.println("Abhishek Gradient index " +
			// tempGradientValue.getElementAt(i));
			i++;
		}
		SectionInputDialog.GradientValue = tempGradientValue;
		LinkedHashSet<String> check = new LinkedHashSet<>();
		String[] AB = new String[GradientValue.getSize()];
		for (int s = 0; s < GradientValue.getSize(); s++) {
			check.add(GradientValue.getElementAt(s));
			// System.out.println("Abhishek" + GradientValue.getElementAt(s) + "ABs" +
			// AB[s]);
		}
		AB = check.toArray(new String[check.size()]);
		GradientInputDialog.editDeleteSlopeField.setModel(new DefaultComboBoxModel<String>(AB));
		GradientInputDialog.editDeleteSlopeField.setSelectedItem("Select");
	}

	public void removeGradient(Gradient gradientFormat) {
		gradientFormatList.remove(gradientFormat);
	}

	public void addGradientEffect(GradientEffect gradientEffect) {
		gradientEffectList.add(gradientEffect);
	}

	public GradientEffect getGradientEffectBySlopeDirection(String slopeString, boolean isGradientUp) {
		String directionString = "Up";
		if (!isGradientUp)
			directionString = "Down";

		for (GradientEffect gradientEffect : gradientEffectList) {
			if (gradientEffect.getGradientValue().equalsIgnoreCase(slopeString) && GlobalVar
					.getDirectionStringFromDirection(gradientEffect.getDirection()).equalsIgnoreCase(directionString))
				return gradientEffect;
		}

		return null;
	}

	public static GradientEffect getGradientEffectByGradientIndex() { // Abhishek
		/**
		 * This method gets the Gradient Effect (direction, acceleration change and
		 * deceleration change due to gradient) corresponding to a gradient.
		 */
		int i = 0;
		for (GradientEffect gradientEffect : gradientEffectList) {
			if (i == GradientInputDialog.index - 1) {
				System.out.println(i - 1 + " " + gradientEffect.gradientValue + " index");
				return gradientEffect;
			}
			i++;
		}
		return null;
	}

	public void removeGradientEffect(GradientEffect gradientEffect) {
		gradientEffectList.remove(gradientEffect);
	}

}
