package input;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.StreamTokenizer;
import java.math.RoundingMode;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Collections;

import javax.imageio.ImageIO;
import javax.swing.ButtonGroup;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.JRootPane;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.AbstractTableModel;

import files.Tweak;
import globalVariables.FileNames;
import globalVariables.GlobalVar;
import globalVariables.GlobalVariables;
import gui.entities.sectionEntities.Station;
import gui.entities.sectionEntities.time.ReferenceTableEntry;
import gui.entities.sectionEntities.trackEntities.Loop;
import gui.entities.trainEntities.ScheduledTrain;
import gui.entities.trainEntities.Train;
import gui.entities.trainEntities.UnscheduledTrain;
import simulator.input.ChangeTimeTable;

public class TrainInputDialog extends InputDialog {

	/**
	 * 
	 */

	private static final long serialVersionUID = 1L;
	public JLabel trainNumberLabel = new JLabel("Train Number");
	public JTextField trainNumberField = new JTextField();
	public JButton ResetButton = new JButton("Reset"); // Abhishek

	public JLabel trainTypeLabel = new JLabel("Train Type");
	public ButtonGroup trainTypeButtonGroup = new ButtonGroup();
	public JRadioButton passengerTrainRadioButton = new JRadioButton("Scheduled");
	public JRadioButton freightTrainRadioButton = new JRadioButton("Freight");
	public JLabel inputTypeLabel = new JLabel("Input type");
	public ButtonGroup inputTypeButtonGroup = new ButtonGroup();
	public JRadioButton locoloadRadioButton = new JRadioButton("Loco-load combination");
	public JRadioButton traindynamicsRadioButton = new JRadioButton("Train dynamics parameters");
	boolean istraindyanmics;
	public JButton viewLoopButton = new JButton("View Loop Details");
	public JLabel directionLabel = new JLabel("Direction");
	public ButtonGroup directionButtonGroup = new ButtonGroup();
	public JRadioButton upRadioButton = new JRadioButton("Up");
	public JRadioButton downRadioButton = new JRadioButton("Down");
	String X = "Select";

	// Variables for Freight Halting
	public JLabel freighthaltLabel = new JLabel("Number of halts");
	public JComboBox<Integer> freighthaltCombo = new JComboBox();
	public ArrayList<JComboBox> stationComboList = new ArrayList<JComboBox>();
	public ArrayList<JTextField> haltTimeFieldList = new ArrayList<JTextField>();
	public boolean freighthaltFlag = false;
	public JLabel stationNameLabel = new JLabel("Station Name");
	public JLabel haltTimeLabel = new JLabel("Minutes of Halt");

	public JLabel locotype = new JLabel("Loco Type");
	public JTextField locotypefield = new JTextField();
	public JButton tweakbutton = new JButton("Tweak");// Abhishek
	public JButton seeEffect = new JButton("See Effect");// Abhishek
	public static int index = -1;
	public static ArrayList<Tweak> tweakList = new ArrayList<Tweak>();
	public static String[] locotypeList = { "Select", "WDM 2-3000", "WDG 4-3500", "WAP 7-4000", "WAG 7-4500", "WAG 9-5000" };
	public static JComboBox<String> locolist = new JComboBox<String>(locotypeList);

	// public JLabel loadtype = new JLabel("Ignore (See Sec. A.1.)");
	// public JTextField loadtypefield = new JTextField();

	// public JLabel coachno = new JLabel("Num. of coaches (15m/coach)");
	// public JTextField coachnofield = new JTextField();

	public JLabel lengthLabel = new JLabel("Length in m");

	public JTextField lengthField = new JTextField();

	public JLabel accelerationLabel = new JLabel("Acceleration in m/s^2");
	public JTextField accelerationField = new JTextField();

	public JLabel decelerationLabel = new JLabel("Deceleration in m/s^2");
	public JTextField decelerationField = new JTextField();

	/*
	 * public JLabel haltnumberLabel = new JLabel("No. of halts"); public JTextField
	 * haltnumberField = new JTextField();
	 */

	public JLabel stationLabel = new JLabel("Station");
	public JTextField stationField = new JTextField();
	public JComboBox stationLoopsCombo = null;

	public JLabel priorityLabel = new JLabel("Priority");
	public JTextField priorityField = new JTextField();

	public JLabel maximumSpeedLabel = new JLabel("Maximum Speed in km/hr");
	public JTextField maximumSpeedField = new JTextField();

	public JLabel startLoopLabel = new JLabel("Start Loop");
	@SuppressWarnings({ "unchecked", "rawtypes" })
	public JComboBox startLoopField = new JComboBox(SectionInputDialog.LoopListDropDown().toArray()); // JTextField was
																										// replaced by
																										// Abhishek

	public JLabel endLoopLabel = new JLabel("End Loop");

	@SuppressWarnings({ "unchecked", "rawtypes" })
	public JComboBox endLoopField = new JComboBox(SectionInputDialog.LoopListDropDown().toArray()); // JTextField was
																									// replaced by
																									// Abhishek

	public JLabel startTimeLabel = new JLabel("Start Time in HHMM");
	public JTextField startTimeField = new JTextField();

	public JLabel scheduledTrainTimeTableLabel = new JLabel("Timetable");

	public JLabel loopLabel = new JLabel("Loop Id");
	public JTextField loopField = new JTextField();

	public JLabel arrivalTimeLabel = new JLabel("Arrival in HHMM");
	public JTextField arrivalTimeField = new JTextField();

	public JLabel departureTimeLabel = new JLabel("Departure in HHMM");
	public JTextField departureTimeField = new JTextField();
	
	public JLabel ErrorExclamation = new JLabel();

	public JLabel operationDaysLabel = new JLabel("Operation Days e.g. all");
	public JTextField operationDaysField = new JTextField();

	public JButton addButton = new JButton("Add Train");
	public JButton addTimeTableEntryButton = new JButton("Add Timetable entry");

	public JLabel editDeleteOptionLabel = new JLabel("Edit/Delete");

	public JLabel editDeleteTrainNumberLabel = new JLabel("Train Number");
	public JTextField editDeleteTrainNumberField = new JTextField();

	public JButton editButton = new JButton("Edit");
	public JButton deleteButton = new JButton("Delete");
	public JButton updateButton = new JButton("Update");

	// public JButton Button = new JButton("");

	public JLabel Label = new JLabel("");
	public JTextField Field = new JTextField();
	public JRadioButton Button = new JRadioButton("");
	public ButtonGroup ButtonGroup = new ButtonGroup();
	public ArrayList<Station> stationList = null;
	public ArrayList<JComboBox> loopFieldList = new ArrayList<JComboBox>();
	public ArrayList<JTextField> arrivalTimeFieldList = new ArrayList<JTextField>();
	public ArrayList<JTextField> departureTimeFieldList = new ArrayList<JTextField>();
	public ArrayList<JLabel> ErrorExclamationArray = new ArrayList<JLabel>();
	public ArrayList<JTextField> stationFieldList = new ArrayList<JTextField>();
	public ArrayList<JCheckBox> checkHaltFieldList = new ArrayList<JCheckBox>();
	public JMenuBar menuBar = new JMenuBar();
	public JMenu viewMenu = new JMenu("View");
	public JMenuItem allScheduledTrainsMenuItem = new JMenuItem("Scheduled Trains");
	public JMenuItem allFreightTrainsMenuItem = new JMenuItem("Freight Trains");

	public JLabel resultLabel = new JLabel("");
	public JLabel resultLabel1 = new JLabel("");
	public JLabel errorLabel = new JLabel("");
	public Train trainToBeEdited = null;
	public JButton doneButton = new JButton("Done");
	public JLabel noHaltLabel = new JLabel("No stopping");
	public JCheckBox checkHalt = null;

	public static int Flag = 0;

	public TrainInputDialog() {
		x = 30;
		y = 30;
		width = 1250;
		height = 700;
		this.setBounds(x, y, width, height);

		setUndecorated(true);
		getRootPane().setWindowDecorationStyle(JRootPane.INFORMATION_DIALOG);

		try {
			this.setIconImage(ImageIO.read(new File(System.getProperty("user.dir") + "/res/logo.png")));
		} catch (IOException exc) {
			// exc.printStackTrace();
		}
		//System.out.println(TweakInputDialog.locotypeListArray.size());

		if (TweakInputDialog.locotypeListArray.size() != 0) {
			locotypeList = new String[TweakInputDialog.locotypeListArray.size() + 1];
			locotypeList[0] = "Select";
			for (int j = 0; j < TweakInputDialog.locotypeListArray.size(); j++) {
				//System.out.println(TweakInputDialog.locotypeListArray.get(j));
				locotypeList[j + 1] = TweakInputDialog.locotypeListArray.get(j);
			}
			locolist.setModel(new DefaultComboBoxModel<String>(locotypeList));
		}

		stationList = GlobalVar.getSectionInputDialog().stationList;
		Integer[] stationNumberList = new Integer[stationList.size() + 1];
		for (int i = 0; i <= stationList.size(); i++) {
			stationNumberList[i] = i;
		}
		freighthaltCombo = new JComboBox<>(stationNumberList);

		// stationList = GlobalVar.getSectionInputDialog().stationList;

		setComponentActionListeners();
		setComponentBounds();
		addComponents();

		jpanel.setLayout(null);
		jpanel2.setLayout(null);
		scroll.getVerticalScrollBar().setUnitIncrement(16);
		mainPanel.setLayout(new GridLayout(1, 2));
		mainPanel.add(jpanel);
		mainPanel.add(scroll);

		this.add(mainPanel);
		this.setTitle("Train Input");
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		this.addWindowListener(new java.awt.event.WindowAdapter() {
			@Override
			public void windowClosing(java.awt.event.WindowEvent windowEvent) {
				clearTimeTablePanel();
				GlobalVar.trainInputDialog = null;
				System.gc();

				if (TweakInputDialog.save.isEnabled() && TweakInputDialog.flag == 0 && !FileNames.getTestCaseDirectory().equals("")) {
					String ObjButtons[] = { "Yes", "No" };
					int PromptResult = JOptionPane.showOptionDialog(null,
							"Do you want to save updated loco parameters?", "Save", JOptionPane.DEFAULT_OPTION,
							JOptionPane.QUESTION_MESSAGE, null, ObjButtons, ObjButtons[1]);

					@SuppressWarnings("unused")
					int x = JOptionPane.CANCEL_OPTION;

					if (PromptResult == 0) {
						TweakInputDialog.writeLocoFile();
						TweakInputDialog.save.setEnabled(false);
						setDefaultCloseOperation(DISPOSE_ON_CLOSE);
						TweakInputDialog.tweakFrame.dispose();
					}

					if (PromptResult == 1) {
						TweakInputDialog.flag = 1;
						setDefaultCloseOperation(DISPOSE_ON_CLOSE);
						TweakInputDialog.tweakFrame.dispose();
					}

					if (PromptResult == -1) {
						setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
						if (TweakInputDialog.tweakFrame != null)
							TweakInputDialog.tweakFrame.show();
					}
				} else {
					dispose();
					if (TweakInputDialog.tweakFrame != null)
						TweakInputDialog.tweakFrame.dispose();
				}

			}
		});
		// this.setVisible(true);

	}

	@Override
	public void addComponents() {
		viewMenu.add(allFreightTrainsMenuItem);
		viewMenu.add(allScheduledTrainsMenuItem);
		menuBar.add(viewMenu);
		this.setJMenuBar(menuBar);

		jpanel.add(trainNumberLabel);
		jpanel.add(trainNumberField);
		jpanel.add(ResetButton);

		jpanel.add(trainTypeLabel);
		jpanel.add(passengerTrainRadioButton);
		jpanel.add(freightTrainRadioButton);
		trainTypeButtonGroup.add(passengerTrainRadioButton);
		trainTypeButtonGroup.add(freightTrainRadioButton);
		freightTrainRadioButton.setSelected(true);

		jpanel2.add(freighthaltLabel);
		jpanel2.add(freighthaltCombo);

		jpanel.add(inputTypeLabel);
		jpanel.add(locoloadRadioButton);
		jpanel.add(traindynamicsRadioButton);
		inputTypeButtonGroup.add(locoloadRadioButton);
		inputTypeButtonGroup.add(traindynamicsRadioButton);
		locoloadRadioButton.setSelected(true);

		jpanel.add(viewLoopButton);

		jpanel.add(directionLabel);
		jpanel.add(upRadioButton);
		jpanel.add(downRadioButton);
		directionButtonGroup.add(upRadioButton);
		directionButtonGroup.add(downRadioButton);
		upRadioButton.setSelected(true);

		jpanel.add(lengthLabel);

		jpanel.add(lengthField);

		jpanel.add(accelerationLabel);
		jpanel.add(accelerationField);

		jpanel.add(decelerationLabel);
		jpanel.add(decelerationField);

		jpanel.add(priorityLabel);
		jpanel.add(priorityField);

		jpanel.add(maximumSpeedLabel);
		jpanel.add(maximumSpeedField);

		jpanel.add(startLoopLabel);
		jpanel.add(startLoopField);

		jpanel.add(endLoopLabel);
		jpanel.add(endLoopField);

		jpanel.add(startTimeLabel);
		jpanel.add(startTimeField);

		jpanel.add(operationDaysLabel);
		jpanel.add(operationDaysField);

		jpanel2.add(scheduledTrainTimeTableLabel);
		jpanel2.add(stationLabel);
		jpanel2.add(loopLabel);
		jpanel2.add(arrivalTimeLabel);
		jpanel2.add(departureTimeLabel);

		jpanel.add(addButton);

		jpanel.add(editDeleteOptionLabel);
		jpanel.add(editDeleteTrainNumberLabel);
		jpanel.add(editDeleteTrainNumberField);

		/*
		 * jpanel.add(haltnumberLabel); jpanel.add(haltnumberField);
		 */

		jpanel.add(editButton);
		jpanel.add(updateButton);

		jpanel.add(deleteButton);
		jpanel2.add(addTimeTableEntryButton);

		jpanel.add(resultLabel);
		jpanel.add(resultLabel1);
		jpanel.add(errorLabel);
		jpanel.add(doneButton);

		jpanel2.add(arrivalTimeLabel);
		jpanel2.add(departureTimeLabel);

		jpanel.add(addButton);

		jpanel.add(editDeleteOptionLabel);
		jpanel.add(editDeleteTrainNumberLabel);
		jpanel.add(editDeleteTrainNumberField);

		jpanel.add(locotype);
		// jpanel.add(locotypefield);
		jpanel.add(tweakbutton);
		jpanel.add(seeEffect);
		// jpanel.add(loadtype);
		// jpanel.add(loadtypefield);
		jpanel.add(locolist);
		// jpanel.add(coachno);
		// jpanel.add(coachnofield);

		// jpanel.add();
		// jpanel.add();
	}

	@Override
	public void setComponentBounds() {
		int yDifference = 25;
		labelWidth = 180;

		buttonWidth = 100;
		x2 = x1 + labelWidth + 20;
		trainNumberLabel.setBounds(x1, y1, labelWidth, labelHeight);
		trainNumberField.setBounds(x2, y1, fieldWidth, fieldHeight);
		ResetButton.setBounds((int) (trainNumberField.getBounds().getX() + fieldWidth + 80), y1, fieldWidth, fieldHeight);

		y1 += yDifference;
		inputTypeLabel.setBounds(x1, y1, labelWidth, labelHeight);
		locoloadRadioButton.setBounds(x2, y1, fieldWidth + 100, fieldHeight);

		freighthaltLabel.setBounds(x2, y1, labelWidth, labelHeight);
		freighthaltCombo.setBounds(x2 + 100, y1 + 5, fieldWidth, fieldHeight);

		y1 += yDifference;
		traindynamicsRadioButton.setBounds(x2, y1, fieldWidth + 100, fieldHeight);

		y1 += yDifference;
		trainTypeLabel.setBounds(x1, y1, labelWidth, labelHeight);
		freightTrainRadioButton.setBounds(x2, y1, fieldWidth, fieldHeight);
		y1 += yDifference;
		passengerTrainRadioButton.setBounds(x2, y1, fieldWidth, fieldHeight);

		y1 += yDifference;
		directionLabel.setBounds(x1, y1, labelWidth, labelHeight);
		upRadioButton.setBounds(x2, y1, fieldWidth, fieldHeight);
		y1 += yDifference;
		downRadioButton.setBounds(x2, y1, fieldWidth, fieldHeight);

		y1 += yDifference;
		// coachno.setBounds(x1, y1, labelWidth, labelHeight);
		// coachnofield.setBounds(x2, y1, fieldWidth, fieldHeight);

		lengthLabel.setBounds(x1, y1, labelWidth, labelHeight);
		lengthField.setBounds(x2, y1, fieldWidth, fieldHeight);

		y1 += yDifference;
		locotype.setBounds(x1, y1, labelWidth, labelHeight);
		locolist.setBounds(x2, y1, fieldWidth, fieldHeight);
		tweakbutton.setBounds(x2 + fieldWidth + 20, y1, buttonWidth, buttonHeight);

		accelerationLabel.setBounds(x1, y1, labelWidth, labelHeight);
		accelerationField.setBounds(x2, y1, fieldWidth, fieldHeight);

		y1 += yDifference;
		// loadtype.setBounds(x1, y1, labelWidth, labelHeight);
		// loadtypefield.setBounds(x2, y1, fieldWidth, fieldHeight);
		seeEffect.setBounds(x2 + fieldWidth + 20, y1, buttonWidth, buttonHeight);

		decelerationLabel.setBounds(x1, y1, labelWidth, labelHeight);
		decelerationField.setBounds(x2, y1, fieldWidth, fieldHeight);

		y1 += yDifference;
		maximumSpeedLabel.setBounds(x1, y1, labelWidth, labelHeight);
		maximumSpeedField.setBounds(x2, y1, fieldWidth, fieldHeight);

		y1 += yDifference;
		priorityLabel.setBounds(x1, y1, labelWidth, labelHeight);
		priorityField.setBounds(x2, y1, fieldWidth, fieldHeight);

		y1 += yDifference;
		startLoopLabel.setBounds(x1, y1, labelWidth, labelHeight);
		startLoopField.setBounds(x2, y1, fieldWidth, fieldHeight);
		operationDaysLabel.setBounds(x1, y1, labelWidth, labelHeight);
		operationDaysField.setBounds(x2, y1, fieldWidth, fieldHeight);

		y1 += yDifference;

		/*
		 * haltnumberLabel.setBounds(x1, y1, labelWidth, labelHeight);
		 * haltnumberField.setBounds(x2, y1, fieldWidth, fieldHeight);
		 */

		endLoopLabel.setBounds(x1, y1, labelWidth, labelHeight);
		endLoopField.setBounds(x2, y1, fieldWidth, fieldHeight);

		y1 += yDifference;
		startTimeLabel.setBounds(x1, y1, labelWidth, labelHeight);
		startTimeField.setBounds(x2, y1, fieldWidth, fieldHeight);

		y1 += yDifference;
		addButton.setBounds(x1, y1, 150, buttonHeight);
		viewLoopButton.setBounds(x2, y1, 150, buttonHeight);

		y1 += 2 * yDifference;
		editDeleteOptionLabel.setBounds(x1, y1, buttonWidth, labelHeight);

		y1 += yDifference;
		editDeleteTrainNumberLabel.setBounds(x1, y1, labelWidth, labelHeight);
		editDeleteTrainNumberField.setBounds(x2, y1, fieldWidth, fieldHeight);

		y1 += yDifference;
		editButton.setBounds(x1, y1, buttonWidth, buttonHeight);
		deleteButton.setBounds(x2, y1, buttonWidth, buttonHeight);

		y1 += yDifference;
		updateButton.setBounds(x1, y1, buttonWidth, buttonHeight);
		doneButton.setBounds(x2, y1, buttonWidth, buttonHeight);

		y1 += yDifference;
		errorLabel.setBounds(x1, y1, 500, labelHeight);

		y1 += yDifference;
		resultLabel.setBounds(x1, y1, 200, labelHeight);
		resultLabel1.setBounds(x1 + 200, y1, 200, labelHeight);

		// time table entry bounds
		setTimeTableEntryBounds();
	}

	public void setTimeTableEntryBounds() {
		int x0 = 20;
		// x1 = 400;
		// x2 = 500;
		// x3 = 650;
		x1 = 90;
		x2 = 200;
		x3 = 310;
		x4 = 420;
		labelWidth = 150;
		fieldWidth = 90;
		y1 = 20;
		fieldWidth = 70;
		int yDifference = 25;

		scheduledTrainTimeTableLabel.setBounds(x0, y1, 200, labelHeight);

		y1 += yDifference;
		stationLabel.setBounds(x0 + 60, y1, 150, labelHeight);
		loopLabel.setBounds(x1 + 150, y1, 90, labelHeight);
		arrivalTimeLabel.setBounds(x2 + 160, y1, 140, labelHeight);
		departureTimeLabel.setBounds(x3 + 150, y1, 140, labelHeight);
		noHaltLabel.setBounds(x4, y1, 90, labelHeight);
		clearTimeTablePanel();

		for (int i = 0; i < stationList.size(); i++) {
			y1 += yDifference;
			addTimeTableEntry();
			//ErrorExclamation.setText("");
			stationField.setText(stationList.get(i).stationName);
			stationField.setEditable(false);
			stationFieldList.add(stationField);
			stationField.setBounds(x0, y1, 150, fieldHeight);
			GlobalVar.getSectionInputDialog();
			ArrayList loopList = SectionInputDialog.loopList;
			DefaultComboBoxModel loopIds = new DefaultComboBoxModel();
			loopIds.addElement("Select");
			String tempLoopDir = "";
			String tempLoopType = "";
			for (int k = 0; k < loopList.size(); k++) {
				Loop loop = (Loop) loopList.get(k);
				if (loop.stationName.equals(stationList.get(i).stationName)) {
					String blockNo = String.valueOf(loop.getBlockNo());
					if (blockNo.length() == 5) {
						tempLoopDir = blockNo.substring(1, 2);
						tempLoopType = blockNo.substring(1, 3);
					} else if (blockNo.length() == 6) {
						tempLoopDir = blockNo.substring(2, 3);
						tempLoopType = blockNo.substring(2, 4);
					} else if (blockNo.length() == 7) {
						tempLoopDir = blockNo.substring(3, 4);
						tempLoopType = blockNo.substring(3, 5);
					}

					String loopType = "";
					String loopDir = "";
					switch (tempLoopDir) {
					case "0":
						loopDir = "Up";
						break;
					case "1":
						loopDir = "Down";
						break;
					case "2":
						loopDir = "Common";
						break;

					}
					switch (tempLoopType) {
					case "00":
						loopType = "ML";
						break;
					case "10":
						loopType = "ML";
						break;
					case "01":
						loopType = "LL";
						break;
					case "11":
						loopType = "LL";
						break;
					case "21":
						loopType = "CML";
						break;
					case "22":
						loopType = "CUL";
						break;
					case "23":
						loopType = "CDL";
						break;
					}
					if (loopDir.length() <= 4)
						loopIds.addElement(loop.getBlockNo() + "_" + loopDir + "_" + loopType);
					else
						loopIds.addElement(loop.getBlockNo() + "_" + loopDir.substring(0, 3) + "_" + loopType);
				}
			}
			stationLoopsCombo = new JComboBox(loopIds);
			loopFieldList.add(stationLoopsCombo);
			stationLoopsCombo.setBounds(x1 + 110, y1, fieldWidth + 60, fieldHeight);
			// loopField.setBounds(x1, y1, fieldWidth, fieldHeight);
			arrivalTimeField.setBounds(x2 + 170, y1, fieldWidth, fieldHeight);
			departureTimeField.setBounds(x3 + 170, y1, fieldWidth, fieldHeight);
			ErrorExclamation.setBounds((int) (departureTimeField.getBounds().getX() + fieldWidth + 10), y1, fieldWidth, fieldHeight);
			/*
			 * checkHalt=new JCheckBox(); checkHalt.addItemListener(haltItemListener);
			 * checkHaltFieldList.add(checkHalt); checkHalt.setBounds(x4,y1,20,20);
			 */
			jpanel2.add(stationField);
			jpanel2.add(stationLoopsCombo);
			jpanel2.add(arrivalTimeField);
			jpanel2.add(departureTimeField);
			jpanel2.add(ErrorExclamation);
			// jpanel.add(checkHalt);
		}

		panelHeight = y1 + yDifference;
		this.setTimeTableEntryPanelVisible();
	}

	private void clearTimeTablePanel() {
		for (int i = 0; i < loopFieldList.size(); i++) {
			stationLoopsCombo = loopFieldList.get(i);
			arrivalTimeField = arrivalTimeFieldList.get(i);
			departureTimeField = departureTimeFieldList.get(i);
			ErrorExclamation = ErrorExclamationArray.get(i);
			// checkHalt=checkHaltFieldList.get(i);
			jpanel2.remove(stationField);
			jpanel2.remove(stationLoopsCombo);
			jpanel2.remove(arrivalTimeField);
			jpanel2.remove(departureTimeField);
			jpanel2.remove(ErrorExclamation);
			// jpanel.remove(checkHalt);
		}
	}

	private void addTimeTableEntry() {
		arrivalTimeField = new JTextField();
		departureTimeField = new JTextField();
		stationField = new JTextField();
		ErrorExclamation = new JLabel();
		// checkHalt=new JCheckBox();
		// loopFieldList.add(stationLoopsCombo);

		arrivalTimeFieldList.add(arrivalTimeField);
		departureTimeFieldList.add(departureTimeField);
		ErrorExclamationArray.add(ErrorExclamation);
		// checkHaltFieldList.add(checkHalt);
	}

	@Override
	public void setComponentActionListeners() {

		ResetButton.addActionListener(ResetButtonListener);
		locoloadRadioButton.addItemListener(inputTypeItemListener);
		traindynamicsRadioButton.addItemListener(inputTypeItemListener);
		passengerTrainRadioButton.addItemListener(trainTypeItemListener);
		freightTrainRadioButton.addItemListener(trainTypeItemListener);
		allFreightTrainsMenuItem.addActionListener(viewAllFreightTrainsActionListener);
		allScheduledTrainsMenuItem.addActionListener(viewAllScheduledTrainsActionListener);
		addButton.addActionListener(addActionListener);
		editButton.addActionListener(editActionListener);
		deleteButton.addActionListener(deleteActionListener);
		updateButton.addActionListener(updateActionListener);
		doneButton.addActionListener(DoneActionListener);
		viewLoopButton.addActionListener(viewLoopActionListener);
		locolist.addActionListener(locolistActionListener);
		seeEffect.addActionListener(seeEffectActionListener);// Abhishek
		tweakbutton.addActionListener(tweakActionListener);// Abhishek

		freighthaltCombo.addActionListener(freighthaltActionListner);

	}

	ActionListener ResetButtonListener = new ActionListener() {
		@Override
		public void actionPerformed(ActionEvent arg0) {
			trainNumberField.setText("");
			lengthField.setText("");
			locolist.setSelectedItem("Select");
			accelerationField.setText("");
			decelerationField.setText("");
			maximumSpeedField.setText("");
			priorityField.setText("");
			editDeleteTrainNumberField.setText("");
			if (passengerTrainRadioButton.isSelected()) {
				for (int i = 0; i < stationFieldList.size(); i++) {
					loopFieldList.get(i).setSelectedItem("Select");
					arrivalTimeFieldList.get(i).setText("");
					departureTimeFieldList.get(i).setText("");
					ErrorExclamationArray.get(i).setText("");
				}
				operationDaysField.setText("");
			}
			else {
				startLoopField.setSelectedItem("Select");
				endLoopField.setSelectedItem("Select");
				startTimeField.setText("");
				freighthaltCombo.setSelectedIndex(0);
			}
		}
	};

	ActionListener tweakActionListener = new ActionListener() {
		@Override
		public void actionPerformed(ActionEvent arg0) {
			if (locolist.getSelectedItem().equals("Select")) {
				TweakInputDialog.TEField.setVisible(false);
				TweakInputDialog.decField.setVisible(false);
				TweakInputDialog.speedField.setVisible(false);
				TweakInputDialog.loadField.setVisible(false);
				TweakInputDialog.accField.setVisible(false);
			} else {
				TweakInputDialog.TEField.setVisible(true);
				TweakInputDialog.decField.setVisible(true);
				TweakInputDialog.speedField.setVisible(true);
				TweakInputDialog.loadField.setVisible(true);
				TweakInputDialog.accField.setVisible(true);
			}
			index = locolist.getSelectedIndex();
			//GlobalVar.getTweakInputDialog();
			GlobalVar.tweakInputDialog = new TweakInputDialog();
			TweakInputDialog.tweakFrame.setVisible(true);
		}
	};

	ActionListener seeEffectActionListener = new ActionListener() {
		@Override
		public void actionPerformed(ActionEvent arg0) {
			TweakInputDialog.setFields();
			DecimalFormat df = new DecimalFormat("#.###");
			df.setRoundingMode(RoundingMode.CEILING);
			String X = locolist.getSelectedItem().toString();
			double acceleration = 0;
			double deceleration = 0;
			double maximumSpeed = 0;
			int flag = 0;
			for (Tweak tweak : TrainInputDialog.tweakList) {
				if (tweak.locoType.equalsIgnoreCase(X.split("-")[0]) && (int) tweak.load == Integer.valueOf(X.split("-")[1])) {
					System.out.println(tweak.locoType + " HIIII " + tweak.load);
					flag = 1;
					acceleration = tweak.acceleration;
					deceleration = tweak.deceleration;
					maximumSpeed = tweak.maximumSpeed;
					break;
				}
			}
			if (flag == 1) {
				accelerationField.setText(String.valueOf(df.format(acceleration)));
				decelerationField.setText(String.valueOf(df.format(deceleration)));
				maximumSpeedField.setText(String.valueOf(df.format(maximumSpeed)));
			} else {
				accelerationField.setText("");
				decelerationField.setText("");
				maximumSpeedField.setText("");
			}

			traindynamicsRadioButton.doClick();
			resultLabel1.setText("");
			resultLabel.setText("");
		}
	};

	ActionListener LoopListActionListener = new ActionListener() {
		@Override
		public void actionPerformed(ActionEvent arg0) {
			{
				for (int i = 0; i <= stationFieldList.size() - 1; i++) {
					if (loopFieldList.get(i).getSelectedItem().equals("Select")) {
						arrivalTimeFieldList.get(i).setVisible(false);
						arrivalTimeFieldList.get(i).setText("");
						departureTimeFieldList.get(i).setVisible(false);
						departureTimeFieldList.get(i).setText("");
						ErrorExclamationArray.get(i).setText("");
					} else {
						arrivalTimeFieldList.get(i).setVisible(true);
						departureTimeFieldList.get(i).setVisible(true);
					}
				}
			}
		}
	};

	ActionListener freighthaltActionListner = new ActionListener() {
		@Override
		public void actionPerformed(ActionEvent arg0) {
			{

				String x = String.valueOf(freighthaltCombo.getSelectedItem());
				int foo = Integer.parseInt(x);
				freighthaltGenerator(foo);
			}
		}
	};

	/**
	 * Vidyadhar This function gets 'x' as input which is no. of scheduled halts for
	 * a freight train. Then the function generates stationCombos and haltTimeField
	 * corresponding to the no. of scheduled halts. To record changes made while
	 * entering, freighthaltFlag is used freighthaltFlag is by default set as
	 * 'false'. Once the first entry is made, it is been set as 'true. With this,
	 * the function clears all past entry and records new entries.
	 * 
	 * @param x
	 */
	void freighthaltGenerator(int x) {

		// Checking whether entry is already made or not
		if (freighthaltFlag) {
			for (int i = 0; i < stationComboList.size(); i++) {
				// blockNumberField = blockNumberFieldList.get(i);
				// minutesField = minutesFieldList.get(i);
				// totalMinutesField = totalMinutesFieldList.get(i);

				jpanel2.remove(stationComboList.get(i));
				// jpanel.remove(minutesField);
				jpanel2.remove(haltTimeFieldList.get(i));
				jpanel2.revalidate();
				jpanel2.repaint();
			}
			stationComboList.clear();
			// minutesFieldList.clear();
			haltTimeFieldList.clear();

		}

		int x1 = 20;
		int x2 = 220;
		int y1 = 95;
		int ydifference = 25;
		int y2 = 95;
		SectionInputDialog sectioninputdialog = GlobalVar.getSectionInputDialog();
		ArrayList<Station> stationlist = sectioninputdialog.stationList;
		String[] stationNameList = new String[stationlist.size()];
		JComboBox[] stationCombo = new JComboBox[x];
		JTextField[] haltTimeField = new JTextField[x];

		if (x != 0) {
			stationNameLabel.setBounds(x1, y1, labelWidth, labelHeight);
			haltTimeLabel.setBounds(x2, y1, labelWidth, labelHeight);
			jpanel2.add(stationNameLabel);
			jpanel2.add(haltTimeLabel);
			jpanel2.revalidate();
			jpanel2.repaint();
			jpanel2.setLayout(null);
		}

		for (int i = 0; i < stationlist.size(); i++) {
			stationNameList[i] = String.valueOf(stationlist.get(i).getStationName());
		}

		for (int i = 0; i < 2; i++) {
			for (int j = 0; j < x; j++) {
				if (i == 0) {
					stationCombo[j] = new JComboBox(stationNameList);
					stationComboList.add(stationCombo[j]);
					y1 += ydifference;
					stationCombo[j].setBounds(x1, y1, 2 * fieldWidth, fieldHeight);
					jpanel2.add(stationCombo[j]);

					jpanel2.revalidate();
					jpanel2.repaint();
					jpanel2.setLayout(null);

				} else if (i == 1) {
					haltTimeField[j] = new JTextField();
					haltTimeFieldList.add(haltTimeField[j]);
					y2 += ydifference;
					haltTimeField[j].setBounds(x2, y2, 2 * fieldWidth, fieldHeight);
					jpanel2.add(haltTimeField[j]);

					jpanel2.revalidate();
					jpanel2.repaint();
					jpanel2.setLayout(null);
				}

			}

		}
		freighthaltFlag = true; // Setting true, if entries is made
	}

	/*
	 * ItemListener haltItemListener=new ItemListener(){ public void
	 * itemStateChanged(ItemEvent arg0) { System.out.println("Hikjdfslakdfjlasjkd");
	 * if(checkHalt.isSelected()==true){ stationLoopsCombo.setEnabled(false);
	 * arrivalTimeField.setEnabled(false); departureTimeField.setEnabled(false);
	 * System.out.println("selected"); }else{ stationLoopsCombo.setEnabled(true);
	 * arrivalTimeField.setEnabled(true); departureTimeField.setEnabled(true);
	 * System.out.println("please check"); } } };
	 */
	ActionListener locolistActionListener = new ActionListener() {
		@Override
		public void actionPerformed(ActionEvent arg0) {

			X = String.valueOf(locolist.getSelectedItem());
		}
	};

	ActionListener editActionListener = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			if (editDeleteTrainNumberField.getText().isEmpty()) {
				resultLabel1.setText("");
				resultLabel.setText("Input train number to edit or delete a train");
				return;
			}

			try {
				int trainNumber = Integer.parseInt(editDeleteTrainNumberField.getText());
				Train findTrain = GlobalVar.getSectionInputDialog().getTrainByTrainNumber(trainNumber);
				if (findTrain == null) {
					resultLabel1.setText("");
					resultLabel.setText("No train " + trainNumber + " exists");
					return;
				}

				setFieldsFromTrainAttributes(findTrain);
				traindynamicsRadioButton.setSelected(true);
				trainToBeEdited = findTrain;
				resultLabel1.setText("");
				resultLabel.setText("Train " + trainNumber + " is shown");
			} catch (Exception ex) {
				resultLabel1.setText("");
				resultLabel.setText("Check train number field for edit/delete option");
			}
		}
	};

	ActionListener deleteActionListener = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			if (editDeleteTrainNumberField.getText().isEmpty()) {
				resultLabel1.setText("");
				resultLabel.setText("Input train number to edit or delete a train");
				return;
			}

			try {
				int trainNumber = Integer.parseInt(editDeleteTrainNumberField.getText());
				Train findTrain = GlobalVar.getSectionInputDialog().getTrainByTrainNumber(trainNumber);
				if (findTrain == null) {
					resultLabel1.setText("");
					resultLabel.setText("No train " + trainNumber + " exists");
					return;
				}
				GlobalVar.getSectionInputDialog().removeTrain(findTrain);
				resultLabel1.setText("");
				resultLabel.setText("Train " + trainNumber + " deleted");

			} catch (Exception ex) {
				resultLabel1.setText("");
				resultLabel.setText("Check train number field for edit/delete option");
			}
		}
	};

	ItemListener trainTypeItemListener = new ItemListener() {

		@Override
		public void itemStateChanged(ItemEvent arg0) {
			// TrainInputDialog trainInputDialog =
			// GlobalVar.getTrainInputDialog();

			mainPanel.repaint();
			boolean isFreightTrain = freightTrainRadioButton.isSelected();

			operationDaysLabel.setVisible(!isFreightTrain);
			operationDaysField.setVisible(!isFreightTrain);
			/*
			 * haltnumberLabel.setVisible(!isFreightTrain);
			 * haltnumberField.setVisible(!isFreightTrain);
			 */
			// loadtype.setVisible(isFreightTrain && !istraindyanmics);
			// loadtypefield.setVisible(isFreightTrain && !istraindyanmics);
			// loadtypefield.disable(); // Load in tonnes disabled by Abhishek
			lengthLabel.setVisible(true);
			/*
			 * lengthLabel.setVisible(isFreightTrain || istraindyanmics);
			 * lengthField.setVisible(isFreightTrain || istraindyanmics);
			 * coachno.setVisible(!isFreightTrain && !istraindyanmics);
			 * coachnofield.setVisible(!isFreightTrain && !istraindyanmics);
			 */

			haltTimeLabel.setVisible(isFreightTrain);
			stationNameLabel.setVisible(isFreightTrain);
			startLoopLabel.setVisible(isFreightTrain);
			startLoopField.setVisible(isFreightTrain);

			endLoopLabel.setVisible(isFreightTrain);
			endLoopField.setVisible(isFreightTrain);

			startTimeLabel.setVisible(isFreightTrain);
			startTimeField.setVisible(isFreightTrain);

			freighthaltLabel.setVisible(isFreightTrain);
			freighthaltCombo.setVisible(isFreightTrain);

			setTimeTableEntryPanelVisible(isFreightTrain);

			if (passengerTrainRadioButton.isSelected()) {
				// trainInputDialog.setBounds(x, y, 1000, 600);

				freighthaltCombo.setSelectedItem(0);
				for (int i = 0; i <= stationFieldList.size() - 1; i++) {
					if (loopFieldList.get(i).getSelectedItem().equals("Select")) {
						arrivalTimeFieldList.get(i).setVisible(false);
						departureTimeFieldList.get(i).setVisible(false);
						ErrorExclamationArray.get(i).setText("");
					}
				}

				priorityLabel.setText("Priority (1 to 5)");
				for (int i = 0; i <= stationFieldList.size() - 1; i++)
					loopFieldList.get(i).addActionListener(LoopListActionListener);
				jpanel2.setPreferredSize(new Dimension(width / 2, panelHeight));
				jpanel2.repaint();
			} else {
				priorityLabel.setText("Priority (6 to 10)");
				jpanel2.setPreferredSize(new Dimension(0, 0));
				jpanel2.repaint();
			}
		}

	};

	ItemListener inputTypeItemListener = new ItemListener() {

		@Override
		public void itemStateChanged(ItemEvent arg0) {
			// TrainInputDialog trainInputDialog =
			// GlobalVar.getTrainInputDialog();

			istraindyanmics = traindynamicsRadioButton.isSelected();

			accelerationLabel.setVisible(istraindyanmics);
			decelerationLabel.setVisible(istraindyanmics);
			accelerationField.setVisible(istraindyanmics);
			decelerationField.setVisible(istraindyanmics);
			// lengthLabel.setVisible(istraindyanmics);
			// lengthField.setVisible(istraindyanmics);

			locotype.setVisible(!istraindyanmics);
			// loadtype.setVisible(!istraindyanmics);

			locolist.setVisible(!istraindyanmics);
			// loadtypefield.setVisible(!istraindyanmics);
			tweakbutton.setVisible(!istraindyanmics);
			seeEffect.setVisible(!istraindyanmics);
			// coachno.setVisible(!istraindyanmics);
			// coachnofield.setVisible(!istraindyanmics);

			// freighthaltLabel.setVisible(!istraindyanmics);
			// freighthaltCombo.setVisible(!istraindyanmics);

			maximumSpeedLabel.setVisible(istraindyanmics);
			maximumSpeedField.setVisible(istraindyanmics);
			// santhosh
			/*
			 * if (freightTrainRadioButton.isSelected() && locoloadRadioButton.isSelected())
			 * { lengthLabel.setVisible(!istraindyanmics);
			 * lengthField.setVisible(!istraindyanmics);
			 * coachno.setVisible(istraindyanmics);
			 * coachnofield.setVisible(istraindyanmics); } else if
			 * (freightTrainRadioButton.isSelected() &&
			 * traindynamicsRadioButton.isSelected()) {
			 * lengthLabel.setVisible(istraindyanmics);
			 * lengthField.setVisible(istraindyanmics);
			 * coachno.setVisible(!istraindyanmics);
			 * coachnofield.setVisible(!istraindyanmics); } else if
			 * (passengerTrainRadioButton.isSelected() &&
			 * traindynamicsRadioButton.isSelected()) {
			 * lengthLabel.setVisible(istraindyanmics);
			 * lengthField.setVisible(istraindyanmics);
			 * coachno.setVisible(!istraindyanmics);
			 * coachnofield.setVisible(!istraindyanmics); } else if
			 * (passengerTrainRadioButton.isSelected() && locoloadRadioButton.isSelected())
			 * { lengthLabel.setVisible(istraindyanmics);
			 * lengthField.setVisible(istraindyanmics);
			 * coachno.setVisible(!istraindyanmics);
			 * coachnofield.setVisible(!istraindyanmics); }
			 */

		}

	};

	ActionListener DoneActionListener = new ActionListener() {
		@Override
		public void actionPerformed(ActionEvent arg0) {
			GlobalVar.trainInputDialog = null;
			System.gc();
			clearTimeTablePanel();

			if (TweakInputDialog.save.isEnabled() && TweakInputDialog.flag == 0) {
				String ObjButtons[] = { "Yes", "No" };
				int PromptResult = JOptionPane.showOptionDialog(null, "Do you want to save updated loco parameters?",
						"Save", JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE, null, ObjButtons,
						ObjButtons[1]);

				@SuppressWarnings("unused")
				int x = JOptionPane.CANCEL_OPTION;

				if (PromptResult == 0) {
					TweakInputDialog.writeLocoFile();
					TweakInputDialog.save.setEnabled(false);
					setDefaultCloseOperation(DISPOSE_ON_CLOSE);
					TweakInputDialog.tweakFrame.dispose();
				}

				if (PromptResult == 1) {
					TweakInputDialog.flag = 1;
					setDefaultCloseOperation(DISPOSE_ON_CLOSE);
					TweakInputDialog.tweakFrame.dispose();
				}

				if (PromptResult == -1) {
					setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
					if (TweakInputDialog.tweakFrame != null)
						TweakInputDialog.tweakFrame.show();
				}
			} else {
				dispose();
				if (TweakInputDialog.tweakFrame != null)
					TweakInputDialog.tweakFrame.dispose();
			}

		}
	};

	ActionListener updateActionListener = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			if (trainNumberField.getText().isEmpty()) {
				resultLabel1.setText("");
				resultLabel.setText("Train number cannot be empty");
				return;
			}

			try {
				Train train = trainToBeEdited;
				if (train == null) {
					resultLabel1.setText("");
					resultLabel.setText("Choose the train to be updated again");
					return;
				}

				train.refTables.clear();

				// If there is error in user input regarding Freight halts
				if (setTrainProperties(train) == 0)
					return;

				resultLabel1.setText("");
				resultLabel.setText("Train " + train.trainNo + " updated");
			} catch (Exception ex) {
				resultLabel.setText("Check all inputs");
			}
		}
	};

	ActionListener addActionListener = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			if (trainNumberField.getText().isEmpty()) {
				resultLabel1.setText("");
				resultLabel.setText("Train number cannot be empty");
				return;
			}

			if (!traindynamicsRadioButton.isSelected() && locolist.getSelectedItem().toString().equalsIgnoreCase("select")) {
				resultLabel1.setText("");
				resultLabel.setText("Please select LocoType");
				return;
			}
			SectionInputDialog sectioninputdialog = GlobalVar.getSectionInputDialog();
			Train train;
			if (passengerTrainRadioButton.isSelected()) {
				train = new ScheduledTrain();
			} else
				train = new UnscheduledTrain();

			try {
				int trainNumber = Integer.parseInt(trainNumberField.getText());
				Train findTrain = sectioninputdialog.getTrainByTrainNumber(trainNumber);
				if (findTrain != null) {
					resultLabel1.setText("");
					resultLabel.setText("Train " + trainNumber + " already exists");
					return;
				}
				// If there is error in user input regarding Freight halts
				if (setTrainProperties(train) == 0)
					return;

				sectioninputdialog.addTrain(train);
				resultLabel1.setText("");
				resultLabel.setText("Train " + train.trainNo + " added");
				/*
				 * Abhishek added the following lines
				 */
				trainNumberField.setText(String.valueOf(train.trainNo));
				if (train.scheduled)
					passengerTrainRadioButton.setSelected(true);
				else
					freightTrainRadioButton.setSelected(true);
				lengthField.setText(String.valueOf(train.length * 1000));
				accelerationField.setText(String.valueOf(train.accParam));
				decelerationField.setText(String.valueOf(train.deceParam));
				priorityField.setText(String.valueOf(train.priority));
				maximumSpeedField.setText(String.valueOf(train.maximumPossibleSpeed));

				if (train.scheduled) {

					locolist.setSelectedIndex(((int) (train.accParam)));
					// coachnofield.setText(String.valueOf(Math.round(train.length / .015)));

					ScheduledTrain sTrain = (ScheduledTrain) train;
					operationDaysField.setText(sTrain.operatingDays);
				}
				/*
				 * 
				 */

			} catch (Exception ex) {
				resultLabel.setText("Check all inputs");
			}
		}
	};

	private int addReferenceTimeTableEntries(Train train) {
		for (int i = 0; i < arrivalTimeFieldList.size(); i++) {
			ErrorExclamationArray.get(i).setText("");
			String tempLoopNo = loopFieldList.get(i).getItemAt(loopFieldList.get(i).getSelectedIndex()).toString();
			if (!tempLoopNo.equals("Select")) {
				String[] tempLoopDetails = tempLoopNo.split("_");
				/*
				 * if(tempLoopNo.charAt(5)=='_') loopNo =
				 * Integer.parseInt(tempLoopNo.substring(0,5)); else
				 * loopNo=Integer.parseInt(tempLoopNo.substring(0,6));
				 */
				int loopNo = Integer.parseInt(tempLoopDetails[0]);
				String loopDir = tempLoopDetails[1];
				String loopType = tempLoopDetails[2];
				if (loopType.equals("Com"))
					loopType = "Common";
				String tempArrivalField = arrivalTimeFieldList.get(i).getText();
				String tempDepartureField = departureTimeFieldList.get(i).getText();
				if (!tempArrivalField.isEmpty() && tempArrivalField.length() == 4 && !tempDepartureField.isEmpty()
						&& tempDepartureField.length() == 4) {
					int ArrHr = Integer.valueOf(tempArrivalField.substring(0, 2));
					int ArrMin = Integer.valueOf(tempArrivalField.substring(2, 4));
					int DepHr = Integer.valueOf(tempDepartureField.substring(0, 2));
					int DepMin = Integer.valueOf(tempDepartureField.substring(2, 4));
					if (ArrHr >= 0 && ArrMin >= 0 && ArrMin < 60 && DepHr >= 0	&& DepMin >= 0 && DepMin < 60) {
						int arrivalTimeInput = Integer.parseInt(tempArrivalField + "00");
						int departureTimeInput = Integer.parseInt(tempDepartureField + "00");
						// santhosh
						String stationName = stationFieldList.get(i).getText();
						ReferenceTableEntry referenceTableEntry = new ReferenceTableEntry(loopNo, arrivalTimeInput,
								departureTimeInput, stationName, loopType, loopDir);
						train.refTables.add(referenceTableEntry);
					} else {
						ErrorExclamationArray.get(i).setText("!");
						ErrorExclamationArray.get(i).setFont(new Font("Serif", Font.BOLD, 26));
						ErrorExclamationArray.get(i).setForeground(Color.red);
						return -1;
					}
				} else {
					ErrorExclamationArray.get(i).setText("!");
					ErrorExclamationArray.get(i).setFont(new Font("Serif", Font.BOLD, 26));
					ErrorExclamationArray.get(i).setForeground(Color.red);
					return -1;
				}
			}
		}
		return 1;
	}

	protected int setTrainProperties(Train train) throws Exception {
		// String load = loadtypefield.getText();
		int trainNumber = Integer.parseInt(trainNumberField.getText());

		boolean isScheduled = passengerTrainRadioButton.isSelected();

		int direction = GlobalVar.UP_DIRECTION;
		if (downRadioButton.isSelected())
			direction = GlobalVar.DOWN_DIRECTION;
		double length = 0;
		double acceleration = 0;
		double deceleration = 0;
		double maximumSpeed = 0;
		if (isScheduled && !istraindyanmics) {
			length = (Double.parseDouble(lengthField.getText())) / 1000;
			for (Tweak tweak : TrainInputDialog.tweakList) {
				if (tweak.locoType.equals(X.split("-")[0])) {
					acceleration = tweak.acceleration;
					deceleration = tweak.deceleration;
					maximumSpeed = tweak.maximumSpeed;
				}
			}

		} else if (!isScheduled && !istraindyanmics) {
			length = (Double.parseDouble(lengthField.getText())) / 1000;
			for (Tweak tweak : TrainInputDialog.tweakList) {
				if (tweak.locoType.equals(X.split("-")[0])) {
					acceleration = tweak.acceleration;
					deceleration = tweak.deceleration;
					maximumSpeed = tweak.maximumSpeed;
				}
			}

		} else {
			length = (Double.parseDouble(lengthField.getText())) / 1000;
			acceleration = Double.parseDouble(accelerationField.getText());
			deceleration = Double.parseDouble(decelerationField.getText());
			maximumSpeed = Double.parseDouble(maximumSpeedField.getText());

		}

		double priority = Double.parseDouble(priorityField.getText());
		// System.out.println("TrainInput.setTrainProperties trainNumber: "+
		// trainNumber+
		// " Priority: "+ priority);
		train.trainNo = trainNumber;
		train.scheduled = isScheduled;
		train.direction = direction;
		train.length = length;
		train.accParam = acceleration;
		train.deceParam = deceleration;
		train.priority = priority;
		train.maximumPossibleSpeed = maximumSpeed;

		if (isScheduled) {

			if (operationDaysField.getText().isEmpty()) {
				resultLabel1.setText("Enter operation days");
				throw new Exception();
			}
			// edited by santhosh 06/11/2015
			// int haltnumber = Integer.parseInt(haltnumberField.getText());
			int haltnumber = 0;
			for (int m = 0; m < arrivalTimeFieldList.size(); m++) {
				String a = arrivalTimeFieldList.get(m).getText();
				if (!arrivalTimeFieldList.get(m).getText().equals("")) {
					haltnumber = haltnumber + 1;

				}
			}

			if (haltnumber < 2) { // Abhishek
				resultLabel1.setText("Enter at least 2 halts");
				throw new Exception();
			}

			ScheduledTrain sTrain = (ScheduledTrain) train;
			sTrain.operatingDays = operationDaysField.getText();
			sTrain.numberofhalts = haltnumber;
			int value = addReferenceTimeTableEntries(train);
			if (value == -1) { // Abhishek
				resultLabel1.setText("Invalid Arrival/Departure (HHMM)");
				throw new Exception();
			}

		} else {
			int numberOfHalts = Integer.parseInt(String.valueOf(freighthaltCombo.getSelectedItem()));
			int startLoop = Integer.parseInt(startLoopField.getSelectedItem().toString());
			int endLoop = Integer.parseInt(endLoopField.getSelectedItem().toString());
			int startTimeInput = Integer.parseInt(startTimeField.getText());
			int endStationCode = 0;
			SectionInputDialog sectioninputdialog = GlobalVar.getSectionInputDialog();
			ArrayList<Station> stationList = sectioninputdialog.stationList;
			ArrayList<Loop> loopList = SectionInputDialog.loopList;

			/**
			 * //R.Vidyadhar //Endstation code from Endloop Number for(int l =0 ;
			 * l<loopList.size(); l++){ if (loopList.get(l).getBlockNo() == endLoop){
			 * System.out.println("Loop= "+loopList.get(l).getBlockNo() +" endStationCode =
			 * "+ loopList.get(l) .getStation().getStationCode()); endStationCode =
			 * Integer.parseInt(loopList.get(l) .getStation().getStationCode()); } }
			 * 
			 * //R.Vidyadhar //Checking whether each halting station is before Endloop
			 * Station //Else 0 will be returned for (int n=0 ; n<numberOfHalts ; n++){
			 * String station = String.valueOf(stationComboList.get(n).getSelectedItem());
			 * for(int k =0 ; k<stationList.size(); k++){
			 * if(stationList.get(k).getStationName() == station){ int stationCode =
			 * Integer.parseInt(stationList.get(k).getStationCode()); if (stationCode >
			 * endStationCode){ errorLabel.setText("Station " + station + " is located ahead
			 * of EndLoop No."); return; } } } }
			 **/

			// R.Vidyadhar
			// Updating Scheduled halt for freight train
			// Also checking for Multiple entries of same Station
			// If multiple entries are noted, 0 will be returned
			for (int m = 0; m < numberOfHalts; m++) {
				String station = String.valueOf(stationComboList.get(m).getSelectedItem());
				for (int n = m + 1; n < numberOfHalts; n++) {
					if (station == String.valueOf(stationComboList.get(n).getSelectedItem())) {
						errorLabel.setText("Multiple entries for freight halting station  " + station + " is found");
						return 0;
					}
				}
				int haltingMinutes = Integer.parseInt(haltTimeFieldList.get(m).getText());
				// System.out.println("Station " + station + "haltingMinutes =
				// "+ haltingMinutes);
				ReferenceTableEntry freightRefEntry = new ReferenceTableEntry(station, haltingMinutes);
				train.getRefTables().add(freightRefEntry);
			}
			train.setNumberofHalts(numberOfHalts);
			train.startLoopNo = startLoop;
			train.endLoopNo = endLoop;
			UnscheduledTrain uTrain = (UnscheduledTrain) train;
			uTrain.startTimeInput = startTimeInput;
		}
		return 1;
	}

	protected void setFieldsFromTrainAttributes(Train train) {

		for (int i = 0; i < stationFieldList.size(); i++) {
			loopFieldList.get(i).setSelectedItem("Select");
			arrivalTimeFieldList.get(i).setText("");
			departureTimeFieldList.get(i).setText("");
			ErrorExclamationArray.get(i).setText("");
		}

		trainNumberField.setText(String.valueOf(train.trainNo));
		if (train.scheduled)
			passengerTrainRadioButton.setSelected(true);
		else
			freightTrainRadioButton.setSelected(true);
		if (GlobalVar.getDirectionStringFromDirection(train.direction).equalsIgnoreCase("up"))
			upRadioButton.setSelected(true);//Abhishek
		else
			downRadioButton.setSelected(true);//Abhishek
		lengthField.setText(String.valueOf(train.length * 1000));
		accelerationField.setText(String.valueOf(train.accParam));// Abhishek
		decelerationField.setText(String.valueOf(train.deceParam));
		priorityField.setText(String.valueOf(train.priority));
		maximumSpeedField.setText(String.valueOf(train.maximumPossibleSpeed));

		if (train.scheduled) {

			locolist.setSelectedIndex(((int) (train.accParam)));
			// coachnofield.setText(String.valueOf(Math.round(train.length / .015)));

			ScheduledTrain sTrain = (ScheduledTrain) train;
			operationDaysField.setText(sTrain.operatingDays);
			// haltnumberField.setText (String.valueOf(sTrain.numberofhalts));
			setReferenceTableFields(train);
		} else {
			// startLoopField.setText(String.valueOf(train.startLoopNo)); //commented by
			// Abhishek since textfield is changed to JComboBox
			// endLoopField.setText(String.valueOf(train.endLoopNo));
			startLoopField.setSelectedItem(String.valueOf(train.startLoopNo));// Abhishek
			endLoopField.setSelectedItem(String.valueOf(train.endLoopNo));// Abhishek
			UnscheduledTrain uTrain = (UnscheduledTrain) train;
			startTimeField.setText(ChangeTimeTable.getTimeInHHMMformat(uTrain.startTimeInput));
			freighthaltCombo.setSelectedItem(train.getNumberofHalts());
			freighthaltGenerator(train.getNumberofHalts());
			for (int i = 0; i < train.getNumberofHalts(); i++) {
				String station = train.getRefTables().get(i).getStationName();
				String haltTime = String.valueOf(train.getRefTables().get(i).getMinHaltTime());
				stationComboList.get(i).setSelectedItem(station);
				haltTimeFieldList.get(i).setText(haltTime);
			}

		}

	}

	private void setReferenceTableFields(Train train) {
		ReferenceTableEntry referenceTableEntry = null;
		for (int i = 0; i < train.refTables.size(); i++) {
			referenceTableEntry = train.refTables.get(i);
			int loopNo = referenceTableEntry.refLoopNo;
			String refArrivalString = ChangeTimeTable.getTimeInHHMMSSformat(referenceTableEntry.refArrTimeInput);
			String refDepartureString = ChangeTimeTable.getTimeInHHMMSSformat(referenceTableEntry.refDepTimeInput);
			String stationName = referenceTableEntry.getStationName();
			String loopDir = referenceTableEntry.loopDir;
			String loopType = referenceTableEntry.loopType;
			//System.out.println(stationName + "_" + loopDir + "-" + loopType);
			for (int k = 0; k < stationFieldList.size(); k++) {
				String a = stationFieldList.get(k).getText();
				ErrorExclamationArray.get(k).setText("");
				if (a.equals(stationName)) {
					//System.out.println(String.valueOf(loopNo) + "_" + loopDir + "_" + loopType + " "
					//		+ refArrivalString.substring(0, 4) + " " + refDepartureString.substring(0, 4));
					
					int size = loopFieldList.get(k).getItemCount();
					for (int n = 0; n < size; n++) { // Abhishek
					  String[] item = ((String) loopFieldList.get(k).getItemAt(n)).split("_");
					  //System.out.println(item[0]);
					  if(item[0].equalsIgnoreCase(String.valueOf(loopNo))) {
						  loopFieldList.get(k).setSelectedItem(loopFieldList.get(k).getItemAt(n));
					  }
					  //System.out.println("Item at " + n + " = " + item);
					}
					
					//loopFieldList.get(k).setSelectedItem((String.valueOf(loopNo)) + "_" + loopDir + "_" + loopType);
					arrivalTimeFieldList.get(k).setText(refArrivalString.substring(0, 4));
					departureTimeFieldList.get(k).setText(refDepartureString.substring(0, 4));
				}
			}

		}
	}

	ActionListener viewAllScheduledTrainsActionListener = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			AllScheduledTrainsData allScheduledTrainsData = new AllScheduledTrainsData();
		}
	};

	ActionListener viewAllFreightTrainsActionListener = new ActionListener() {

		@Override
		public void actionPerformed(ActionEvent arg0) {
			AllFreightTrainsData allFreightTrainsData = new AllFreightTrainsData();
		}
	};

	public static void main(String[] args) {
		GlobalVar.trainInputDialog = GlobalVar.getTrainInputDialog();
		GlobalVar.trainInputDialog = null;
		System.gc();
	}

	protected void setTimeTableEntryPanelVisible() {
		setTimeTableEntryPanelVisible(freightTrainRadioButton.isSelected());
	}

	ActionListener viewLoopActionListener = new ActionListener() {
		@Override
		public void actionPerformed(ActionEvent arg0) {
			AllLoopData1 allLoopData = new AllLoopData1();

		}
	};

	class AllLoopData1 extends JFrame implements TableModelListener {
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		JTable loopDataTable;

		public AllLoopData1() {

			this.setTitle("List of all loops");

			loopDataTable = new JTable(new AbstractTableModel() {
				SectionInputDialog sectioninputdialog = GlobalVar.getSectionInputDialog();
				ArrayList<Loop> loopList = sectioninputdialog.loopList;

				/**
				 * 
				
				 *
				 */

				private static final long serialVersionUID = 1L;

				String[] columnNames = { "Id", "Direction", "Station Name", "Type", "Type of Trains allowed ",
						"Maximum Speed" };

				@Override
				public String getColumnName(int col) {
					return columnNames[col];
				}

				@Override
				public int getRowCount() {
					return loopList.size();
				}

				@Override
				public int getColumnCount() {
					return columnNames.length;
				}

				@Override
				public Object getValueAt(int row, int col) {
					switch (col) {
					case 0:
						return loopList.get(row).blockNo;
					case 1:
						int direction = loopList.get(row).direction;
						String directionString = GlobalVar.getDirectionStringFromDirection(direction);
						return directionString;
					case 2:
						return loopList.get(row).stationName;
					case 3:
						String loopType = "mainLine";
						if (loopList.get(row).whetherMainLine != 0)
							loopType = "loop";
						return loopType;
					case 4:
						return loopList.get(row).getLoopTrainType();
					case 5:
						return loopList.get(row).maximumPossibleSpeed;
					}

					return null;
				}

			});

			JScrollPane scrollPane = new JScrollPane(loopDataTable);
			loopDataTable.setPreferredScrollableViewportSize(new Dimension(500, 70));
			getContentPane().add(scrollPane);

			setUndecorated(true);
			getRootPane().setWindowDecorationStyle(JRootPane.WARNING_DIALOG);
			try {
				this.setIconImage(ImageIO.read(new File(System.getProperty("user.dir") + "/res/DesktopIcon.png")));
			} catch (IOException exc) {
				// exc.printStackTrace();
			}

			setBounds(70, 70, 900, 400);
			setVisible(true);
		}

		@Override
		public void tableChanged(TableModelEvent arg0) {
		}

	}

	protected void setTimeTableEntryPanelVisible(boolean isFreightTrain) {
		scheduledTrainTimeTableLabel.setVisible(!isFreightTrain);
		stationLabel.setVisible(!isFreightTrain);
		loopLabel.setVisible(!isFreightTrain);
		arrivalTimeLabel.setVisible(!isFreightTrain);
		departureTimeLabel.setVisible(!isFreightTrain);
		noHaltLabel.setVisible(!isFreightTrain);
		for (int i = 0; i < stationList.size(); i++) {
			stationFieldList.get(i).setVisible(!isFreightTrain);
			loopFieldList.get(i).setVisible(!isFreightTrain);
			loopFieldList.get(i).setEnabled(!isFreightTrain);
			arrivalTimeFieldList.get(i).setVisible(!isFreightTrain);
			departureTimeFieldList.get(i).setVisible(!isFreightTrain);
			ErrorExclamationArray.get(i).setVisible(!isFreightTrain);
			// checkHaltFieldList.get(i).setVisible(!isFreightTrain);
		}

		this.repaint();
	}

	public void write(ArrayList<Train> trainList, boolean isScheduled) throws IOException {
		String trainFileName;
		String formatString;
		if (!isScheduled) {
			trainFileName = FileNames.getUnscheduledTrainsFileName();
			formatString = "/*Train-No. Direction Start-Time(HHMM) Length(Km) Acceleration(m/s^2) Deceleration(m/s^2) Priority Maximum-Speed(kmph) Start-Loop End-Loop Number-Of-Halts Station Minutes-of-Halt Station Minutes-of-Halt*/\n\n";
		} else {
			trainFileName = FileNames.getScheduledTrainsFileName();
			formatString = "/*Train-No. Direction Length(Km) Acceleration(m/s^2) Decelaration(m/s^2) Priority Maximum-Speed(kmph) Operation-Days Number-Of-Halts Loop-No. Arrival-Time Departure-Time Loop-No. Arrival-Time Departure-Time Loop-No. Arrival-Time Departure-Time Loop-No. Arrival-Time Departure-Time*/\n\n";
		}

		BufferedWriter bw = new BufferedWriter(new FileWriter(trainFileName));
		bw.write(formatString);

		bw.write("");
		for (Train train : trainList) {
			if (isScheduled)
				writeScheduledTrain(bw, train);
			else
				writeUnscheduledTrain(bw, train);

		}

		bw.close();

	}

	private void writeUnscheduledTrain(BufferedWriter bw, Train train) throws IOException {
		UnscheduledTrain uTrain = (UnscheduledTrain) train;

		bw.write(String.valueOf(train.trainNo));
		bw.write(" ");

		bw.write(GlobalVar.getDirectionStringFromDirection(train.direction));
		bw.write(" ");

		bw.write(ChangeTimeTable.getTimeInHHMMformat(uTrain.startTimeInput));
		bw.write(" ");

		bw.write(String.valueOf(train.length));
		bw.write(" ");

		bw.write(String.valueOf(train.accParam));
		bw.write(" ");

		bw.write(String.valueOf(train.deceParam));
		bw.write(" ");

		bw.write(String.valueOf(train.priority));
		bw.write(" ");

		bw.write(String.valueOf(train.maximumPossibleSpeed));
		bw.write(" ");

		bw.write(String.valueOf(train.startLoopNo));
		bw.write(" ");

		bw.write(String.valueOf(train.endLoopNo));
		bw.write(" ");

		bw.write(String.valueOf(train.getNumberofHalts()));
		bw.write(" ");

		for (int i = 0; i < train.getNumberofHalts(); i++) {
			bw.write(train.getRefTables().get(i).getStationName());
			bw.write(" ");
			bw.write(String.valueOf(train.getRefTables().get(i).getMinHaltTime()));
			bw.write(" ");
		}
		bw.write("\n");

	}

	private void writeScheduledTrain(BufferedWriter bw, Train train) throws IOException {
		ScheduledTrain sTrain = (ScheduledTrain) train;
		bw.write(String.valueOf(train.trainNo));
		bw.write(" ");

		bw.write(GlobalVar.getDirectionStringFromDirection(train.direction));
		bw.write(" ");

		bw.write(String.valueOf(train.length));
		bw.write(" ");

		bw.write(String.valueOf(train.accParam));
		bw.write(" ");

		bw.write(String.valueOf(train.deceParam));
		bw.write(" ");

		bw.write(String.valueOf(train.priority));
		bw.write(" ");

		bw.write(String.valueOf(train.maximumPossibleSpeed));
		bw.write(" ");

		bw.write("\"" + sTrain.operatingDays + "\"");
		bw.write(" ");

		bw.write(String.valueOf(sTrain.numberofhalts));
		bw.write(" ");
		// code added by santhosh on Feb 02,2016 to resolve the down train
		// labelling issue
		String direction = GlobalVar.getDirectionStringFromDirection(train.direction);
		if (direction.equals("up")) {

			for (ReferenceTableEntry referenceTableEntry : train.refTables) {
				bw.write(String.valueOf(referenceTableEntry.refLoopNo));
				bw.write(" ");

				bw.write(ChangeTimeTable.getTimeInHHMMSSformat(referenceTableEntry.refArrTimeInput));
				bw.write(" ");

				bw.write(ChangeTimeTable.getTimeInHHMMSSformat(referenceTableEntry.refDepTimeInput));
				bw.write(" ");
			}
		} else if (direction.equals("down")) {
			Collections.sort(train.refTables);

			for (int k = train.refTables.size() - 1; k >= 0; k--) {
				ReferenceTableEntry referenceTableEntry = train.refTables.get(k);
				bw.write(String.valueOf(referenceTableEntry.refLoopNo));
				bw.write(" ");

				bw.write(ChangeTimeTable.getTimeInHHMMSSformat(referenceTableEntry.refArrTimeInput));
				bw.write(" ");

				bw.write(ChangeTimeTable.getTimeInHHMMSSformat(referenceTableEntry.refDepTimeInput));
				bw.write(" ");
			}
		}

		bw.write("\n");
	}

	public void readScheduledTrains(ArrayList<Train> trainList, int nEntries) throws IOException {
		String trainFileName = FileNames.getScheduledTrainsFileName();
		StreamTokenizer streamTokenizer = new StreamTokenizer(new FileReader(trainFileName));
		streamTokenizer.slashSlashComments(true);
		streamTokenizer.slashStarComments(true);

		while (streamTokenizer.nextToken() != StreamTokenizer.TT_EOF) {
			Train train = new ScheduledTrain();
			train.scheduled = true;

			train.trainNo = (int) streamTokenizer.nval;

			streamTokenizer.nextToken();

			train.direction = GlobalVar.getDirectionFromDirectionString(streamTokenizer.sval);

			streamTokenizer.nextToken();
			train.length = streamTokenizer.nval;

			streamTokenizer.nextToken();
			train.accParam = streamTokenizer.nval;

			streamTokenizer.nextToken();
			train.deceParam = streamTokenizer.nval;

			streamTokenizer.nextToken();
			train.priority = streamTokenizer.nval;

			streamTokenizer.nextToken();
			train.maximumPossibleSpeed = (int) streamTokenizer.nval;

			streamTokenizer.nextToken();
			ScheduledTrain sTrain = (ScheduledTrain) train;
			sTrain.operatingDays = streamTokenizer.sval;

			streamTokenizer.nextToken();
			sTrain.numberofhalts = (int) streamTokenizer.nval;

			// Sneha modified following line to give sTain.numberofhalts as
			// parameters otherwise
			// gives exception
			// sTrain.readReferenceTableEntries(streamTokenizer, nEntries);
			sTrain.readReferenceTableEntries(streamTokenizer, sTrain.numberofhalts);

			trainList.add(train);

		}
		GlobalVar.trainInputDialog = null; // Abhishek
	}

	public void readUnscheduledTrains(ArrayList<Train> trainList) throws IOException {
		String trainFileName = FileNames.getUnscheduledTrainsFileName();
		StreamTokenizer streamTokenizer = new StreamTokenizer(new FileReader(trainFileName));
		streamTokenizer.slashSlashComments(true);
		streamTokenizer.slashStarComments(true);

		while (streamTokenizer.nextToken() != StreamTokenizer.TT_EOF) {
			UnscheduledTrain train = new UnscheduledTrain();
			train.trainNo = (int) streamTokenizer.nval;

			streamTokenizer.nextToken();
			train.direction = GlobalVar.getDirectionFromDirectionString(streamTokenizer.sval);

			streamTokenizer.nextToken();
			train.startTimeInput = (int) streamTokenizer.nval;

			streamTokenizer.nextToken();
			train.length = streamTokenizer.nval;

			streamTokenizer.nextToken();
			train.accParam = streamTokenizer.nval;

			streamTokenizer.nextToken();
			train.deceParam = streamTokenizer.nval;

			streamTokenizer.nextToken();
			train.priority = streamTokenizer.nval;

			streamTokenizer.nextToken();
			train.maximumPossibleSpeed = (int) streamTokenizer.nval;

			streamTokenizer.nextToken();
			train.startLoopNo = (int) streamTokenizer.nval;

			streamTokenizer.nextToken();
			train.endLoopNo = (int) streamTokenizer.nval;

			// System.out.println("endloop " + train.endLoopNo);

			streamTokenizer.nextToken();
			train.numberofhalts = (int) streamTokenizer.nval;

			train.readReferenceTableEntries(streamTokenizer, train.numberofhalts);

			trainList.add(train);
		}
		GlobalVar.trainInputDialog = null; // Abhishek
	}

}

class AllScheduledTrainsData extends JFrame implements TableModelListener {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	JTable scheduledTrainDataTable;

	public AllScheduledTrainsData() {
		super("List of Scheduled Trains");

		scheduledTrainDataTable = new JTable(new AbstractTableModel() {

			/**
			 * 
			 */
			private static final long serialVersionUID = 1L;
			SectionInputDialog sectioninputdialog = GlobalVar.getSectionInputDialog();
			ArrayList<Train> trainList = sectioninputdialog.getTrainList(true);
			ArrayList<Station> stationList = sectioninputdialog.stationList;

			String[] columnNames = { "Train No", "Direction", "Length", "Acceleration", "Deceleration", "Priority",
					"Maximum Speed", "OperationDays", "Number of Halts" };

			@Override
			public String getColumnName(int col) {
				if (col < columnNames.length)
					return columnNames[col];
				else {
					int i = (col - columnNames.length) % 3;
					if (i == 0)
						return "Loop";
					else if (i == 1)
						return "Arrival";
					else
						return "Departure";
				}
			}

			@Override
			public int getRowCount() {
				return trainList.size();
			}

			@Override
			public int getColumnCount() {
				return columnNames.length + 3 * stationList.size();
			}

			@Override
			public Object getValueAt(int row, int col) {
				switch (col) {
				case 0:
					return trainList.get(row).trainNo;
				case 1:{
					int direction = trainList.get(row).direction;
					String directionString = GlobalVar.getDirectionStringFromDirection(direction);
					return directionString;
				}
				case 2:
					return trainList.get(row).length;
				case 3:
					return trainList.get(row).accParam;
				case 4:
					return trainList.get(row).deceParam;
				case 5:
					return trainList.get(row).priority;
				case 6:
					return trainList.get(row).maximumPossibleSpeed;
				case 7:
					return trainList.get(row).operatingDays;
				case 8:
					return trainList.get(row).numberofhalts;

				}

				int numberOfColumn = col - columnNames.length;
				int nReferenceTableEntry = numberOfColumn / 3;
				int nAttribute = numberOfColumn % 3;
				ArrayList<ReferenceTableEntry> referenceTableEntries = trainList.get(row).refTables;
				if (nReferenceTableEntry < referenceTableEntries.size()) {
					ReferenceTableEntry referenceTableEntry = referenceTableEntries.get(nReferenceTableEntry);
					if (nAttribute == 0)
						return referenceTableEntry.refLoopNo;
					else if (nAttribute == 1)
						return ChangeTimeTable.getTimeInHHMMSSformat(referenceTableEntry.refArrTimeInput);
					else
						return ChangeTimeTable.getTimeInHHMMSSformat(referenceTableEntry.refDepTimeInput);
				}

				return null;
			}

		});

		JScrollPane scrollPane = new JScrollPane(scheduledTrainDataTable, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED); // Abhishek
		scheduledTrainDataTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF); // Abhishek
		scheduledTrainDataTable.setPreferredScrollableViewportSize(new Dimension(500, 70));
		getContentPane().add(scrollPane);

		setUndecorated(true);
		getRootPane().setWindowDecorationStyle(JRootPane.WARNING_DIALOG);
		try {
			this.setIconImage(ImageIO.read(new File(System.getProperty("user.dir") + "/res/DesktopIcon.png")));
		} catch (IOException exc) {
			// exc.printStackTrace();
		}

		setBounds(80, 80, 1000, 400);
		setVisible(true);
	}

	@Override
	public void tableChanged(TableModelEvent arg0) {
	}

}

class AllFreightTrainsData extends JFrame implements TableModelListener {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	JTable freightTrainDataTable;

	public AllFreightTrainsData() {
		super("List of Freight Trains");

		freightTrainDataTable = new JTable(new AbstractTableModel() {

			/**
			 * 
			 */
			private static final long serialVersionUID = 1L;
			SectionInputDialog sectioninputdialog = GlobalVar.getSectionInputDialog();
			ArrayList<Train> trainList = sectioninputdialog.getTrainList(false);
			ArrayList<Station> stationList = sectioninputdialog.stationList;

			String[] columnNames = { "Train No", "Direction", "Length", "Acceleration", "Deceleration", "Priority",
					"Maximum Speed", "Start Loop", "End Loop", "Start Time", "No. of Halts" };

			@Override
			public String getColumnName(int col) {
				if (col < columnNames.length)
					return columnNames[col];
				else {
					int i = (col - columnNames.length) % 2;
					if (i == 0)
						return "Station";
					else
						return "Halting Time in Minutes";
				}
			}

			/**
			 * public int getColumnCount() { if (Integer.parseInt(columnNames[11]) == 0)
			 * return columnNames.length; else
			 * 
			 * }
			 **/

			@Override
			public int getRowCount() {
				return trainList.size();
			}

			@Override
			public int getColumnCount() {
				return columnNames.length + 2 * stationList.size();
			}

			@Override
			public Object getValueAt(int row, int col) {
				switch (col) {
				case 0:
					return trainList.get(row).trainNo;
				case 1:{
					int direction = trainList.get(row).direction;
					String directionString = GlobalVar.getDirectionStringFromDirection(direction);
					return directionString;
				}
				case 2:
					return trainList.get(row).length;
				case 3:
					return trainList.get(row).accParam;
				case 4:
					return trainList.get(row).deceParam;
				case 5:
					return trainList.get(row).priority;
				case 6:
					return trainList.get(row).maximumPossibleSpeed;
				case 7:
					return trainList.get(row).startLoopNo;
				case 8:
					return trainList.get(row).endLoopNo;
				case 9:
					return trainList.get(row).startTimeInput;
				case 10:
					return trainList.get(row).getNumberofHalts();
				}

				int numberOfColumn = col - columnNames.length;
				int nReferenceTableEntry = numberOfColumn / 2;
				int nAttribute = numberOfColumn % 2;
				ArrayList<ReferenceTableEntry> referenceTableEntries = trainList.get(row).refTables;
				if (nReferenceTableEntry < referenceTableEntries.size()) {
					ReferenceTableEntry referenceTableEntry = referenceTableEntries.get(nReferenceTableEntry);
					if (nAttribute == 0)
						return referenceTableEntry.getStationName();
					else if (nAttribute == 1)
						return referenceTableEntry.getMinHaltTime();
				}
				return null;
			}

		});

		JScrollPane scrollPane = new JScrollPane(freightTrainDataTable, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED); // Abhishek
		freightTrainDataTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF); // Abhishek
		freightTrainDataTable.setPreferredScrollableViewportSize(new Dimension(500, 70));
		getContentPane().add(scrollPane);

		setUndecorated(true);
		getRootPane().setWindowDecorationStyle(JRootPane.WARNING_DIALOG);
		try {
			this.setIconImage(ImageIO.read(new File(System.getProperty("user.dir") + "/res/DesktopIcon.png")));
		} catch (IOException exc) {
			// exc.printStackTrace();
		}

		setBounds(80, 80, 1000, 400);
		setVisible(true);
	}

	@Override
	public void tableChanged(TableModelEvent arg0) {
	}

}
