package simulator.outputFeatures;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Desktop;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.StreamTokenizer;
import java.net.URI;
import java.net.URISyntaxException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;

import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JRootPane;
import javax.swing.SwingConstants;

import globalVariables.FileNames;
import globalVariables.GlobalVar;
import globalVariables.GlobalVariables;
import gui.entities.sectionEntities.trackEntities.Loop;
import input.BlockInput;
import input.FreightTrainInputDialog;
import input.SectionInputDialog;
import simulator.input.SimulationInstance;
import simulator.scheduler.SimulationStart;
import simulator.ui.StartUpScreen;
import simulator.util.Debug;

/**
 * 
 */
@SuppressWarnings("serial")
public class MainInterface extends JFrame {
	/**
	 * mainMenuBar
	 */
	JMenuBar mainMenuBar = new JMenuBar();
	/**
	 * jMenu1
	 */
	JMenu jMenu1 = new JMenu();
	/**
	 * jMnItSelect
	 */
	JMenuItem jMnItGUI = new JMenuItem("Add/Edit Infrastructure/Train");

	JMenuItem jMnItSelect = new JMenuItem();
	/**
	 * jMnItRun
	 */
	JMenuItem jMnItRun = new JMenuItem();
	// santhosh
	JMenuItem jMnItCapacity = new JMenuItem();
	JMenuItem jMnItRawCapacity = new JMenuItem();
	/**
	 * jMnItExit
	 */
	JMenuItem jMnItExit = new JMenuItem();
	/**
	 * jMenu2
	 */
	// JMenu jMenu2 = new JMenu();
	/**
	 * jMnRunTime
	 */
	JMenuItem jMnRunTime = new JMenuItem();
	/**
	 * borderLayout1
	 */
	BorderLayout borderLayout1 = new BorderLayout();
	/**
	 * jMenu3
	 */
	JMenu jMenu3 = new JMenu();
	/**
	 * jChkMnuDebug
	 */
	JCheckBoxMenuItem jChkMnuDebug = new JCheckBoxMenuItem();

	JMenuItem jMenuCompare = new JMenuItem();

	JMenuItem jMenuCompareNew = new JMenuItem();

	JButton visual = new JButton();

	/**
	* 
	*/
	public MainInterface() {
		try {
			jbInit();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * @throws URISyntaxException
	 */
	private void jbInit() throws URISyntaxException {
		this.getContentPane().setLayout(borderLayout1);
		ImageIcon img = new ImageIcon("C:\\Users\\Soumya\\Desktop\\images.jpg");
		this.setIconImage(img.getImage());
		JLabel background = new JLabel(new ImageIcon("C:\\Users\\Soumya\\Desktop\\logo.png"));
		add(background);// adding images by Soumya
		jMenu1.setText("Simulator");

		try {
			this.setIconImage(ImageIO.read(new File(System.getProperty("user.dir") + "/res/DesktopIcon.png")));
		} catch (IOException exc) {
			// exc.printStackTrace();
		}

		JLabel lbl1 = new JLabel("Cost Optimization and Simulation Tool (COST)");
		lbl1.setFont(lbl1.getFont().deriveFont(20f));
		JPanel jpanel = new JPanel();
		JLabel ic = new JLabel(new ImageIcon(System.getProperty("user.dir") + "/res/iitbLogo.png"));
		jpanel.setLayout(null);
		JLabel lbl2 = new JLabel("Developed at IIT Bombay");
		lbl2.setFont(lbl2.getFont().deriveFont(18f));
		JLabel lbl7 = new JLabel("Tool development sponsored by RDSO, Lucknow");
		lbl7.setFont(lbl7.getFont().deriveFont(18f));
		JLabel lbl3 = new JLabel("Jar file version: February 2019");
		JLabel S1 = new JLabel(
				"The latest version of this jar-file and a user-manual, together with a detailed code-documentation,");
		JLabel lbl62 = new JLabel("Feedback and suggestions are welcome.");
		JLabel lbl4 = new JLabel("Contributors - Faculty, students and project staff at IIT Bombay");
		JLabel lbl5 = new JLabel(
				"Earlier support from Indian Railways (IRISET, Secunderabad, other agencies and their technical teams),");
		JLabel contact = new JLabel("Contact person:");
		JLabel name = new JLabel("Prof. Narayan Rangaraj,");
		JLabel dept = new JLabel("Industrial Engineering and Operations Research,");
		JLabel insti = new JLabel("IIT Bombay, Powai, Mumbai");
		String str = "ww";
		JLabel ackcont = new JLabel("is at:");

		final URI uri = new URI("https://www.ee.iitb.ac.in/%7Ebelur/railways/RDSO");

		class OpenUrlAction implements ActionListener {
			@Override
			public void actionPerformed(ActionEvent e) {
				open(uri);
			}
		}

		String mailto = "mailto:narayan.rangaraj@iitb.ac.in?subject=Simulator%20Query.";

		String cmd = "";
		String os = System.getProperty("os.name").toLowerCase();

		if (os.contains("win")) {
			cmd = "cmd.exe /c start " + mailto;
		} else if (os.contains("osx")) {
			cmd = "open " + mailto;
		} else if (os.contains("nix") || os.contains("aix") || os.contains("nux")) {
			cmd = "xdg-open " + mailto;
		}

		final String id = cmd;
		class MailUrlAction implements ActionListener {
			@Override
			public void actionPerformed(ActionEvent e) {
				try {
					email(id);
				} catch (Exception e1) {
					e1.printStackTrace();
					System.out.println("desktop doesn't support mailto; mail is dead anyway ;)");
				}
			}
		}

		JButton lbl61 = new JButton();
		lbl61.setText("<html><a href=\" " + str + "\"> www.ee.iitb.ac.in/~belur/railways/RDSO</a></html>");
		lbl61.setHorizontalAlignment(SwingConstants.LEFT);
		lbl61.setBorderPainted(false);
		lbl61.setOpaque(false);
		lbl61.setBackground(Color.WHITE);
		lbl61.setToolTipText(uri.toString());
		lbl61.addActionListener(new OpenUrlAction());
		JButton link = new JButton();
		link.setText("<html><a href=\" " + str + "\"> narayan.rangaraj@iitb.ac.in </a></html>");
		link.setHorizontalAlignment(SwingConstants.LEFT);
		link.setBorderPainted(false);
		link.setOpaque(false);
		link.setBackground(Color.WHITE);
		link.setToolTipText("narayan.rangaraj@iitb.ac.in");
		link.addActionListener(new MailUrlAction());
		JLabel email = new JLabel("Email:");
		// JLabel present=new JLabel("For current version of the tool, for
		// demonstration and trial, please see");
		JLabel lbl6 = new JLabel("and of ITSPE, Hyderabad to the software is acknowledged.");
		this.add(jpanel);
		jpanel.add(lbl1);
		jpanel.add(ic);
		jpanel.add(lbl2);
		jpanel.add(lbl3);
		jpanel.add(lbl7);
		jpanel.add(lbl4);
		jpanel.add(lbl5);
		jpanel.add(lbl6);
		jpanel.add(S1);
		jpanel.add(lbl61);
		jpanel.add(lbl62);
		jpanel.add(ackcont);
		jpanel.add(contact);
		jpanel.add(name);
		jpanel.add(dept);
		jpanel.add(insti);
		jpanel.add(email);
		jpanel.add(jChkMnuDebug);
		jpanel.add(visual);
		// this.add(present);
		jpanel.add(link);
		lbl1.setLocation(120, 200);
		ic.setLocation(235, 5);
		lbl2.setLocation(230, 230);
		lbl7.setLocation(125, 260);
		lbl3.setLocation(10, 400);
		lbl4.setLocation(10, 425);
		lbl5.setLocation(10, 450);
		lbl6.setLocation(10, 475);
		S1.setLocation(10, 490);
		lbl61.setLocation(95, 515);
		lbl62.setLocation(10, 630);
		contact.setLocation(10, 535);
		ackcont.setLocation(10, 515);

		name.setLocation(20, 560);
		dept.setLocation(20, 575);
		insti.setLocation(20, 590);
		email.setLocation(20, 605);// present.setLocation(0,590);
		link.setLocation(45, 605);
		lbl1.setSize(800, 30);
		ic.setSize(200, 200); // image dimension should be less than 200x200 -Abhishek
		lbl2.setSize(800, 30);
		lbl7.setSize(800, 30);
		lbl3.setSize(800, 30);
		lbl4.setSize(800, 30);
		ackcont.setSize(800, 30);
		lbl5.setSize(2000, 30);
		lbl6.setSize(2000, 30);
		S1.setSize(2000, 40);
		lbl61.setSize(300, 30);
		lbl62.setSize(2000, 30);
		link.setSize(200, 30);
		contact.setSize(800, 30);// present.setSize(800,30);
		dept.setSize(800, 30);
		name.setSize(800, 30);
		insti.setSize(800, 30);
		email.setSize(800, 30);
		jChkMnuDebug.setBounds(550, 20, 80, 20);
		visual.setBounds(550, 60, 110, 25);
		// JLabel background=new JLabel(new
		// ImageIcon("C:\\Users\\Soumya\\Desktop\\logo.png"));
		// add(background)f;//adding images by Soumya
		jMnItGUI.addActionListener(new java.awt.event.ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				inputMenuItem_actionPerformed(e);
			}

			private void inputMenuItem_actionPerformed(ActionEvent e) {
				SectionInputDialog sectioninputdialog = GlobalVar.getSectionInputDialog();
				sectioninputdialog.setVisible(true);

			}
		});

		jMnItSelect.setText("Select Infrastructure/Train");
		jMnItSelect.addActionListener(new java.awt.event.ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				jMnItSelect_actionPerformed(e);
			}
		});
		jMnItRun.setText("Simulate");
		jMnItRun.addActionListener(new java.awt.event.ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				new Debug(true);
				runMenuActionPerformed(e);
			}
		});
		// santhosh - capacity added
/*		jMnItCapacity.setText("Calculate Mixed Capacity");
		jMnItCapacity.addActionListener(new java.awt.event.ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				new Debug(false);
				capacityMenuActionPerformed(e);
			}
		}); */

		jMnItRawCapacity.setText("Calculate Raw Capacity");
		jMnItRawCapacity.addActionListener(new java.awt.event.ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				new Debug(false);
				rawCapacityMenuActionPerformed(e);
			}
		});
		jMnItExit.setText("Exit");
		jMnItExit.addActionListener(new java.awt.event.ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				System.exit(0);
			}
		});
		this.addWindowListener(new java.awt.event.WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				this_windowClosing(e);
			}
		});
		this.setJMenuBar(mainMenuBar);
		this.setTitle("Mixed Rail Traffic Simulator Tool");
		// jMenu2.setText("Report");
		jMnRunTime.setText("Running Time");
		jMnRunTime.addActionListener(new java.awt.event.ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				jMnRunTime_actionPerformed(e);
			}
		});
		jMenu3.setText("Comparator");
		jChkMnuDebug.setText("Debug");
		jChkMnuDebug.addActionListener(new java.awt.event.ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				jChkMnuDebug_actionPerformed(e);
			}
		});
		jChkMnuDebug.setToolTipText("Generate debug.txt file (Simulation of trains takes more time)"); // Abhishek
		jMenuCompare.setText("Freight Comparison");// Abhishek
		jMenuCompare.addActionListener(new java.awt.event.ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				comparator.FreightComparison.CompareActionPerformed();
			}
		});
		visual.setText("Visualization"); // Abhishek
		visual.addActionListener(new java.awt.event.ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				try {
					visualization.visualization.main();
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}
		});

		jMenuCompareNew.setText("Advanced Comparison");// Abhishek
		jMenuCompareNew.addActionListener(new java.awt.event.ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				comparator.Comparator.main();
			}
		});

		mainMenuBar.add(jMenu1);
		// mainMenuBar.add(jMenu2);
		mainMenuBar.add(jMenu3);
		jMenu3.add(jMenuCompare);
		jMenu3.add(jMenuCompareNew);

		jMenu1.add(jMnItGUI);
		jMenu1.add(jMnItSelect);
		jMenu1.add(jMnItRun);
		jMenu1.add(jMnItCapacity);
		jMenu1.add(jMnItRawCapacity);
		jMenu1.addSeparator();
		jMenu1.add(jMnItExit);
		// jMenu2.add(jMnRunTime);
		// jMenu3.add(jChkMnuDebug);
	}

	private static void email(String id) throws Exception {
		Runtime.getRuntime().exec(id);
	}

	private static void open(URI uri) {
		if (Desktop.isDesktopSupported()) {
			try {
				Desktop.getDesktop().browse(uri);
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	/**
	 * @param e
	 */

	void runMenuActionPerformed(ActionEvent e) {
		System.out.println("Boom");
		GlobalVar.capacitySelected = false;
		GlobalVar.rawCapacitySelected = false;
		SimulationStart simulationStart = new SimulationStart();
		System.out.println("sneha Simulation start called");
		simulationStart.start();
		System.out.println("sneha Simulation start returned");
	}

	public static void readLoops() throws IOException {
		String loopFileName = FileNames.getLoopFileName();
		StreamTokenizer streamTokenizer = new StreamTokenizer(new FileReader(loopFileName));
		streamTokenizer.slashSlashComments(true);
		streamTokenizer.slashStarComments(true);

		while (streamTokenizer.nextToken() != StreamTokenizer.TT_EOF) {
			Loop loop = new Loop();
			int blockId = (int) streamTokenizer.nval;
			Loop.AllLoops.add(blockId);

			streamTokenizer.nextToken();
			streamTokenizer.nextToken();
			streamTokenizer.nextToken();
			streamTokenizer.nextToken();
			loop.readCommonBlockLoopProperties(streamTokenizer);
		}
		Loop.AllLoops.sort(null);
	}
	
	// santhosh
	void capacityMenuActionPerformed(ActionEvent e) {
		GlobalVar.rawCapacitySelected = false;
		GlobalVar.capacitySelected = true;
		FreightTrainInputDialog freightTrainInputDialog = new FreightTrainInputDialog();
		freightTrainInputDialog.setVisible(true);
	}

	void rawCapacityMenuActionPerformed(ActionEvent e) {
		GlobalVar.capacitySelected = false;
		GlobalVar.rawCapacitySelected = true;
		FreightTrainInputDialog freightTrainInputDialog = new FreightTrainInputDialog();

		freightTrainInputDialog.setVisible(true);
	}

	/**
	 * @param args
	 */
	public static void main(String args[]) {

		// Debug debug = new Debug();
		System.out.println(System.getProperty("user.dir"));
		
		Path currentRelativePath = Paths.get("");
		String s = currentRelativePath.toAbsolutePath().toString();
		System.out.println("Current relative path is: " + s);
		try {
			if(args[0].equals("true"))
			{
				GlobalVariables.flagToShowAutomaticMode=true;
				
				AutomaticMode.automaticMode();
				System.exit(0);
			}
		}catch(ArrayIndexOutOfBoundsException e) {
		}
		StartUpScreen startUp = new StartUpScreen();
		startUp.setVisible(true);
		startUp.setBounds(10, 10, 200, 200);

		MainInterface mi = new MainInterface();
		mi.setBounds(10, 10, 700, 720);
		mi.setVisible(true);
		startUp.dispose();
	}

	/**
	 * @param e
	 */
	void this_windowClosing(WindowEvent e) {
		System.exit(0);
	}

	/**
	 * @param e
	 */
	void jMnItSelect_actionPerformed(ActionEvent e) {
		Debug.print("Selecte selected");
		// santhosh
		SimulationInstance simulationInstance = new SimulationInstance();
		GlobalVar.simulationInstance = simulationInstance;
		SelectFiles selectFiles = new SelectFiles(simulationInstance);
		// santhosh
		// SelectFiles selectFiles = new
		// SelectFiles(null);//SelectFiles.getInterface();
		selectFiles.setBounds(20, 20, 500, 700);
		selectFiles.setVisible(true);
	}

	/**
	 * @param e
	 */
	@SuppressWarnings({ "unused" })
	void jMnRunTime_actionPerformed(ActionEvent e) {
		TrainRunTime trnFrame = new TrainRunTime();
	}

	/**
	 * @param e
	 */
	void jChkMnuDebug_actionPerformed(ActionEvent e) {
		if (jChkMnuDebug.getState() == true) {
			Debug.debug = true;
		} else {
			Debug.debug = false;
		}
	}
}
